package hu.bme.mit.train.cc.nativ;

import java.util.Collection;

import hu.bme.mit.train.cc.eoclCG.TestCasePosLength_EoclCG;
import hu.bme.mit.train.cc.eoclCG.TestCaseRouteSensor_EoclCG;
import hu.bme.mit.train.cc.eoclCG.TestCaseSignalNeighbor_EoclCG;
import hu.bme.mit.train.cc.eoclCG.TestCaseSwitchSensor_EoclCG;
import hu.bme.mit.train.cc.eoclCG.TestCaseSwitchSet_EoclCG;
import hu.bme.mit.train.cc.eoclCGAI.TestCaseRouteSensor_EoclCGAI;
import hu.bme.mit.train.cc.eoclCGAI.TestCaseSwitchSet_EoclCGAI;
import hu.bme.mit.train.scenarios.TestFactory;
import hu.bme.mit.train.util.CcBenchmark;

public class EoclCGTestFactory implements TestFactory {

	@Override
	public CcBenchmark getPosLength() {
		return new TestCasePosLength_EoclCG();
	}

	@Override
	public CcBenchmark getRouteSensor() {
		return new TestCaseRouteSensor_EoclCG();
	}

	@Override
	public CcBenchmark getSwitchSensor() {
		return new TestCaseSwitchSensor_EoclCG();
	}

	@Override
	public CcBenchmark getSwitchSet() {
		return new TestCaseSwitchSet_EoclCG();
	}

	@Override
	public CcBenchmark getSignalNeighbor() {
		return new TestCaseSignalNeighbor_EoclCG();
	}

	@Override
	public CcBenchmark getRouteSensorAI() {
		return new TestCaseRouteSensor_EoclCGAI();
	}

	@Override
	public CcBenchmark getSwitchSetAI() {
		return new TestCaseSwitchSet_EoclCGAI();
	}

	@Override
	public Collection<Object[]> getPosLengthModelsizes() {
		return TestCasePosLength_EoclCG.data();
	}

	@Override
	public Collection<Object[]> getRouteSensorModelsizes() {
		return TestCaseRouteSensor_EoclCG.data();
	}

	@Override
	public Collection<Object[]> getSwitchSensorModelsizes() {
		return TestCaseSwitchSensor_EoclCG.data();
	}

	@Override
	public Collection<Object[]> getSwitchSetModelsizes() {
		return TestCaseSwitchSet_EoclCG.data();
	}

	@Override
	public Collection<Object[]> getSignalNeighborModelsizes() {
		return TestCaseSignalNeighbor_EoclCG.data();
	}

	@Override
	public Collection<Object[]> getRouteSensorAIModelsizes() {
		return TestCaseRouteSensor_EoclCGAI.data();
	}

	@Override
	public Collection<Object[]> getSwitchSetAIModelsizes() {
		return TestCaseSwitchSet_EoclCGAI.data();
	}

}
