package hu.bme.mit.train.cc.nativ;

import java.util.Collection;

import hu.bme.mit.train.cc.eoclPivot.TestCasePosLength_EoclPivot;
import hu.bme.mit.train.cc.eoclPivot.TestCaseRouteSensor_EoclPivot;
import hu.bme.mit.train.cc.eoclPivot.TestCaseSignalNeighbor_EoclPivot;
import hu.bme.mit.train.cc.eoclPivot.TestCaseSwitchSensor_EoclPivot;
import hu.bme.mit.train.cc.eoclPivot.TestCaseSwitchSet_EoclPivot;
import hu.bme.mit.train.cc.eoclPivotAI.TestCaseRouteSensor_EoclPivotAI;
import hu.bme.mit.train.cc.eoclPivotAI.TestCaseSwitchSet_EoclPivotAI;
import hu.bme.mit.train.scenarios.TestFactory;
import hu.bme.mit.train.util.CcBenchmark;

public class EoclPivotTestFactory implements TestFactory {

	@Override
	public CcBenchmark getPosLength() {
		return new TestCasePosLength_EoclPivot();
	}

	@Override
	public CcBenchmark getRouteSensor() {
		return new TestCaseRouteSensor_EoclPivot();
	}

	@Override
	public CcBenchmark getSwitchSensor() {
		return new TestCaseSwitchSensor_EoclPivot();
	}

	@Override
	public CcBenchmark getSwitchSet() {
		return new TestCaseSwitchSet_EoclPivot();
	}

	@Override
	public CcBenchmark getSignalNeighbor() {
		return new TestCaseSignalNeighbor_EoclPivot();
	}

	@Override
	public CcBenchmark getRouteSensorAI() {
		return new TestCaseRouteSensor_EoclPivotAI();
	}

	@Override
	public CcBenchmark getSwitchSetAI() {
		return new TestCaseSwitchSet_EoclPivotAI();
	}

	@Override
	public Collection<Object[]> getPosLengthModelsizes() {
		return TestCasePosLength_EoclPivot.data();
	}

	@Override
	public Collection<Object[]> getRouteSensorModelsizes() {
		return TestCaseRouteSensor_EoclPivot.data();
	}

	@Override
	public Collection<Object[]> getSwitchSensorModelsizes() {
		return TestCaseSwitchSensor_EoclPivot.data();
	}

	@Override
	public Collection<Object[]> getSwitchSetModelsizes() {
		return TestCaseSwitchSet_EoclPivot.data();
	}

	@Override
	public Collection<Object[]> getSignalNeighborModelsizes() {
		return TestCaseSignalNeighbor_EoclPivot.data();
	}

	@Override
	public Collection<Object[]> getRouteSensorAIModelsizes() {
		return TestCaseRouteSensor_EoclPivotAI.data();
	}

	@Override
	public Collection<Object[]> getSwitchSetAIModelsizes() {
		return TestCaseSwitchSet_EoclPivotAI.data();
	}

}
