package hu.bme.mit.train.cc.nativ;

import java.util.Collection;

import hu.bme.mit.train.cc.oclImpact.TestCasePosLength_Eoclia;
import hu.bme.mit.train.cc.oclImpact.TestCaseRouteSensor_Eoclia;
import hu.bme.mit.train.cc.oclImpact.TestCaseSignalNeighbor_Eoclia;
import hu.bme.mit.train.cc.oclImpact.TestCaseSwitchSensor_Eoclia;
import hu.bme.mit.train.cc.oclImpact.TestCaseSwitchSet_Eoclia;
import hu.bme.mit.train.cc.oclImpactAI.TestCaseRouteSensor_EocliaAI;
import hu.bme.mit.train.cc.oclImpactAI.TestCaseSwitchSet_EocliaAI;
import hu.bme.mit.train.scenarios.TestFactory;
import hu.bme.mit.train.util.CcBenchmark;

public class OCLImpTestFactory implements TestFactory {

	@Override
	public CcBenchmark getPosLength() {
		return new TestCasePosLength_Eoclia();
	}

	@Override
	public CcBenchmark getRouteSensor() {
		return new TestCaseRouteSensor_Eoclia();
	}

	@Override
	public CcBenchmark getSwitchSensor() {
		return new TestCaseSwitchSensor_Eoclia();
	}

	@Override
	public CcBenchmark getSwitchSet() {
		return new TestCaseSwitchSet_Eoclia();
	}

	@Override
	public CcBenchmark getSignalNeighbor() {
		return new TestCaseSignalNeighbor_Eoclia();
	}

	@Override
	public CcBenchmark getRouteSensorAI() {
		return new TestCaseRouteSensor_EocliaAI();
	}

	@Override
	public CcBenchmark getSwitchSetAI() {
		return new TestCaseSwitchSet_EocliaAI();
	}

	@Override
	public Collection<Object[]> getPosLengthModelsizes() {
		return TestCasePosLength_Eoclia.data();
	}

	@Override
	public Collection<Object[]> getRouteSensorModelsizes() {
		return TestCaseRouteSensor_Eoclia.data();
	}

	@Override
	public Collection<Object[]> getSwitchSensorModelsizes() {
		return TestCaseSwitchSensor_Eoclia.data();
	}

	@Override
	public Collection<Object[]> getSwitchSetModelsizes() {
		return TestCaseSwitchSet_Eoclia.data();
	}

	@Override
	public Collection<Object[]> getSignalNeighborModelsizes() {
		return TestCaseSignalNeighbor_Eoclia.data();
	}

	@Override
	public Collection<Object[]> getRouteSensorAIModelsizes() {
		return TestCaseRouteSensor_EocliaAI.data();
	}

	@Override
	public Collection<Object[]> getSwitchSetAIModelsizes() {
		return TestCaseSwitchSet_EocliaAI.data();
	}

}
