package hu.bme.mit.train.constrintcheck.eoclia;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.impl.AdapterImpl;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.ocl.ecore.OCL;
import org.eclipse.ocl.ecore.OCLExpression;
import org.eclipse.ocl.examples.impactanalyzer.ImpactAnalyzer;

public class ResultAdapter<T> extends AdapterImpl {
	
	private ImpactAnalyzer impactAnalyzer;
	private OCL ocl;
	private OCLExpression query;
	// incrementally modified result set
	private Set<T> invalids;
	
	public ResultAdapter(ImpactAnalyzer impactAnalyzer, OCL ocl, OCLExpression query, Collection<T> init) {
		this.impactAnalyzer = impactAnalyzer;
		this.ocl = ocl;
		this.query = query;
		invalids = new HashSet<T>(init);
	}
	
	@SuppressWarnings("unchecked")
	public void notifyChanged(Notification notification) {
		Collection<EObject> valueMayHaveChangedOn = impactAnalyzer.getContextObjects(notification);
		for (EObject eo : valueMayHaveChangedOn) {
			Object result = ocl.evaluate(eo, query);
			if (result == Boolean.TRUE) {
				invalids.add((T) eo);
			} else {
				invalids.remove((T) eo);
			}
		}
	}
	
	public Set<T> getInvalids() {
		return invalids;
	}
}
