package hu.bme.mit.train.constraintcheck.incquery;

import hu.bme.mit.train.constraintcheck.incquery.AseMatcher;
import hu.bme.mit.train.constraintcheck.incquery.Ase_oldMatcher;
import hu.bme.mit.train.constraintcheck.incquery.util.AseQuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_oldQuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedPatternGroup;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * A pattern group formed of all patterns defined in ase.eiq.
 * 
 * <p>Use the static instance as any {@link org.eclipse.incquery.runtime.api.IPatternGroup}, to conveniently prepare
 * an EMF-IncQuery engine for matching all patterns originally defined in file ase.eiq,
 * in order to achieve better performance than one-by-one on-demand matcher initialization.
 * 
 * <p> From package hu.bme.mit.train.constraintcheck.incquery, the group contains the definition of the following patterns: <ul>
 * <li>ase</li>
 * <li>ase_old</li>
 * </ul>
 * 
 * @see IPatternGroup
 * 
 */
@SuppressWarnings("all")
public final class Ase extends BaseGeneratedPatternGroup {
  /**
   * Access the pattern group.
   * 
   * @return the singleton instance of the group
   * @throws IncQueryException if there was an error loading the generated code of pattern specifications
   * 
   */
  public static Ase instance() throws IncQueryException {
    if (INSTANCE == null) {
    	INSTANCE = new Ase();
    }
    return INSTANCE;
    
  }
  
  private static Ase INSTANCE;
  
  private Ase() throws IncQueryException {
    querySpecifications.add(AseQuerySpecification.instance());
    querySpecifications.add(Ase_oldQuerySpecification.instance());
    
  }
  
  public AseQuerySpecification getAse() throws IncQueryException {
    return AseQuerySpecification.instance();
  }
  
  public AseMatcher getAse(final IncQueryEngine engine) throws IncQueryException {
    return AseMatcher.on(engine);
  }
  
  public Ase_oldQuerySpecification getAse_old() throws IncQueryException {
    return Ase_oldQuerySpecification.instance();
  }
  
  public Ase_oldMatcher getAse_old(final IncQueryEngine engine) throws IncQueryException {
    return Ase_oldMatcher.on(engine);
  }
}
