package hu.bme.mit.train.constraintcheck.incquery;

import Concept.Route;
import hu.bme.mit.train.constraintcheck.incquery.AseMatch;
import hu.bme.mit.train.constraintcheck.incquery.util.AseQuerySpecification;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.incquery.runtime.api.IMatchProcessor;
import org.eclipse.incquery.runtime.api.IQuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseMatcher;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.matchers.tuple.Tuple;
import org.eclipse.incquery.runtime.rete.misc.DeltaMonitor;

/**
 * Generated pattern matcher API of the hu.bme.mit.train.constraintcheck.incquery.ase pattern,
 * providing pattern-specific query methods.
 * 
 * <p>Use the pattern matcher on a given model via {@link #on(IncQueryEngine)},
 * e.g. in conjunction with {@link IncQueryEngine#on(Notifier)}.
 * 
 * <p>Matches of the pattern will be represented as {@link AseMatch}.
 * 
 * <p>Original source:
 * <code><pre>
 * pattern ase(R1) {
 * 	Signal(SigA);
 * 	Signal(SigB);
 * 	Route(R1);
 * 	Route(R2);
 * 	Route(R3);
 * 	
 * 	Route.Route_exit(R1, SigA);
 * 	//Route.Route_entry(R2, SigA);
 * 	Route.Route_exit(R2, SigB);
 * 	//Route.Route_entry(R3, SigB);
 * 
 * 	Sensor(Sen1);
 * 	Sensor(Sen2);
 * 	Sensor(Sen3);
 * 	
 * 	Route.Route_routeDefinition(R1, Sen1);
 * 	Route.Route_routeDefinition(R2, Sen2);
 * 	Route.Route_routeDefinition(R3, Sen3);
 * 	
 * 	Trackelement(Te1);
 * 	Trackelement(Te2a);
 * 	Trackelement(Te2b);
 * 	Trackelement(Te3);
 * 
 * 	Sensor.Sensor_trackElement(Sen1, Te1);
 * 	Sensor.Sensor_trackElement(Sen2, Te2a);
 * 	Sensor.Sensor_trackElement(Sen2, Te2b);
 * 	Sensor.Sensor_trackElement(Sen3, Te3);
 * 
 * 	Trackelement.TrackElement_connectsTo(Te1, Te2a);
 * 	Trackelement.TrackElement_connectsTo(Te2b, Te3);
 * 	
 * 	R1!=R2;
 * 	R2!=R3;
 * 	R3!=R1;
 * 	
 * 	neg find entrySignal1(R2,SigA);
 * 	neg find entrySignal1(R3,SigB);
 * 	
 * 	//neg find entrySignalSensor1(SigA, R2, Sen2);
 * }
 * </pre></code>
 * 
 * @see AseMatch
 * @see AseProcessor
 * @see AseQuerySpecification
 * 
 */
@SuppressWarnings("all")
public class AseMatcher extends BaseMatcher<AseMatch> {
  /**
   * @return the singleton instance of the query specification of this pattern
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static IQuerySpecification<AseMatcher> querySpecification() throws IncQueryException {
    return AseQuerySpecification.instance();
  }
  
  /**
   * Initializes the pattern matcher within an existing EMF-IncQuery engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing EMF-IncQuery engine in which this matcher will be created.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * 
   */
  public static AseMatcher on(final IncQueryEngine engine) throws IncQueryException {
    // check if matcher already exists
    AseMatcher matcher = engine.getExistingMatcher(querySpecification());
    if (matcher == null) {
    	matcher = new AseMatcher(engine);
    	// do not have to "put" it into engine.matchers, reportMatcherInitialized() will take care of it
    }
    return matcher;
  }
  
  private final static int POSITION_R1 = 0;
  
  /**
   * Initializes the pattern matcher over a given EMF model root (recommended: Resource or ResourceSet).
   * If a pattern matcher is already constructed with the same root, only a light-weight reference is returned.
   * The scope of pattern matching will be the given EMF model root and below (see FAQ for more precise definition).
   * The match set will be incrementally refreshed upon updates from this scope.
   * <p>The matcher will be created within the managed {@link IncQueryEngine} belonging to the EMF model root, so
   * multiple matchers will reuse the same engine and benefit from increased performance and reduced memory footprint.
   * @param emfRoot the root of the EMF containment hierarchy where the pattern matcher will operate. Recommended: Resource or ResourceSet.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * @deprecated use {@link #on(IncQueryEngine)} instead, e.g. in conjunction with {@link IncQueryEngine#on(Notifier)}
   * 
   */
  @Deprecated
  public AseMatcher(final Notifier emfRoot) throws IncQueryException {
    this(IncQueryEngine.on(emfRoot));
  }
  
  /**
   * Initializes the pattern matcher within an existing EMF-IncQuery engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing EMF-IncQuery engine in which this matcher will be created.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * @deprecated use {@link #on(IncQueryEngine)} instead
   * 
   */
  @Deprecated
  public AseMatcher(final IncQueryEngine engine) throws IncQueryException {
    super(engine, querySpecification());
  }
  
  /**
   * Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pR1 the fixed value of pattern parameter R1, or null if not bound.
   * @return matches represented as a AseMatch object.
   * 
   */
  public Collection<AseMatch> getAllMatches(final Route pR1) {
    return rawGetAllMatches(new Object[]{pR1});
  }
  
  /**
   * Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pR1 the fixed value of pattern parameter R1, or null if not bound.
   * @return a match represented as a AseMatch object, or null if no match is found.
   * 
   */
  public AseMatch getOneArbitraryMatch(final Route pR1) {
    return rawGetOneArbitraryMatch(new Object[]{pR1});
  }
  
  /**
   * Indicates whether the given combination of specified pattern parameters constitute a valid pattern match,
   * under any possible substitution of the unspecified parameters (if any).
   * @param pR1 the fixed value of pattern parameter R1, or null if not bound.
   * @return true if the input is a valid (partial) match of the pattern.
   * 
   */
  public boolean hasMatch(final Route pR1) {
    return rawHasMatch(new Object[]{pR1});
  }
  
  /**
   * Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pR1 the fixed value of pattern parameter R1, or null if not bound.
   * @return the number of pattern matches found.
   * 
   */
  public int countMatches(final Route pR1) {
    return rawCountMatches(new Object[]{pR1});
  }
  
  /**
   * Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
   * @param pR1 the fixed value of pattern parameter R1, or null if not bound.
   * @param processor the action that will process each pattern match.
   * 
   */
  public void forEachMatch(final Route pR1, final IMatchProcessor<? super AseMatch> processor) {
    rawForEachMatch(new Object[]{pR1}, processor);
  }
  
  /**
   * Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pR1 the fixed value of pattern parameter R1, or null if not bound.
   * @param processor the action that will process the selected match.
   * @return true if the pattern has at least one match with the given parameter values, false if the processor was not invoked
   * 
   */
  public boolean forOneArbitraryMatch(final Route pR1, final IMatchProcessor<? super AseMatch> processor) {
    return rawForOneArbitraryMatch(new Object[]{pR1}, processor);
  }
  
  /**
   * Registers a new filtered delta monitor on this pattern matcher.
   * The DeltaMonitor can be used to track changes (delta) in the set of filtered pattern matches from now on, considering those matches only that conform to the given fixed values of some parameters.
   * It can also be reset to track changes from a later point in time,
   * and changes can even be acknowledged on an individual basis.
   * See {@link DeltaMonitor} for details.
   * @param fillAtStart if true, all current matches are reported as new match events; if false, the delta monitor starts empty.
   * @param pR1 the fixed value of pattern parameter R1, or null if not bound.
   * @return the delta monitor.
   * @deprecated use the IncQuery Databinding API (IncQueryObservables) instead.
   * 
   */
  @Deprecated
  public DeltaMonitor<AseMatch> newFilteredDeltaMonitor(final boolean fillAtStart, final Route pR1) {
    return rawNewFilteredDeltaMonitor(fillAtStart, new Object[]{pR1});
  }
  
  /**
   * Returns a new (partial) Match object for the matcher.
   * This can be used e.g. to call the matcher with a partial match.
   * <p>The returned match will be immutable. Use {@link #newEmptyMatch()} to obtain a mutable match object.
   * @param pR1 the fixed value of pattern parameter R1, or null if not bound.
   * @return the (partial) match object.
   * 
   */
  public AseMatch newMatch(final Route pR1) {
    return new AseMatch.Immutable(pR1);
    
  }
  
  /**
   * Retrieve the set of values that occur in matches for R1.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  protected Set<Route> rawAccumulateAllValuesOfR1(final Object[] parameters) {
    Set<Route> results = new HashSet<Route>();
    rawAccumulateAllValues(POSITION_R1, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for R1.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Route> getAllValuesOfR1() {
    return rawAccumulateAllValuesOfR1(emptyArray());
  }
  
  @Override
  protected AseMatch tupleToMatch(final Tuple t) {
    try {
    	return new AseMatch.Immutable((Concept.Route) t.get(POSITION_R1));
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in tuple not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
  
  @Override
  protected AseMatch arrayToMatch(final Object[] match) {
    try {
    	return new AseMatch.Immutable((Concept.Route) match[POSITION_R1]);
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in array not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
  
  @Override
  protected AseMatch arrayToMatchMutable(final Object[] match) {
    try {
    	return new AseMatch.Mutable((Concept.Route) match[POSITION_R1]);
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in array not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
}
