package hu.bme.mit.train.constraintcheck.incquery;

import hu.bme.mit.train.constraintcheck.incquery.EntrySignal1Matcher;
import hu.bme.mit.train.constraintcheck.incquery.EntrySignalSensor1Matcher;
import hu.bme.mit.train.constraintcheck.incquery.HasNegLengthSegmentMatcher;
import hu.bme.mit.train.constraintcheck.incquery.NegLengthSegmentMatcher;
import hu.bme.mit.train.constraintcheck.incquery.util.EntrySignal1QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.EntrySignalSensor1QuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.HasNegLengthSegmentQuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.NegLengthSegmentQuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedPatternGroup;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * A pattern group formed of all patterns defined in ase_helper.eiq.
 * 
 * <p>Use the static instance as any {@link org.eclipse.incquery.runtime.api.IPatternGroup}, to conveniently prepare
 * an EMF-IncQuery engine for matching all patterns originally defined in file ase_helper.eiq,
 * in order to achieve better performance than one-by-one on-demand matcher initialization.
 * 
 * <p> From package hu.bme.mit.train.constraintcheck.incquery, the group contains the definition of the following patterns: <ul>
 * <li>entrySignalSensor1</li>
 * <li>entrySignal1</li>
 * <li>HasNegLengthSegment</li>
 * <li>NegLengthSegment</li>
 * </ul>
 * 
 * @see IPatternGroup
 * 
 */
@SuppressWarnings("all")
public final class Ase_helper extends BaseGeneratedPatternGroup {
  /**
   * Access the pattern group.
   * 
   * @return the singleton instance of the group
   * @throws IncQueryException if there was an error loading the generated code of pattern specifications
   * 
   */
  public static Ase_helper instance() throws IncQueryException {
    if (INSTANCE == null) {
    	INSTANCE = new Ase_helper();
    }
    return INSTANCE;
    
  }
  
  private static Ase_helper INSTANCE;
  
  private Ase_helper() throws IncQueryException {
    querySpecifications.add(EntrySignalSensor1QuerySpecification.instance());
    querySpecifications.add(EntrySignal1QuerySpecification.instance());
    querySpecifications.add(HasNegLengthSegmentQuerySpecification.instance());
    querySpecifications.add(NegLengthSegmentQuerySpecification.instance());
    
  }
  
  public EntrySignalSensor1QuerySpecification getEntrySignalSensor1() throws IncQueryException {
    return EntrySignalSensor1QuerySpecification.instance();
  }
  
  public EntrySignalSensor1Matcher getEntrySignalSensor1(final IncQueryEngine engine) throws IncQueryException {
    return EntrySignalSensor1Matcher.on(engine);
  }
  
  public EntrySignal1QuerySpecification getEntrySignal1() throws IncQueryException {
    return EntrySignal1QuerySpecification.instance();
  }
  
  public EntrySignal1Matcher getEntrySignal1(final IncQueryEngine engine) throws IncQueryException {
    return EntrySignal1Matcher.on(engine);
  }
  
  public HasNegLengthSegmentQuerySpecification getHasNegLengthSegment() throws IncQueryException {
    return HasNegLengthSegmentQuerySpecification.instance();
  }
  
  public HasNegLengthSegmentMatcher getHasNegLengthSegment(final IncQueryEngine engine) throws IncQueryException {
    return HasNegLengthSegmentMatcher.on(engine);
  }
  
  public NegLengthSegmentQuerySpecification getNegLengthSegment() throws IncQueryException {
    return NegLengthSegmentQuerySpecification.instance();
  }
  
  public NegLengthSegmentMatcher getNegLengthSegment(final IncQueryEngine engine) throws IncQueryException {
    return NegLengthSegmentMatcher.on(engine);
  }
}
