package hu.bme.mit.train.constraintcheck.incquery;

import Concept.Route;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_oldQuerySpecification;
import java.util.Arrays;
import java.util.List;
import org.eclipse.incquery.runtime.api.IPatternMatch;
import org.eclipse.incquery.runtime.api.impl.BasePatternMatch;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * Pattern-specific match representation of the hu.bme.mit.train.constraintcheck.incquery.ase_old pattern,
 * to be used in conjunction with {@link Ase_oldMatcher}.
 * 
 * <p>Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters,
 * usable to represent a match of the pattern in the result of a query,
 * or to specify the bound (fixed) input parameters when issuing a query.
 * 
 * @see Ase_oldMatcher
 * @see Ase_oldProcessor
 * 
 */
@SuppressWarnings("all")
public abstract class Ase_oldMatch extends BasePatternMatch {
  private Route fR1;
  
  private static List<String> parameterNames = makeImmutableList("R1");
  
  private Ase_oldMatch(final Route pR1) {
    this.fR1 = pR1;
    
  }
  
  @Override
  public Object get(final String parameterName) {
    if ("R1".equals(parameterName)) return this.fR1;
    return null;
    
  }
  
  public Route getR1() {
    return this.fR1;
    
  }
  
  @Override
  public boolean set(final String parameterName, final Object newValue) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    if ("R1".equals(parameterName) ) {
    	this.fR1 = (Concept.Route) newValue;
    	return true;
    }
    return false;
    
  }
  
  public void setR1(final Route pR1) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fR1 = pR1;
    
  }
  
  @Override
  public String patternName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ase_old";
    
  }
  
  @Override
  public List<String> parameterNames() {
    return Ase_oldMatch.parameterNames;
    
  }
  
  @Override
  public Object[] toArray() {
    return new Object[]{fR1};
    
  }
  
  @Override
  public String prettyPrint() {
    StringBuilder result = new StringBuilder();
    result.append("\"R1\"=" + prettyPrintValue(fR1));
    return result.toString();
    
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fR1 == null) ? 0 : fR1.hashCode());
    return result;
    
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
    	return true;
    if (!(obj instanceof Ase_oldMatch)) { // this should be infrequent
    	if (obj == null)
    		return false;
    	if (!(obj instanceof IPatternMatch))
    		return false;
    	IPatternMatch otherSig  = (IPatternMatch) obj;
    	if (!specification().equals(otherSig.specification()))
    		return false;
    	return Arrays.deepEquals(toArray(), otherSig.toArray());
    }
    Ase_oldMatch other = (Ase_oldMatch) obj;
    if (fR1 == null) {if (other.fR1 != null) return false;}
    else if (!fR1.equals(other.fR1)) return false;
    return true;
  }
  
  @Override
  public Ase_oldQuerySpecification specification() {
    try {
    	return Ase_oldQuerySpecification.instance();
    } catch (IncQueryException ex) {
     	// This cannot happen, as the match object can only be instantiated if the query specification exists
     	throw new IllegalStateException	(ex);
    }
    
  }
  
  @SuppressWarnings("all")
  static final class Mutable extends Ase_oldMatch {
    Mutable(final Route pR1) {
      super(pR1);
      
    }
    
    @Override
    public boolean isMutable() {
      return true;
    }
  }
  
  
  @SuppressWarnings("all")
  static final class Immutable extends Ase_oldMatch {
    Immutable(final Route pR1) {
      super(pR1);
      
    }
    
    @Override
    public boolean isMutable() {
      return false;
    }
  }
  
}
