package hu.bme.mit.train.constraintcheck.incquery;

import Concept.Route;
import Concept.Signal;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_param_2QuerySpecification;
import java.util.Arrays;
import java.util.List;
import org.eclipse.incquery.runtime.api.IPatternMatch;
import org.eclipse.incquery.runtime.api.impl.BasePatternMatch;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * Pattern-specific match representation of the hu.bme.mit.train.constraintcheck.incquery.ase_param_2 pattern,
 * to be used in conjunction with {@link Ase_param_2Matcher}.
 * 
 * <p>Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters,
 * usable to represent a match of the pattern in the result of a query,
 * or to specify the bound (fixed) input parameters when issuing a query.
 * 
 * @see Ase_param_2Matcher
 * @see Ase_param_2Processor
 * 
 */
@SuppressWarnings("all")
public abstract class Ase_param_2Match extends BasePatternMatch {
  private Route fR;
  
  private Signal fSigA;
  
  private static List<String> parameterNames = makeImmutableList("R", "SigA");
  
  private Ase_param_2Match(final Route pR, final Signal pSigA) {
    this.fR = pR;
    this.fSigA = pSigA;
    
  }
  
  @Override
  public Object get(final String parameterName) {
    if ("R".equals(parameterName)) return this.fR;
    if ("SigA".equals(parameterName)) return this.fSigA;
    return null;
    
  }
  
  public Route getR() {
    return this.fR;
    
  }
  
  public Signal getSigA() {
    return this.fSigA;
    
  }
  
  @Override
  public boolean set(final String parameterName, final Object newValue) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    if ("R".equals(parameterName) ) {
    	this.fR = (Concept.Route) newValue;
    	return true;
    }
    if ("SigA".equals(parameterName) ) {
    	this.fSigA = (Concept.Signal) newValue;
    	return true;
    }
    return false;
    
  }
  
  public void setR(final Route pR) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fR = pR;
    
  }
  
  public void setSigA(final Signal pSigA) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSigA = pSigA;
    
  }
  
  @Override
  public String patternName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ase_param_2";
    
  }
  
  @Override
  public List<String> parameterNames() {
    return Ase_param_2Match.parameterNames;
    
  }
  
  @Override
  public Object[] toArray() {
    return new Object[]{fR, fSigA};
    
  }
  
  @Override
  public String prettyPrint() {
    StringBuilder result = new StringBuilder();
    result.append("\"R\"=" + prettyPrintValue(fR) + ", ");
    result.append("\"SigA\"=" + prettyPrintValue(fSigA));
    return result.toString();
    
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fR == null) ? 0 : fR.hashCode());
    result = prime * result + ((fSigA == null) ? 0 : fSigA.hashCode());
    return result;
    
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
    	return true;
    if (!(obj instanceof Ase_param_2Match)) { // this should be infrequent
    	if (obj == null)
    		return false;
    	if (!(obj instanceof IPatternMatch))
    		return false;
    	IPatternMatch otherSig  = (IPatternMatch) obj;
    	if (!specification().equals(otherSig.specification()))
    		return false;
    	return Arrays.deepEquals(toArray(), otherSig.toArray());
    }
    Ase_param_2Match other = (Ase_param_2Match) obj;
    if (fR == null) {if (other.fR != null) return false;}
    else if (!fR.equals(other.fR)) return false;
    if (fSigA == null) {if (other.fSigA != null) return false;}
    else if (!fSigA.equals(other.fSigA)) return false;
    return true;
  }
  
  @Override
  public Ase_param_2QuerySpecification specification() {
    try {
    	return Ase_param_2QuerySpecification.instance();
    } catch (IncQueryException ex) {
     	// This cannot happen, as the match object can only be instantiated if the query specification exists
     	throw new IllegalStateException	(ex);
    }
    
  }
  
  @SuppressWarnings("all")
  static final class Mutable extends Ase_param_2Match {
    Mutable(final Route pR, final Signal pSigA) {
      super(pR, pSigA);
      
    }
    
    @Override
    public boolean isMutable() {
      return true;
    }
  }
  
  
  @SuppressWarnings("all")
  static final class Immutable extends Ase_param_2Match {
    Immutable(final Route pR, final Signal pSigA) {
      super(pR, pSigA);
      
    }
    
    @Override
    public boolean isMutable() {
      return false;
    }
  }
  
}
