package hu.bme.mit.train.constraintcheck.incquery;

import Concept.Route;
import Concept.Sensor;
import Concept.Signal;
import Concept.Trackelement;
import hu.bme.mit.train.constraintcheck.incquery.Ase_param_4Match;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_param_4QuerySpecification;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.incquery.runtime.api.IMatchProcessor;
import org.eclipse.incquery.runtime.api.IQuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseMatcher;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.matchers.tuple.Tuple;
import org.eclipse.incquery.runtime.rete.misc.DeltaMonitor;

/**
 * Generated pattern matcher API of the hu.bme.mit.train.constraintcheck.incquery.ase_param_4 pattern,
 * providing pattern-specific query methods.
 * 
 * <p>Use the pattern matcher on a given model via {@link #on(IncQueryEngine)},
 * e.g. in conjunction with {@link IncQueryEngine#on(Notifier)}.
 * 
 * <p>Matches of the pattern will be represented as {@link Ase_param_4Match}.
 * 
 * <p>Original source:
 * <code><pre>
 * pattern ase_param_4(R, SigA, Te1, Sen1) =
 * {
 * 	Route(R);
 * 	Signal(SigA);
 * 	Signal(SigB);
 * 	Route.Route_entry(R, SigA);
 * 	Route.Route_exit(R, SigB);
 * 
 * 	Sensor(Sen1);
 * 	Sensor(Sen2);
 * 	Route.Route_routeDefinition(R, Sen1);
 * 	Route.Route_routeDefinition(R, Sen2);
 * 
 * 	Trackelement(Te1);
 * 	
 * 	Switch(Te2);
 * 
 * 	Sensor.Sensor_trackElement(Sen1, Te1);
 * 	Sensor.Sensor_trackElement(Sen2, Te2);
 * 
 * 	SwitchPosition(SWPTe2);
 * 	Switch.Switch_switchPosition(Te2, SWPTe2);
 * 	SwitchPosition.SwitchPosition_route(SWPTe2,R);
 * 	
 * }
 * </pre></code>
 * 
 * @see Ase_param_4Match
 * @see Ase_param_4Processor
 * @see Ase_param_4QuerySpecification
 * 
 */
@SuppressWarnings("all")
public class Ase_param_4Matcher extends BaseMatcher<Ase_param_4Match> {
  /**
   * @return the singleton instance of the query specification of this pattern
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static IQuerySpecification<Ase_param_4Matcher> querySpecification() throws IncQueryException {
    return Ase_param_4QuerySpecification.instance();
  }
  
  /**
   * Initializes the pattern matcher within an existing EMF-IncQuery engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing EMF-IncQuery engine in which this matcher will be created.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * 
   */
  public static Ase_param_4Matcher on(final IncQueryEngine engine) throws IncQueryException {
    // check if matcher already exists
    Ase_param_4Matcher matcher = engine.getExistingMatcher(querySpecification());
    if (matcher == null) {
    	matcher = new Ase_param_4Matcher(engine);
    	// do not have to "put" it into engine.matchers, reportMatcherInitialized() will take care of it
    }
    return matcher;
  }
  
  private final static int POSITION_R = 0;
  
  private final static int POSITION_SIGA = 1;
  
  private final static int POSITION_TE1 = 2;
  
  private final static int POSITION_SEN1 = 3;
  
  /**
   * Initializes the pattern matcher over a given EMF model root (recommended: Resource or ResourceSet).
   * If a pattern matcher is already constructed with the same root, only a light-weight reference is returned.
   * The scope of pattern matching will be the given EMF model root and below (see FAQ for more precise definition).
   * The match set will be incrementally refreshed upon updates from this scope.
   * <p>The matcher will be created within the managed {@link IncQueryEngine} belonging to the EMF model root, so
   * multiple matchers will reuse the same engine and benefit from increased performance and reduced memory footprint.
   * @param emfRoot the root of the EMF containment hierarchy where the pattern matcher will operate. Recommended: Resource or ResourceSet.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * @deprecated use {@link #on(IncQueryEngine)} instead, e.g. in conjunction with {@link IncQueryEngine#on(Notifier)}
   * 
   */
  @Deprecated
  public Ase_param_4Matcher(final Notifier emfRoot) throws IncQueryException {
    this(IncQueryEngine.on(emfRoot));
  }
  
  /**
   * Initializes the pattern matcher within an existing EMF-IncQuery engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing EMF-IncQuery engine in which this matcher will be created.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * @deprecated use {@link #on(IncQueryEngine)} instead
   * 
   */
  @Deprecated
  public Ase_param_4Matcher(final IncQueryEngine engine) throws IncQueryException {
    super(engine, querySpecification());
  }
  
  /**
   * Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pR the fixed value of pattern parameter R, or null if not bound.
   * @param pSigA the fixed value of pattern parameter SigA, or null if not bound.
   * @param pTe1 the fixed value of pattern parameter Te1, or null if not bound.
   * @param pSen1 the fixed value of pattern parameter Sen1, or null if not bound.
   * @return matches represented as a Ase_param_4Match object.
   * 
   */
  public Collection<Ase_param_4Match> getAllMatches(final Route pR, final Signal pSigA, final Trackelement pTe1, final Sensor pSen1) {
    return rawGetAllMatches(new Object[]{pR, pSigA, pTe1, pSen1});
  }
  
  /**
   * Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pR the fixed value of pattern parameter R, or null if not bound.
   * @param pSigA the fixed value of pattern parameter SigA, or null if not bound.
   * @param pTe1 the fixed value of pattern parameter Te1, or null if not bound.
   * @param pSen1 the fixed value of pattern parameter Sen1, or null if not bound.
   * @return a match represented as a Ase_param_4Match object, or null if no match is found.
   * 
   */
  public Ase_param_4Match getOneArbitraryMatch(final Route pR, final Signal pSigA, final Trackelement pTe1, final Sensor pSen1) {
    return rawGetOneArbitraryMatch(new Object[]{pR, pSigA, pTe1, pSen1});
  }
  
  /**
   * Indicates whether the given combination of specified pattern parameters constitute a valid pattern match,
   * under any possible substitution of the unspecified parameters (if any).
   * @param pR the fixed value of pattern parameter R, or null if not bound.
   * @param pSigA the fixed value of pattern parameter SigA, or null if not bound.
   * @param pTe1 the fixed value of pattern parameter Te1, or null if not bound.
   * @param pSen1 the fixed value of pattern parameter Sen1, or null if not bound.
   * @return true if the input is a valid (partial) match of the pattern.
   * 
   */
  public boolean hasMatch(final Route pR, final Signal pSigA, final Trackelement pTe1, final Sensor pSen1) {
    return rawHasMatch(new Object[]{pR, pSigA, pTe1, pSen1});
  }
  
  /**
   * Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pR the fixed value of pattern parameter R, or null if not bound.
   * @param pSigA the fixed value of pattern parameter SigA, or null if not bound.
   * @param pTe1 the fixed value of pattern parameter Te1, or null if not bound.
   * @param pSen1 the fixed value of pattern parameter Sen1, or null if not bound.
   * @return the number of pattern matches found.
   * 
   */
  public int countMatches(final Route pR, final Signal pSigA, final Trackelement pTe1, final Sensor pSen1) {
    return rawCountMatches(new Object[]{pR, pSigA, pTe1, pSen1});
  }
  
  /**
   * Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
   * @param pR the fixed value of pattern parameter R, or null if not bound.
   * @param pSigA the fixed value of pattern parameter SigA, or null if not bound.
   * @param pTe1 the fixed value of pattern parameter Te1, or null if not bound.
   * @param pSen1 the fixed value of pattern parameter Sen1, or null if not bound.
   * @param processor the action that will process each pattern match.
   * 
   */
  public void forEachMatch(final Route pR, final Signal pSigA, final Trackelement pTe1, final Sensor pSen1, final IMatchProcessor<? super Ase_param_4Match> processor) {
    rawForEachMatch(new Object[]{pR, pSigA, pTe1, pSen1}, processor);
  }
  
  /**
   * Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pR the fixed value of pattern parameter R, or null if not bound.
   * @param pSigA the fixed value of pattern parameter SigA, or null if not bound.
   * @param pTe1 the fixed value of pattern parameter Te1, or null if not bound.
   * @param pSen1 the fixed value of pattern parameter Sen1, or null if not bound.
   * @param processor the action that will process the selected match.
   * @return true if the pattern has at least one match with the given parameter values, false if the processor was not invoked
   * 
   */
  public boolean forOneArbitraryMatch(final Route pR, final Signal pSigA, final Trackelement pTe1, final Sensor pSen1, final IMatchProcessor<? super Ase_param_4Match> processor) {
    return rawForOneArbitraryMatch(new Object[]{pR, pSigA, pTe1, pSen1}, processor);
  }
  
  /**
   * Registers a new filtered delta monitor on this pattern matcher.
   * The DeltaMonitor can be used to track changes (delta) in the set of filtered pattern matches from now on, considering those matches only that conform to the given fixed values of some parameters.
   * It can also be reset to track changes from a later point in time,
   * and changes can even be acknowledged on an individual basis.
   * See {@link DeltaMonitor} for details.
   * @param fillAtStart if true, all current matches are reported as new match events; if false, the delta monitor starts empty.
   * @param pR the fixed value of pattern parameter R, or null if not bound.
   * @param pSigA the fixed value of pattern parameter SigA, or null if not bound.
   * @param pTe1 the fixed value of pattern parameter Te1, or null if not bound.
   * @param pSen1 the fixed value of pattern parameter Sen1, or null if not bound.
   * @return the delta monitor.
   * @deprecated use the IncQuery Databinding API (IncQueryObservables) instead.
   * 
   */
  @Deprecated
  public DeltaMonitor<Ase_param_4Match> newFilteredDeltaMonitor(final boolean fillAtStart, final Route pR, final Signal pSigA, final Trackelement pTe1, final Sensor pSen1) {
    return rawNewFilteredDeltaMonitor(fillAtStart, new Object[]{pR, pSigA, pTe1, pSen1});
  }
  
  /**
   * Returns a new (partial) Match object for the matcher.
   * This can be used e.g. to call the matcher with a partial match.
   * <p>The returned match will be immutable. Use {@link #newEmptyMatch()} to obtain a mutable match object.
   * @param pR the fixed value of pattern parameter R, or null if not bound.
   * @param pSigA the fixed value of pattern parameter SigA, or null if not bound.
   * @param pTe1 the fixed value of pattern parameter Te1, or null if not bound.
   * @param pSen1 the fixed value of pattern parameter Sen1, or null if not bound.
   * @return the (partial) match object.
   * 
   */
  public Ase_param_4Match newMatch(final Route pR, final Signal pSigA, final Trackelement pTe1, final Sensor pSen1) {
    return new Ase_param_4Match.Immutable(pR, pSigA, pTe1, pSen1);
    
  }
  
  /**
   * Retrieve the set of values that occur in matches for R.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  protected Set<Route> rawAccumulateAllValuesOfR(final Object[] parameters) {
    Set<Route> results = new HashSet<Route>();
    rawAccumulateAllValues(POSITION_R, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for R.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Route> getAllValuesOfR() {
    return rawAccumulateAllValuesOfR(emptyArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for R.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Route> getAllValuesOfR(final Ase_param_4Match partialMatch) {
    return rawAccumulateAllValuesOfR(partialMatch.toArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for R.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Route> getAllValuesOfR(final Signal pSigA, final Trackelement pTe1, final Sensor pSen1) {
    return rawAccumulateAllValuesOfR(new Object[]{null, pSigA, pTe1, pSen1});
  }
  
  /**
   * Retrieve the set of values that occur in matches for SigA.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  protected Set<Signal> rawAccumulateAllValuesOfSigA(final Object[] parameters) {
    Set<Signal> results = new HashSet<Signal>();
    rawAccumulateAllValues(POSITION_SIGA, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for SigA.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Signal> getAllValuesOfSigA() {
    return rawAccumulateAllValuesOfSigA(emptyArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for SigA.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Signal> getAllValuesOfSigA(final Ase_param_4Match partialMatch) {
    return rawAccumulateAllValuesOfSigA(partialMatch.toArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for SigA.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Signal> getAllValuesOfSigA(final Route pR, final Trackelement pTe1, final Sensor pSen1) {
    return rawAccumulateAllValuesOfSigA(new Object[]{pR, null, pTe1, pSen1});
  }
  
  /**
   * Retrieve the set of values that occur in matches for Te1.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  protected Set<Trackelement> rawAccumulateAllValuesOfTe1(final Object[] parameters) {
    Set<Trackelement> results = new HashSet<Trackelement>();
    rawAccumulateAllValues(POSITION_TE1, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for Te1.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Trackelement> getAllValuesOfTe1() {
    return rawAccumulateAllValuesOfTe1(emptyArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for Te1.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Trackelement> getAllValuesOfTe1(final Ase_param_4Match partialMatch) {
    return rawAccumulateAllValuesOfTe1(partialMatch.toArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for Te1.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Trackelement> getAllValuesOfTe1(final Route pR, final Signal pSigA, final Sensor pSen1) {
    return rawAccumulateAllValuesOfTe1(new Object[]{pR, pSigA, null, pSen1});
  }
  
  /**
   * Retrieve the set of values that occur in matches for Sen1.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  protected Set<Sensor> rawAccumulateAllValuesOfSen1(final Object[] parameters) {
    Set<Sensor> results = new HashSet<Sensor>();
    rawAccumulateAllValues(POSITION_SEN1, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for Sen1.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Sensor> getAllValuesOfSen1() {
    return rawAccumulateAllValuesOfSen1(emptyArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for Sen1.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Sensor> getAllValuesOfSen1(final Ase_param_4Match partialMatch) {
    return rawAccumulateAllValuesOfSen1(partialMatch.toArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for Sen1.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Sensor> getAllValuesOfSen1(final Route pR, final Signal pSigA, final Trackelement pTe1) {
    return rawAccumulateAllValuesOfSen1(new Object[]{pR, pSigA, pTe1, null});
  }
  
  @Override
  protected Ase_param_4Match tupleToMatch(final Tuple t) {
    try {
    	return new Ase_param_4Match.Immutable((Concept.Route) t.get(POSITION_R), (Concept.Signal) t.get(POSITION_SIGA), (Concept.Trackelement) t.get(POSITION_TE1), (Concept.Sensor) t.get(POSITION_SEN1));
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in tuple not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
  
  @Override
  protected Ase_param_4Match arrayToMatch(final Object[] match) {
    try {
    	return new Ase_param_4Match.Immutable((Concept.Route) match[POSITION_R], (Concept.Signal) match[POSITION_SIGA], (Concept.Trackelement) match[POSITION_TE1], (Concept.Sensor) match[POSITION_SEN1]);
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in array not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
  
  @Override
  protected Ase_param_4Match arrayToMatchMutable(final Object[] match) {
    try {
    	return new Ase_param_4Match.Mutable((Concept.Route) match[POSITION_R], (Concept.Signal) match[POSITION_SIGA], (Concept.Trackelement) match[POSITION_TE1], (Concept.Sensor) match[POSITION_SEN1]);
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in array not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
}
