package hu.bme.mit.train.constraintcheck.incquery;

import Concept.Route;
import Concept.Sensor;
import Concept.Signal;
import Concept.Switch;
import Concept.SwitchPosition;
import hu.bme.mit.train.constraintcheck.incquery.util.Ase_paramcircle_5QuerySpecification;
import java.util.Arrays;
import java.util.List;
import org.eclipse.incquery.runtime.api.IPatternMatch;
import org.eclipse.incquery.runtime.api.impl.BasePatternMatch;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * Pattern-specific match representation of the hu.bme.mit.train.constraintcheck.incquery.ase_paramcircle_5 pattern,
 * to be used in conjunction with {@link Ase_paramcircle_5Matcher}.
 * 
 * <p>Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters,
 * usable to represent a match of the pattern in the result of a query,
 * or to specify the bound (fixed) input parameters when issuing a query.
 * 
 * @see Ase_paramcircle_5Matcher
 * @see Ase_paramcircle_5Processor
 * 
 */
@SuppressWarnings("all")
public abstract class Ase_paramcircle_5Match extends BasePatternMatch {
  private Route fR;
  
  private Signal fSigA;
  
  private Switch fTe1;
  
  private Sensor fSen1;
  
  private SwitchPosition fSWPTe;
  
  private static List<String> parameterNames = makeImmutableList("R", "SigA", "Te1", "Sen1", "SWPTe");
  
  private Ase_paramcircle_5Match(final Route pR, final Signal pSigA, final Switch pTe1, final Sensor pSen1, final SwitchPosition pSWPTe) {
    this.fR = pR;
    this.fSigA = pSigA;
    this.fTe1 = pTe1;
    this.fSen1 = pSen1;
    this.fSWPTe = pSWPTe;
    
  }
  
  @Override
  public Object get(final String parameterName) {
    if ("R".equals(parameterName)) return this.fR;
    if ("SigA".equals(parameterName)) return this.fSigA;
    if ("Te1".equals(parameterName)) return this.fTe1;
    if ("Sen1".equals(parameterName)) return this.fSen1;
    if ("SWPTe".equals(parameterName)) return this.fSWPTe;
    return null;
    
  }
  
  public Route getR() {
    return this.fR;
    
  }
  
  public Signal getSigA() {
    return this.fSigA;
    
  }
  
  public Switch getTe1() {
    return this.fTe1;
    
  }
  
  public Sensor getSen1() {
    return this.fSen1;
    
  }
  
  public SwitchPosition getSWPTe() {
    return this.fSWPTe;
    
  }
  
  @Override
  public boolean set(final String parameterName, final Object newValue) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    if ("R".equals(parameterName) ) {
    	this.fR = (Concept.Route) newValue;
    	return true;
    }
    if ("SigA".equals(parameterName) ) {
    	this.fSigA = (Concept.Signal) newValue;
    	return true;
    }
    if ("Te1".equals(parameterName) ) {
    	this.fTe1 = (Concept.Switch) newValue;
    	return true;
    }
    if ("Sen1".equals(parameterName) ) {
    	this.fSen1 = (Concept.Sensor) newValue;
    	return true;
    }
    if ("SWPTe".equals(parameterName) ) {
    	this.fSWPTe = (Concept.SwitchPosition) newValue;
    	return true;
    }
    return false;
    
  }
  
  public void setR(final Route pR) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fR = pR;
    
  }
  
  public void setSigA(final Signal pSigA) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSigA = pSigA;
    
  }
  
  public void setTe1(final Switch pTe1) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fTe1 = pTe1;
    
  }
  
  public void setSen1(final Sensor pSen1) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSen1 = pSen1;
    
  }
  
  public void setSWPTe(final SwitchPosition pSWPTe) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSWPTe = pSWPTe;
    
  }
  
  @Override
  public String patternName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ase_paramcircle_5";
    
  }
  
  @Override
  public List<String> parameterNames() {
    return Ase_paramcircle_5Match.parameterNames;
    
  }
  
  @Override
  public Object[] toArray() {
    return new Object[]{fR, fSigA, fTe1, fSen1, fSWPTe};
    
  }
  
  @Override
  public String prettyPrint() {
    StringBuilder result = new StringBuilder();
    result.append("\"R\"=" + prettyPrintValue(fR) + ", ");
    result.append("\"SigA\"=" + prettyPrintValue(fSigA) + ", ");
    result.append("\"Te1\"=" + prettyPrintValue(fTe1) + ", ");
    result.append("\"Sen1\"=" + prettyPrintValue(fSen1) + ", ");
    result.append("\"SWPTe\"=" + prettyPrintValue(fSWPTe));
    return result.toString();
    
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fR == null) ? 0 : fR.hashCode());
    result = prime * result + ((fSigA == null) ? 0 : fSigA.hashCode());
    result = prime * result + ((fTe1 == null) ? 0 : fTe1.hashCode());
    result = prime * result + ((fSen1 == null) ? 0 : fSen1.hashCode());
    result = prime * result + ((fSWPTe == null) ? 0 : fSWPTe.hashCode());
    return result;
    
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
    	return true;
    if (!(obj instanceof Ase_paramcircle_5Match)) { // this should be infrequent
    	if (obj == null)
    		return false;
    	if (!(obj instanceof IPatternMatch))
    		return false;
    	IPatternMatch otherSig  = (IPatternMatch) obj;
    	if (!specification().equals(otherSig.specification()))
    		return false;
    	return Arrays.deepEquals(toArray(), otherSig.toArray());
    }
    Ase_paramcircle_5Match other = (Ase_paramcircle_5Match) obj;
    if (fR == null) {if (other.fR != null) return false;}
    else if (!fR.equals(other.fR)) return false;
    if (fSigA == null) {if (other.fSigA != null) return false;}
    else if (!fSigA.equals(other.fSigA)) return false;
    if (fTe1 == null) {if (other.fTe1 != null) return false;}
    else if (!fTe1.equals(other.fTe1)) return false;
    if (fSen1 == null) {if (other.fSen1 != null) return false;}
    else if (!fSen1.equals(other.fSen1)) return false;
    if (fSWPTe == null) {if (other.fSWPTe != null) return false;}
    else if (!fSWPTe.equals(other.fSWPTe)) return false;
    return true;
  }
  
  @Override
  public Ase_paramcircle_5QuerySpecification specification() {
    try {
    	return Ase_paramcircle_5QuerySpecification.instance();
    } catch (IncQueryException ex) {
     	// This cannot happen, as the match object can only be instantiated if the query specification exists
     	throw new IllegalStateException	(ex);
    }
    
  }
  
  @SuppressWarnings("all")
  static final class Mutable extends Ase_paramcircle_5Match {
    Mutable(final Route pR, final Signal pSigA, final Switch pTe1, final Sensor pSen1, final SwitchPosition pSWPTe) {
      super(pR, pSigA, pTe1, pSen1, pSWPTe);
      
    }
    
    @Override
    public boolean isMutable() {
      return true;
    }
  }
  
  
  @SuppressWarnings("all")
  static final class Immutable extends Ase_paramcircle_5Match {
    Immutable(final Route pR, final Signal pSigA, final Switch pTe1, final Sensor pSen1, final SwitchPosition pSWPTe) {
      super(pR, pSigA, pTe1, pSen1, pSWPTe);
      
    }
    
    @Override
    public boolean isMutable() {
      return false;
    }
  }
  
}
