package hu.bme.mit.train.constraintcheck.incquery;

import Concept.Sensor;
import hu.bme.mit.train.constraintcheck.incquery.util.ConnectingSensorsQuerySpecification;
import java.util.Arrays;
import java.util.List;
import org.eclipse.incquery.runtime.api.IPatternMatch;
import org.eclipse.incquery.runtime.api.impl.BasePatternMatch;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * Pattern-specific match representation of the hu.bme.mit.train.constraintcheck.incquery.connectingSensors pattern,
 * to be used in conjunction with {@link ConnectingSensorsMatcher}.
 * 
 * <p>Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters,
 * usable to represent a match of the pattern in the result of a query,
 * or to specify the bound (fixed) input parameters when issuing a query.
 * 
 * @see ConnectingSensorsMatcher
 * @see ConnectingSensorsProcessor
 * 
 */
@SuppressWarnings("all")
public abstract class ConnectingSensorsMatch extends BasePatternMatch {
  private Sensor fSen1;
  
  private Sensor fSen2;
  
  private static List<String> parameterNames = makeImmutableList("Sen1", "Sen2");
  
  private ConnectingSensorsMatch(final Sensor pSen1, final Sensor pSen2) {
    this.fSen1 = pSen1;
    this.fSen2 = pSen2;
    
  }
  
  @Override
  public Object get(final String parameterName) {
    if ("Sen1".equals(parameterName)) return this.fSen1;
    if ("Sen2".equals(parameterName)) return this.fSen2;
    return null;
    
  }
  
  public Sensor getSen1() {
    return this.fSen1;
    
  }
  
  public Sensor getSen2() {
    return this.fSen2;
    
  }
  
  @Override
  public boolean set(final String parameterName, final Object newValue) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    if ("Sen1".equals(parameterName) ) {
    	this.fSen1 = (Concept.Sensor) newValue;
    	return true;
    }
    if ("Sen2".equals(parameterName) ) {
    	this.fSen2 = (Concept.Sensor) newValue;
    	return true;
    }
    return false;
    
  }
  
  public void setSen1(final Sensor pSen1) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSen1 = pSen1;
    
  }
  
  public void setSen2(final Sensor pSen2) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSen2 = pSen2;
    
  }
  
  @Override
  public String patternName() {
    return "hu.bme.mit.train.constraintcheck.incquery.connectingSensors";
    
  }
  
  @Override
  public List<String> parameterNames() {
    return ConnectingSensorsMatch.parameterNames;
    
  }
  
  @Override
  public Object[] toArray() {
    return new Object[]{fSen1, fSen2};
    
  }
  
  @Override
  public String prettyPrint() {
    StringBuilder result = new StringBuilder();
    result.append("\"Sen1\"=" + prettyPrintValue(fSen1) + ", ");
    result.append("\"Sen2\"=" + prettyPrintValue(fSen2));
    return result.toString();
    
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fSen1 == null) ? 0 : fSen1.hashCode());
    result = prime * result + ((fSen2 == null) ? 0 : fSen2.hashCode());
    return result;
    
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
    	return true;
    if (!(obj instanceof ConnectingSensorsMatch)) { // this should be infrequent
    	if (obj == null)
    		return false;
    	if (!(obj instanceof IPatternMatch))
    		return false;
    	IPatternMatch otherSig  = (IPatternMatch) obj;
    	if (!specification().equals(otherSig.specification()))
    		return false;
    	return Arrays.deepEquals(toArray(), otherSig.toArray());
    }
    ConnectingSensorsMatch other = (ConnectingSensorsMatch) obj;
    if (fSen1 == null) {if (other.fSen1 != null) return false;}
    else if (!fSen1.equals(other.fSen1)) return false;
    if (fSen2 == null) {if (other.fSen2 != null) return false;}
    else if (!fSen2.equals(other.fSen2)) return false;
    return true;
  }
  
  @Override
  public ConnectingSensorsQuerySpecification specification() {
    try {
    	return ConnectingSensorsQuerySpecification.instance();
    } catch (IncQueryException ex) {
     	// This cannot happen, as the match object can only be instantiated if the query specification exists
     	throw new IllegalStateException	(ex);
    }
    
  }
  
  @SuppressWarnings("all")
  static final class Mutable extends ConnectingSensorsMatch {
    Mutable(final Sensor pSen1, final Sensor pSen2) {
      super(pSen1, pSen2);
      
    }
    
    @Override
    public boolean isMutable() {
      return true;
    }
  }
  
  
  @SuppressWarnings("all")
  static final class Immutable extends ConnectingSensorsMatch {
    Immutable(final Sensor pSen1, final Sensor pSen2) {
      super(pSen1, pSen2);
      
    }
    
    @Override
    public boolean isMutable() {
      return false;
    }
  }
  
}
