package hu.bme.mit.train.constraintcheck.incquery;

import Concept.Route;
import Concept.Signal;
import hu.bme.mit.train.constraintcheck.incquery.util.EntrySignal1QuerySpecification;
import java.util.Arrays;
import java.util.List;
import org.eclipse.incquery.runtime.api.IPatternMatch;
import org.eclipse.incquery.runtime.api.impl.BasePatternMatch;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * Pattern-specific match representation of the hu.bme.mit.train.constraintcheck.incquery.entrySignal1 pattern,
 * to be used in conjunction with {@link EntrySignal1Matcher}.
 * 
 * <p>Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters,
 * usable to represent a match of the pattern in the result of a query,
 * or to specify the bound (fixed) input parameters when issuing a query.
 * 
 * @see EntrySignal1Matcher
 * @see EntrySignal1Processor
 * 
 */
@SuppressWarnings("all")
public abstract class EntrySignal1Match extends BasePatternMatch {
  private Signal fSig;
  
  private Route fR;
  
  private static List<String> parameterNames = makeImmutableList("Sig", "R");
  
  private EntrySignal1Match(final Signal pSig, final Route pR) {
    this.fSig = pSig;
    this.fR = pR;
    
  }
  
  @Override
  public Object get(final String parameterName) {
    if ("Sig".equals(parameterName)) return this.fSig;
    if ("R".equals(parameterName)) return this.fR;
    return null;
    
  }
  
  public Signal getSig() {
    return this.fSig;
    
  }
  
  public Route getR() {
    return this.fR;
    
  }
  
  @Override
  public boolean set(final String parameterName, final Object newValue) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    if ("Sig".equals(parameterName) ) {
    	this.fSig = (Concept.Signal) newValue;
    	return true;
    }
    if ("R".equals(parameterName) ) {
    	this.fR = (Concept.Route) newValue;
    	return true;
    }
    return false;
    
  }
  
  public void setSig(final Signal pSig) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSig = pSig;
    
  }
  
  public void setR(final Route pR) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fR = pR;
    
  }
  
  @Override
  public String patternName() {
    return "hu.bme.mit.train.constraintcheck.incquery.entrySignal1";
    
  }
  
  @Override
  public List<String> parameterNames() {
    return EntrySignal1Match.parameterNames;
    
  }
  
  @Override
  public Object[] toArray() {
    return new Object[]{fSig, fR};
    
  }
  
  @Override
  public String prettyPrint() {
    StringBuilder result = new StringBuilder();
    result.append("\"Sig\"=" + prettyPrintValue(fSig) + ", ");
    result.append("\"R\"=" + prettyPrintValue(fR));
    return result.toString();
    
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fSig == null) ? 0 : fSig.hashCode());
    result = prime * result + ((fR == null) ? 0 : fR.hashCode());
    return result;
    
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
    	return true;
    if (!(obj instanceof EntrySignal1Match)) { // this should be infrequent
    	if (obj == null)
    		return false;
    	if (!(obj instanceof IPatternMatch))
    		return false;
    	IPatternMatch otherSig  = (IPatternMatch) obj;
    	if (!specification().equals(otherSig.specification()))
    		return false;
    	return Arrays.deepEquals(toArray(), otherSig.toArray());
    }
    EntrySignal1Match other = (EntrySignal1Match) obj;
    if (fSig == null) {if (other.fSig != null) return false;}
    else if (!fSig.equals(other.fSig)) return false;
    if (fR == null) {if (other.fR != null) return false;}
    else if (!fR.equals(other.fR)) return false;
    return true;
  }
  
  @Override
  public EntrySignal1QuerySpecification specification() {
    try {
    	return EntrySignal1QuerySpecification.instance();
    } catch (IncQueryException ex) {
     	// This cannot happen, as the match object can only be instantiated if the query specification exists
     	throw new IllegalStateException	(ex);
    }
    
  }
  
  @SuppressWarnings("all")
  static final class Mutable extends EntrySignal1Match {
    Mutable(final Signal pSig, final Route pR) {
      super(pSig, pR);
      
    }
    
    @Override
    public boolean isMutable() {
      return true;
    }
  }
  
  
  @SuppressWarnings("all")
  static final class Immutable extends EntrySignal1Match {
    Immutable(final Signal pSig, final Route pR) {
      super(pSig, pR);
      
    }
    
    @Override
    public boolean isMutable() {
      return false;
    }
  }
  
}
