package hu.bme.mit.train.constraintcheck.incquery;

import Concept.Route;
import Concept.Sensor;
import Concept.Signal;
import hu.bme.mit.train.constraintcheck.incquery.util.EntrySignalSensor1QuerySpecification;
import java.util.Arrays;
import java.util.List;
import org.eclipse.incquery.runtime.api.IPatternMatch;
import org.eclipse.incquery.runtime.api.impl.BasePatternMatch;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * Pattern-specific match representation of the hu.bme.mit.train.constraintcheck.incquery.entrySignalSensor1 pattern,
 * to be used in conjunction with {@link EntrySignalSensor1Matcher}.
 * 
 * <p>Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters,
 * usable to represent a match of the pattern in the result of a query,
 * or to specify the bound (fixed) input parameters when issuing a query.
 * 
 * @see EntrySignalSensor1Matcher
 * @see EntrySignalSensor1Processor
 * 
 */
@SuppressWarnings("all")
public abstract class EntrySignalSensor1Match extends BasePatternMatch {
  private Signal fSig;
  
  private Route fR2;
  
  private Sensor fSen2;
  
  private static List<String> parameterNames = makeImmutableList("Sig", "R2", "Sen2");
  
  private EntrySignalSensor1Match(final Signal pSig, final Route pR2, final Sensor pSen2) {
    this.fSig = pSig;
    this.fR2 = pR2;
    this.fSen2 = pSen2;
    
  }
  
  @Override
  public Object get(final String parameterName) {
    if ("Sig".equals(parameterName)) return this.fSig;
    if ("R2".equals(parameterName)) return this.fR2;
    if ("Sen2".equals(parameterName)) return this.fSen2;
    return null;
    
  }
  
  public Signal getSig() {
    return this.fSig;
    
  }
  
  public Route getR2() {
    return this.fR2;
    
  }
  
  public Sensor getSen2() {
    return this.fSen2;
    
  }
  
  @Override
  public boolean set(final String parameterName, final Object newValue) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    if ("Sig".equals(parameterName) ) {
    	this.fSig = (Concept.Signal) newValue;
    	return true;
    }
    if ("R2".equals(parameterName) ) {
    	this.fR2 = (Concept.Route) newValue;
    	return true;
    }
    if ("Sen2".equals(parameterName) ) {
    	this.fSen2 = (Concept.Sensor) newValue;
    	return true;
    }
    return false;
    
  }
  
  public void setSig(final Signal pSig) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSig = pSig;
    
  }
  
  public void setR2(final Route pR2) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fR2 = pR2;
    
  }
  
  public void setSen2(final Sensor pSen2) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSen2 = pSen2;
    
  }
  
  @Override
  public String patternName() {
    return "hu.bme.mit.train.constraintcheck.incquery.entrySignalSensor1";
    
  }
  
  @Override
  public List<String> parameterNames() {
    return EntrySignalSensor1Match.parameterNames;
    
  }
  
  @Override
  public Object[] toArray() {
    return new Object[]{fSig, fR2, fSen2};
    
  }
  
  @Override
  public String prettyPrint() {
    StringBuilder result = new StringBuilder();
    result.append("\"Sig\"=" + prettyPrintValue(fSig) + ", ");
    result.append("\"R2\"=" + prettyPrintValue(fR2) + ", ");
    result.append("\"Sen2\"=" + prettyPrintValue(fSen2));
    return result.toString();
    
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fSig == null) ? 0 : fSig.hashCode());
    result = prime * result + ((fR2 == null) ? 0 : fR2.hashCode());
    result = prime * result + ((fSen2 == null) ? 0 : fSen2.hashCode());
    return result;
    
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
    	return true;
    if (!(obj instanceof EntrySignalSensor1Match)) { // this should be infrequent
    	if (obj == null)
    		return false;
    	if (!(obj instanceof IPatternMatch))
    		return false;
    	IPatternMatch otherSig  = (IPatternMatch) obj;
    	if (!specification().equals(otherSig.specification()))
    		return false;
    	return Arrays.deepEquals(toArray(), otherSig.toArray());
    }
    EntrySignalSensor1Match other = (EntrySignalSensor1Match) obj;
    if (fSig == null) {if (other.fSig != null) return false;}
    else if (!fSig.equals(other.fSig)) return false;
    if (fR2 == null) {if (other.fR2 != null) return false;}
    else if (!fR2.equals(other.fR2)) return false;
    if (fSen2 == null) {if (other.fSen2 != null) return false;}
    else if (!fSen2.equals(other.fSen2)) return false;
    return true;
  }
  
  @Override
  public EntrySignalSensor1QuerySpecification specification() {
    try {
    	return EntrySignalSensor1QuerySpecification.instance();
    } catch (IncQueryException ex) {
     	// This cannot happen, as the match object can only be instantiated if the query specification exists
     	throw new IllegalStateException	(ex);
    }
    
  }
  
  @SuppressWarnings("all")
  static final class Mutable extends EntrySignalSensor1Match {
    Mutable(final Signal pSig, final Route pR2, final Sensor pSen2) {
      super(pSig, pR2, pSen2);
      
    }
    
    @Override
    public boolean isMutable() {
      return true;
    }
  }
  
  
  @SuppressWarnings("all")
  static final class Immutable extends EntrySignalSensor1Match {
    Immutable(final Signal pSig, final Route pR2, final Sensor pSen2) {
      super(pSig, pR2, pSen2);
      
    }
    
    @Override
    public boolean isMutable() {
      return false;
    }
  }
  
}
