package hu.bme.mit.train.constraintcheck.incquery;

import Concept.Sensor;
import hu.bme.mit.train.constraintcheck.incquery.util.HasNegLengthSegmentQuerySpecification;
import java.util.Arrays;
import java.util.List;
import org.eclipse.incquery.runtime.api.IPatternMatch;
import org.eclipse.incquery.runtime.api.impl.BasePatternMatch;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * Pattern-specific match representation of the hu.bme.mit.train.constraintcheck.incquery.HasNegLengthSegment pattern,
 * to be used in conjunction with {@link HasNegLengthSegmentMatcher}.
 * 
 * <p>Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters,
 * usable to represent a match of the pattern in the result of a query,
 * or to specify the bound (fixed) input parameters when issuing a query.
 * 
 * @see HasNegLengthSegmentMatcher
 * @see HasNegLengthSegmentProcessor
 * 
 */
@SuppressWarnings("all")
public abstract class HasNegLengthSegmentMatch extends BasePatternMatch {
  private Sensor fSen;
  
  private static List<String> parameterNames = makeImmutableList("Sen");
  
  private HasNegLengthSegmentMatch(final Sensor pSen) {
    this.fSen = pSen;
    
  }
  
  @Override
  public Object get(final String parameterName) {
    if ("Sen".equals(parameterName)) return this.fSen;
    return null;
    
  }
  
  public Sensor getSen() {
    return this.fSen;
    
  }
  
  @Override
  public boolean set(final String parameterName, final Object newValue) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    if ("Sen".equals(parameterName) ) {
    	this.fSen = (Concept.Sensor) newValue;
    	return true;
    }
    return false;
    
  }
  
  public void setSen(final Sensor pSen) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSen = pSen;
    
  }
  
  @Override
  public String patternName() {
    return "hu.bme.mit.train.constraintcheck.incquery.HasNegLengthSegment";
    
  }
  
  @Override
  public List<String> parameterNames() {
    return HasNegLengthSegmentMatch.parameterNames;
    
  }
  
  @Override
  public Object[] toArray() {
    return new Object[]{fSen};
    
  }
  
  @Override
  public String prettyPrint() {
    StringBuilder result = new StringBuilder();
    result.append("\"Sen\"=" + prettyPrintValue(fSen));
    return result.toString();
    
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fSen == null) ? 0 : fSen.hashCode());
    return result;
    
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
    	return true;
    if (!(obj instanceof HasNegLengthSegmentMatch)) { // this should be infrequent
    	if (obj == null)
    		return false;
    	if (!(obj instanceof IPatternMatch))
    		return false;
    	IPatternMatch otherSig  = (IPatternMatch) obj;
    	if (!specification().equals(otherSig.specification()))
    		return false;
    	return Arrays.deepEquals(toArray(), otherSig.toArray());
    }
    HasNegLengthSegmentMatch other = (HasNegLengthSegmentMatch) obj;
    if (fSen == null) {if (other.fSen != null) return false;}
    else if (!fSen.equals(other.fSen)) return false;
    return true;
  }
  
  @Override
  public HasNegLengthSegmentQuerySpecification specification() {
    try {
    	return HasNegLengthSegmentQuerySpecification.instance();
    } catch (IncQueryException ex) {
     	// This cannot happen, as the match object can only be instantiated if the query specification exists
     	throw new IllegalStateException	(ex);
    }
    
  }
  
  @SuppressWarnings("all")
  static final class Mutable extends HasNegLengthSegmentMatch {
    Mutable(final Sensor pSen) {
      super(pSen);
      
    }
    
    @Override
    public boolean isMutable() {
      return true;
    }
  }
  
  
  @SuppressWarnings("all")
  static final class Immutable extends HasNegLengthSegmentMatch {
    Immutable(final Sensor pSen) {
      super(pSen);
      
    }
    
    @Override
    public boolean isMutable() {
      return false;
    }
  }
  
}
