package hu.bme.mit.train.constraintcheck.incquery;

import Concept.Sensor;
import Concept.Trackelement;
import hu.bme.mit.train.constraintcheck.incquery.util.SensorTrackelementQuerySpecification;
import java.util.Arrays;
import java.util.List;
import org.eclipse.incquery.runtime.api.IPatternMatch;
import org.eclipse.incquery.runtime.api.impl.BasePatternMatch;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * Pattern-specific match representation of the hu.bme.mit.train.constraintcheck.incquery.sensorTrackelement pattern,
 * to be used in conjunction with {@link SensorTrackelementMatcher}.
 * 
 * <p>Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters,
 * usable to represent a match of the pattern in the result of a query,
 * or to specify the bound (fixed) input parameters when issuing a query.
 * 
 * @see SensorTrackelementMatcher
 * @see SensorTrackelementProcessor
 * 
 */
@SuppressWarnings("all")
public abstract class SensorTrackelementMatch extends BasePatternMatch {
  private Sensor fSen;
  
  private Trackelement fTe;
  
  private static List<String> parameterNames = makeImmutableList("Sen", "Te");
  
  private SensorTrackelementMatch(final Sensor pSen, final Trackelement pTe) {
    this.fSen = pSen;
    this.fTe = pTe;
    
  }
  
  @Override
  public Object get(final String parameterName) {
    if ("Sen".equals(parameterName)) return this.fSen;
    if ("Te".equals(parameterName)) return this.fTe;
    return null;
    
  }
  
  public Sensor getSen() {
    return this.fSen;
    
  }
  
  public Trackelement getTe() {
    return this.fTe;
    
  }
  
  @Override
  public boolean set(final String parameterName, final Object newValue) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    if ("Sen".equals(parameterName) ) {
    	this.fSen = (Concept.Sensor) newValue;
    	return true;
    }
    if ("Te".equals(parameterName) ) {
    	this.fTe = (Concept.Trackelement) newValue;
    	return true;
    }
    return false;
    
  }
  
  public void setSen(final Sensor pSen) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSen = pSen;
    
  }
  
  public void setTe(final Trackelement pTe) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fTe = pTe;
    
  }
  
  @Override
  public String patternName() {
    return "hu.bme.mit.train.constraintcheck.incquery.sensorTrackelement";
    
  }
  
  @Override
  public List<String> parameterNames() {
    return SensorTrackelementMatch.parameterNames;
    
  }
  
  @Override
  public Object[] toArray() {
    return new Object[]{fSen, fTe};
    
  }
  
  @Override
  public String prettyPrint() {
    StringBuilder result = new StringBuilder();
    result.append("\"Sen\"=" + prettyPrintValue(fSen) + ", ");
    result.append("\"Te\"=" + prettyPrintValue(fTe));
    return result.toString();
    
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fSen == null) ? 0 : fSen.hashCode());
    result = prime * result + ((fTe == null) ? 0 : fTe.hashCode());
    return result;
    
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
    	return true;
    if (!(obj instanceof SensorTrackelementMatch)) { // this should be infrequent
    	if (obj == null)
    		return false;
    	if (!(obj instanceof IPatternMatch))
    		return false;
    	IPatternMatch otherSig  = (IPatternMatch) obj;
    	if (!specification().equals(otherSig.specification()))
    		return false;
    	return Arrays.deepEquals(toArray(), otherSig.toArray());
    }
    SensorTrackelementMatch other = (SensorTrackelementMatch) obj;
    if (fSen == null) {if (other.fSen != null) return false;}
    else if (!fSen.equals(other.fSen)) return false;
    if (fTe == null) {if (other.fTe != null) return false;}
    else if (!fTe.equals(other.fTe)) return false;
    return true;
  }
  
  @Override
  public SensorTrackelementQuerySpecification specification() {
    try {
    	return SensorTrackelementQuerySpecification.instance();
    } catch (IncQueryException ex) {
     	// This cannot happen, as the match object can only be instantiated if the query specification exists
     	throw new IllegalStateException	(ex);
    }
    
  }
  
  @SuppressWarnings("all")
  static final class Mutable extends SensorTrackelementMatch {
    Mutable(final Sensor pSen, final Trackelement pTe) {
      super(pSen, pTe);
      
    }
    
    @Override
    public boolean isMutable() {
      return true;
    }
  }
  
  
  @SuppressWarnings("all")
  static final class Immutable extends SensorTrackelementMatch {
    Immutable(final Sensor pSen, final Trackelement pTe) {
      super(pSen, pTe);
      
    }
    
    @Override
    public boolean isMutable() {
      return false;
    }
  }
  
}
