package hu.bme.mit.train.constraintcheck.incquery.ocl2iq;

import Concept.Segment;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util.PosLengthQuerySpecification;
import java.util.Arrays;
import java.util.List;
import org.eclipse.incquery.runtime.api.IPatternMatch;
import org.eclipse.incquery.runtime.api.impl.BasePatternMatch;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * Pattern-specific match representation of the hu.bme.mit.train.constraintcheck.incquery.ocl2iq.PosLength pattern,
 * to be used in conjunction with {@link PosLengthMatcher}.
 * 
 * <p>Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters,
 * usable to represent a match of the pattern in the result of a query,
 * or to specify the bound (fixed) input parameters when issuing a query.
 * 
 * @see PosLengthMatcher
 * @see PosLengthProcessor
 * 
 */
@SuppressWarnings("all")
public abstract class PosLengthMatch extends BasePatternMatch {
  private Segment fSelf;
  
  private static List<String> parameterNames = makeImmutableList("self");
  
  private PosLengthMatch(final Segment pSelf) {
    this.fSelf = pSelf;
    
  }
  
  @Override
  public Object get(final String parameterName) {
    if ("self".equals(parameterName)) return this.fSelf;
    return null;
    
  }
  
  public Segment getSelf() {
    return this.fSelf;
    
  }
  
  @Override
  public boolean set(final String parameterName, final Object newValue) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    if ("self".equals(parameterName) ) {
    	this.fSelf = (Concept.Segment) newValue;
    	return true;
    }
    return false;
    
  }
  
  public void setSelf(final Segment pSelf) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSelf = pSelf;
    
  }
  
  @Override
  public String patternName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ocl2iq.PosLength";
    
  }
  
  @Override
  public List<String> parameterNames() {
    return PosLengthMatch.parameterNames;
    
  }
  
  @Override
  public Object[] toArray() {
    return new Object[]{fSelf};
    
  }
  
  @Override
  public String prettyPrint() {
    StringBuilder result = new StringBuilder();
    result.append("\"self\"=" + prettyPrintValue(fSelf));
    return result.toString();
    
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fSelf == null) ? 0 : fSelf.hashCode());
    return result;
    
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
    	return true;
    if (!(obj instanceof PosLengthMatch)) { // this should be infrequent
    	if (obj == null)
    		return false;
    	if (!(obj instanceof IPatternMatch))
    		return false;
    	IPatternMatch otherSig  = (IPatternMatch) obj;
    	if (!specification().equals(otherSig.specification()))
    		return false;
    	return Arrays.deepEquals(toArray(), otherSig.toArray());
    }
    PosLengthMatch other = (PosLengthMatch) obj;
    if (fSelf == null) {if (other.fSelf != null) return false;}
    else if (!fSelf.equals(other.fSelf)) return false;
    return true;
  }
  
  @Override
  public PosLengthQuerySpecification specification() {
    try {
    	return PosLengthQuerySpecification.instance();
    } catch (IncQueryException ex) {
     	// This cannot happen, as the match object can only be instantiated if the query specification exists
     	throw new IllegalStateException	(ex);
    }
    
  }
  
  @SuppressWarnings("all")
  static final class Mutable extends PosLengthMatch {
    Mutable(final Segment pSelf) {
      super(pSelf);
      
    }
    
    @Override
    public boolean isMutable() {
      return true;
    }
  }
  
  
  @SuppressWarnings("all")
  static final class Immutable extends PosLengthMatch {
    Immutable(final Segment pSelf) {
      super(pSelf);
      
    }
    
    @Override
    public boolean isMutable() {
      return false;
    }
  }
  
}
