package hu.bme.mit.train.constraintcheck.incquery.ocl2iq;

import Concept.Sensor;
import Concept.SwitchPosition;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util.RouteSensor_0QuerySpecification;
import java.util.Arrays;
import java.util.List;
import org.eclipse.incquery.runtime.api.IPatternMatch;
import org.eclipse.incquery.runtime.api.impl.BasePatternMatch;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * Pattern-specific match representation of the hu.bme.mit.train.constraintcheck.incquery.ocl2iq.RouteSensor_0 pattern,
 * to be used in conjunction with {@link RouteSensor_0Matcher}.
 * 
 * <p>Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters,
 * usable to represent a match of the pattern in the result of a query,
 * or to specify the bound (fixed) input parameters when issuing a query.
 * 
 * @see RouteSensor_0Matcher
 * @see RouteSensor_0Processor
 * 
 */
@SuppressWarnings("all")
public abstract class RouteSensor_0Match extends BasePatternMatch {
  private SwitchPosition fSp;
  
  private Sensor fSelf;
  
  private static List<String> parameterNames = makeImmutableList("sp", "self");
  
  private RouteSensor_0Match(final SwitchPosition pSp, final Sensor pSelf) {
    this.fSp = pSp;
    this.fSelf = pSelf;
    
  }
  
  @Override
  public Object get(final String parameterName) {
    if ("sp".equals(parameterName)) return this.fSp;
    if ("self".equals(parameterName)) return this.fSelf;
    return null;
    
  }
  
  public SwitchPosition getSp() {
    return this.fSp;
    
  }
  
  public Sensor getSelf() {
    return this.fSelf;
    
  }
  
  @Override
  public boolean set(final String parameterName, final Object newValue) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    if ("sp".equals(parameterName) ) {
    	this.fSp = (Concept.SwitchPosition) newValue;
    	return true;
    }
    if ("self".equals(parameterName) ) {
    	this.fSelf = (Concept.Sensor) newValue;
    	return true;
    }
    return false;
    
  }
  
  public void setSp(final SwitchPosition pSp) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSp = pSp;
    
  }
  
  public void setSelf(final Sensor pSelf) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSelf = pSelf;
    
  }
  
  @Override
  public String patternName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ocl2iq.RouteSensor_0";
    
  }
  
  @Override
  public List<String> parameterNames() {
    return RouteSensor_0Match.parameterNames;
    
  }
  
  @Override
  public Object[] toArray() {
    return new Object[]{fSp, fSelf};
    
  }
  
  @Override
  public String prettyPrint() {
    StringBuilder result = new StringBuilder();
    result.append("\"sp\"=" + prettyPrintValue(fSp) + ", ");
    result.append("\"self\"=" + prettyPrintValue(fSelf));
    return result.toString();
    
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fSp == null) ? 0 : fSp.hashCode());
    result = prime * result + ((fSelf == null) ? 0 : fSelf.hashCode());
    return result;
    
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
    	return true;
    if (!(obj instanceof RouteSensor_0Match)) { // this should be infrequent
    	if (obj == null)
    		return false;
    	if (!(obj instanceof IPatternMatch))
    		return false;
    	IPatternMatch otherSig  = (IPatternMatch) obj;
    	if (!specification().equals(otherSig.specification()))
    		return false;
    	return Arrays.deepEquals(toArray(), otherSig.toArray());
    }
    RouteSensor_0Match other = (RouteSensor_0Match) obj;
    if (fSp == null) {if (other.fSp != null) return false;}
    else if (!fSp.equals(other.fSp)) return false;
    if (fSelf == null) {if (other.fSelf != null) return false;}
    else if (!fSelf.equals(other.fSelf)) return false;
    return true;
  }
  
  @Override
  public RouteSensor_0QuerySpecification specification() {
    try {
    	return RouteSensor_0QuerySpecification.instance();
    } catch (IncQueryException ex) {
     	// This cannot happen, as the match object can only be instantiated if the query specification exists
     	throw new IllegalStateException	(ex);
    }
    
  }
  
  @SuppressWarnings("all")
  static final class Mutable extends RouteSensor_0Match {
    Mutable(final SwitchPosition pSp, final Sensor pSelf) {
      super(pSp, pSelf);
      
    }
    
    @Override
    public boolean isMutable() {
      return true;
    }
  }
  
  
  @SuppressWarnings("all")
  static final class Immutable extends RouteSensor_0Match {
    Immutable(final SwitchPosition pSp, final Sensor pSelf) {
      super(pSp, pSelf);
      
    }
    
    @Override
    public boolean isMutable() {
      return false;
    }
  }
  
}
