package hu.bme.mit.train.constraintcheck.incquery.ocl2iq;

import Concept.Route;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SignalNeighborMatch;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util.SignalNeighborQuerySpecification;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.incquery.runtime.api.IMatchProcessor;
import org.eclipse.incquery.runtime.api.IQuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseMatcher;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.matchers.tuple.Tuple;
import org.eclipse.incquery.runtime.rete.misc.DeltaMonitor;

/**
 * Generated pattern matcher API of the hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SignalNeighbor pattern,
 * providing pattern-specific query methods.
 * 
 * <p>Use the pattern matcher on a given model via {@link #on(IncQueryEngine)},
 * e.g. in conjunction with {@link IncQueryEngine#on(Notifier)}.
 * 
 * <p>Matches of the pattern will be represented as {@link SignalNeighborMatch}.
 * 
 * <p>Original source:
 * <code><pre>
 * // expected result: 2
 * 
 * pattern SignalNeighbor(
 * 	self : Route
 * ) {
 * 	Route(route);
 * 	self == route;
 * 	Route.Route_exit(self, signal);
 * 	signal_1 == signal;
 * 	Route.Route_routeDefinition(self, sensor);
 * 	temp1 == sensor;
 * 	Sensor.Sensor_trackElement(temp1, trackelement);
 * 	temp2 == trackelement;
 * 	Trackelement.TrackElement_connectsTo(temp2, trackelement_0);
 * 	temp3 == trackelement_0;
 * 	Trackelement.TrackElement_sensor(temp3, sensor_0);
 * 	sen2 == sensor_0;
 * 	Route(route_0);
 * 	route2X == route_0;
 * 	route2X != self;
 * 	Route.Route_routeDefinition(route2X, sensor_1);
 * 	sensor_1 == sen2;
 * 	neg find SignalNeighbor_4(sen2, signal_1);
 * }
 * </pre></code>
 * 
 * @see SignalNeighborMatch
 * @see SignalNeighborProcessor
 * @see SignalNeighborQuerySpecification
 * 
 */
@SuppressWarnings("all")
public class SignalNeighborMatcher extends BaseMatcher<SignalNeighborMatch> {
  /**
   * @return the singleton instance of the query specification of this pattern
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static IQuerySpecification<SignalNeighborMatcher> querySpecification() throws IncQueryException {
    return SignalNeighborQuerySpecification.instance();
  }
  
  /**
   * Initializes the pattern matcher within an existing EMF-IncQuery engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing EMF-IncQuery engine in which this matcher will be created.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * 
   */
  public static SignalNeighborMatcher on(final IncQueryEngine engine) throws IncQueryException {
    // check if matcher already exists
    SignalNeighborMatcher matcher = engine.getExistingMatcher(querySpecification());
    if (matcher == null) {
    	matcher = new SignalNeighborMatcher(engine);
    	// do not have to "put" it into engine.matchers, reportMatcherInitialized() will take care of it
    }
    return matcher;
  }
  
  private final static int POSITION_SELF = 0;
  
  /**
   * Initializes the pattern matcher over a given EMF model root (recommended: Resource or ResourceSet).
   * If a pattern matcher is already constructed with the same root, only a light-weight reference is returned.
   * The scope of pattern matching will be the given EMF model root and below (see FAQ for more precise definition).
   * The match set will be incrementally refreshed upon updates from this scope.
   * <p>The matcher will be created within the managed {@link IncQueryEngine} belonging to the EMF model root, so
   * multiple matchers will reuse the same engine and benefit from increased performance and reduced memory footprint.
   * @param emfRoot the root of the EMF containment hierarchy where the pattern matcher will operate. Recommended: Resource or ResourceSet.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * @deprecated use {@link #on(IncQueryEngine)} instead, e.g. in conjunction with {@link IncQueryEngine#on(Notifier)}
   * 
   */
  @Deprecated
  public SignalNeighborMatcher(final Notifier emfRoot) throws IncQueryException {
    this(IncQueryEngine.on(emfRoot));
  }
  
  /**
   * Initializes the pattern matcher within an existing EMF-IncQuery engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing EMF-IncQuery engine in which this matcher will be created.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * @deprecated use {@link #on(IncQueryEngine)} instead
   * 
   */
  @Deprecated
  public SignalNeighborMatcher(final IncQueryEngine engine) throws IncQueryException {
    super(engine, querySpecification());
  }
  
  /**
   * Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @return matches represented as a SignalNeighborMatch object.
   * 
   */
  public Collection<SignalNeighborMatch> getAllMatches(final Route pSelf) {
    return rawGetAllMatches(new Object[]{pSelf});
  }
  
  /**
   * Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @return a match represented as a SignalNeighborMatch object, or null if no match is found.
   * 
   */
  public SignalNeighborMatch getOneArbitraryMatch(final Route pSelf) {
    return rawGetOneArbitraryMatch(new Object[]{pSelf});
  }
  
  /**
   * Indicates whether the given combination of specified pattern parameters constitute a valid pattern match,
   * under any possible substitution of the unspecified parameters (if any).
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @return true if the input is a valid (partial) match of the pattern.
   * 
   */
  public boolean hasMatch(final Route pSelf) {
    return rawHasMatch(new Object[]{pSelf});
  }
  
  /**
   * Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @return the number of pattern matches found.
   * 
   */
  public int countMatches(final Route pSelf) {
    return rawCountMatches(new Object[]{pSelf});
  }
  
  /**
   * Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @param processor the action that will process each pattern match.
   * 
   */
  public void forEachMatch(final Route pSelf, final IMatchProcessor<? super SignalNeighborMatch> processor) {
    rawForEachMatch(new Object[]{pSelf}, processor);
  }
  
  /**
   * Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @param processor the action that will process the selected match.
   * @return true if the pattern has at least one match with the given parameter values, false if the processor was not invoked
   * 
   */
  public boolean forOneArbitraryMatch(final Route pSelf, final IMatchProcessor<? super SignalNeighborMatch> processor) {
    return rawForOneArbitraryMatch(new Object[]{pSelf}, processor);
  }
  
  /**
   * Registers a new filtered delta monitor on this pattern matcher.
   * The DeltaMonitor can be used to track changes (delta) in the set of filtered pattern matches from now on, considering those matches only that conform to the given fixed values of some parameters.
   * It can also be reset to track changes from a later point in time,
   * and changes can even be acknowledged on an individual basis.
   * See {@link DeltaMonitor} for details.
   * @param fillAtStart if true, all current matches are reported as new match events; if false, the delta monitor starts empty.
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @return the delta monitor.
   * @deprecated use the IncQuery Databinding API (IncQueryObservables) instead.
   * 
   */
  @Deprecated
  public DeltaMonitor<SignalNeighborMatch> newFilteredDeltaMonitor(final boolean fillAtStart, final Route pSelf) {
    return rawNewFilteredDeltaMonitor(fillAtStart, new Object[]{pSelf});
  }
  
  /**
   * Returns a new (partial) Match object for the matcher.
   * This can be used e.g. to call the matcher with a partial match.
   * <p>The returned match will be immutable. Use {@link #newEmptyMatch()} to obtain a mutable match object.
   * @param pSelf the fixed value of pattern parameter self, or null if not bound.
   * @return the (partial) match object.
   * 
   */
  public SignalNeighborMatch newMatch(final Route pSelf) {
    return new SignalNeighborMatch.Immutable(pSelf);
    
  }
  
  /**
   * Retrieve the set of values that occur in matches for self.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  protected Set<Route> rawAccumulateAllValuesOfself(final Object[] parameters) {
    Set<Route> results = new HashSet<Route>();
    rawAccumulateAllValues(POSITION_SELF, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for self.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Route> getAllValuesOfself() {
    return rawAccumulateAllValuesOfself(emptyArray());
  }
  
  @Override
  protected SignalNeighborMatch tupleToMatch(final Tuple t) {
    try {
    	return new SignalNeighborMatch.Immutable((Concept.Route) t.get(POSITION_SELF));
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in tuple not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
  
  @Override
  protected SignalNeighborMatch arrayToMatch(final Object[] match) {
    try {
    	return new SignalNeighborMatch.Immutable((Concept.Route) match[POSITION_SELF]);
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in array not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
  
  @Override
  protected SignalNeighborMatch arrayToMatchMutable(final Object[] match) {
    try {
    	return new SignalNeighborMatch.Mutable((Concept.Route) match[POSITION_SELF]);
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in array not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
}
