package hu.bme.mit.train.constraintcheck.incquery.ocl2iq;

import Concept.Sensor;
import Concept.Signal;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util.SignalNeighbor_4QuerySpecification;
import java.util.Arrays;
import java.util.List;
import org.eclipse.incquery.runtime.api.IPatternMatch;
import org.eclipse.incquery.runtime.api.impl.BasePatternMatch;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * Pattern-specific match representation of the hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SignalNeighbor_4 pattern,
 * to be used in conjunction with {@link SignalNeighbor_4Matcher}.
 * 
 * <p>Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters,
 * usable to represent a match of the pattern in the result of a query,
 * or to specify the bound (fixed) input parameters when issuing a query.
 * 
 * @see SignalNeighbor_4Matcher
 * @see SignalNeighbor_4Processor
 * 
 */
@SuppressWarnings("all")
public abstract class SignalNeighbor_4Match extends BasePatternMatch {
  private Sensor fSen2;
  
  private Signal fSignal_1;
  
  private static List<String> parameterNames = makeImmutableList("sen2", "signal_1");
  
  private SignalNeighbor_4Match(final Sensor pSen2, final Signal pSignal_1) {
    this.fSen2 = pSen2;
    this.fSignal_1 = pSignal_1;
    
  }
  
  @Override
  public Object get(final String parameterName) {
    if ("sen2".equals(parameterName)) return this.fSen2;
    if ("signal_1".equals(parameterName)) return this.fSignal_1;
    return null;
    
  }
  
  public Sensor getSen2() {
    return this.fSen2;
    
  }
  
  public Signal getSignal_1() {
    return this.fSignal_1;
    
  }
  
  @Override
  public boolean set(final String parameterName, final Object newValue) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    if ("sen2".equals(parameterName) ) {
    	this.fSen2 = (Concept.Sensor) newValue;
    	return true;
    }
    if ("signal_1".equals(parameterName) ) {
    	this.fSignal_1 = (Concept.Signal) newValue;
    	return true;
    }
    return false;
    
  }
  
  public void setSen2(final Sensor pSen2) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSen2 = pSen2;
    
  }
  
  public void setSignal_1(final Signal pSignal_1) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSignal_1 = pSignal_1;
    
  }
  
  @Override
  public String patternName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SignalNeighbor_4";
    
  }
  
  @Override
  public List<String> parameterNames() {
    return SignalNeighbor_4Match.parameterNames;
    
  }
  
  @Override
  public Object[] toArray() {
    return new Object[]{fSen2, fSignal_1};
    
  }
  
  @Override
  public String prettyPrint() {
    StringBuilder result = new StringBuilder();
    result.append("\"sen2\"=" + prettyPrintValue(fSen2) + ", ");
    result.append("\"signal_1\"=" + prettyPrintValue(fSignal_1));
    return result.toString();
    
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fSen2 == null) ? 0 : fSen2.hashCode());
    result = prime * result + ((fSignal_1 == null) ? 0 : fSignal_1.hashCode());
    return result;
    
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
    	return true;
    if (!(obj instanceof SignalNeighbor_4Match)) { // this should be infrequent
    	if (obj == null)
    		return false;
    	if (!(obj instanceof IPatternMatch))
    		return false;
    	IPatternMatch otherSig  = (IPatternMatch) obj;
    	if (!specification().equals(otherSig.specification()))
    		return false;
    	return Arrays.deepEquals(toArray(), otherSig.toArray());
    }
    SignalNeighbor_4Match other = (SignalNeighbor_4Match) obj;
    if (fSen2 == null) {if (other.fSen2 != null) return false;}
    else if (!fSen2.equals(other.fSen2)) return false;
    if (fSignal_1 == null) {if (other.fSignal_1 != null) return false;}
    else if (!fSignal_1.equals(other.fSignal_1)) return false;
    return true;
  }
  
  @Override
  public SignalNeighbor_4QuerySpecification specification() {
    try {
    	return SignalNeighbor_4QuerySpecification.instance();
    } catch (IncQueryException ex) {
     	// This cannot happen, as the match object can only be instantiated if the query specification exists
     	throw new IllegalStateException	(ex);
    }
    
  }
  
  @SuppressWarnings("all")
  static final class Mutable extends SignalNeighbor_4Match {
    Mutable(final Sensor pSen2, final Signal pSignal_1) {
      super(pSen2, pSignal_1);
      
    }
    
    @Override
    public boolean isMutable() {
      return true;
    }
  }
  
  
  @SuppressWarnings("all")
  static final class Immutable extends SignalNeighbor_4Match {
    Immutable(final Sensor pSen2, final Signal pSignal_1) {
      super(pSen2, pSignal_1);
      
    }
    
    @Override
    public boolean isMutable() {
      return false;
    }
  }
  
}
