package hu.bme.mit.train.constraintcheck.incquery.ocl2iq;

import Concept.Sensor;
import Concept.Signal;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SignalNeighbor_4Match;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util.SignalNeighbor_4QuerySpecification;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.incquery.runtime.api.IMatchProcessor;
import org.eclipse.incquery.runtime.api.IQuerySpecification;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseMatcher;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.matchers.tuple.Tuple;
import org.eclipse.incquery.runtime.rete.misc.DeltaMonitor;

/**
 * Generated pattern matcher API of the hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SignalNeighbor_4 pattern,
 * providing pattern-specific query methods.
 * 
 * <p>Use the pattern matcher on a given model via {@link #on(IncQueryEngine)},
 * e.g. in conjunction with {@link IncQueryEngine#on(Notifier)}.
 * 
 * <p>Matches of the pattern will be represented as {@link SignalNeighbor_4Match}.
 * 
 * <p>Original source:
 * <code><pre>
 * pattern SignalNeighbor_4(
 * 	sen2 : Sensor,
 * 	signal_1 : Signal
 * ) {
 * 	Route(route_1);
 * 	route2 == route_1;
 * 	Route.Route_routeDefinition(route2, sensor_2);
 * 	sensor_2 == sen2;
 * 	Route.Route_entry(route2, signal_0);
 * 	signal_0 == signal_1;
 * }
 * </pre></code>
 * 
 * @see SignalNeighbor_4Match
 * @see SignalNeighbor_4Processor
 * @see SignalNeighbor_4QuerySpecification
 * 
 */
@SuppressWarnings("all")
public class SignalNeighbor_4Matcher extends BaseMatcher<SignalNeighbor_4Match> {
  /**
   * @return the singleton instance of the query specification of this pattern
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static IQuerySpecification<SignalNeighbor_4Matcher> querySpecification() throws IncQueryException {
    return SignalNeighbor_4QuerySpecification.instance();
  }
  
  /**
   * Initializes the pattern matcher within an existing EMF-IncQuery engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing EMF-IncQuery engine in which this matcher will be created.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * 
   */
  public static SignalNeighbor_4Matcher on(final IncQueryEngine engine) throws IncQueryException {
    // check if matcher already exists
    SignalNeighbor_4Matcher matcher = engine.getExistingMatcher(querySpecification());
    if (matcher == null) {
    	matcher = new SignalNeighbor_4Matcher(engine);
    	// do not have to "put" it into engine.matchers, reportMatcherInitialized() will take care of it
    }
    return matcher;
  }
  
  private final static int POSITION_SEN2 = 0;
  
  private final static int POSITION_SIGNAL_1 = 1;
  
  /**
   * Initializes the pattern matcher over a given EMF model root (recommended: Resource or ResourceSet).
   * If a pattern matcher is already constructed with the same root, only a light-weight reference is returned.
   * The scope of pattern matching will be the given EMF model root and below (see FAQ for more precise definition).
   * The match set will be incrementally refreshed upon updates from this scope.
   * <p>The matcher will be created within the managed {@link IncQueryEngine} belonging to the EMF model root, so
   * multiple matchers will reuse the same engine and benefit from increased performance and reduced memory footprint.
   * @param emfRoot the root of the EMF containment hierarchy where the pattern matcher will operate. Recommended: Resource or ResourceSet.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * @deprecated use {@link #on(IncQueryEngine)} instead, e.g. in conjunction with {@link IncQueryEngine#on(Notifier)}
   * 
   */
  @Deprecated
  public SignalNeighbor_4Matcher(final Notifier emfRoot) throws IncQueryException {
    this(IncQueryEngine.on(emfRoot));
  }
  
  /**
   * Initializes the pattern matcher within an existing EMF-IncQuery engine.
   * If the pattern matcher is already constructed in the engine, only a light-weight reference is returned.
   * The match set will be incrementally refreshed upon updates.
   * @param engine the existing EMF-IncQuery engine in which this matcher will be created.
   * @throws IncQueryException if an error occurs during pattern matcher creation
   * @deprecated use {@link #on(IncQueryEngine)} instead
   * 
   */
  @Deprecated
  public SignalNeighbor_4Matcher(final IncQueryEngine engine) throws IncQueryException {
    super(engine, querySpecification());
  }
  
  /**
   * Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pSen2 the fixed value of pattern parameter sen2, or null if not bound.
   * @param pSignal_1 the fixed value of pattern parameter signal_1, or null if not bound.
   * @return matches represented as a SignalNeighbor_4Match object.
   * 
   */
  public Collection<SignalNeighbor_4Match> getAllMatches(final Sensor pSen2, final Signal pSignal_1) {
    return rawGetAllMatches(new Object[]{pSen2, pSignal_1});
  }
  
  /**
   * Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pSen2 the fixed value of pattern parameter sen2, or null if not bound.
   * @param pSignal_1 the fixed value of pattern parameter signal_1, or null if not bound.
   * @return a match represented as a SignalNeighbor_4Match object, or null if no match is found.
   * 
   */
  public SignalNeighbor_4Match getOneArbitraryMatch(final Sensor pSen2, final Signal pSignal_1) {
    return rawGetOneArbitraryMatch(new Object[]{pSen2, pSignal_1});
  }
  
  /**
   * Indicates whether the given combination of specified pattern parameters constitute a valid pattern match,
   * under any possible substitution of the unspecified parameters (if any).
   * @param pSen2 the fixed value of pattern parameter sen2, or null if not bound.
   * @param pSignal_1 the fixed value of pattern parameter signal_1, or null if not bound.
   * @return true if the input is a valid (partial) match of the pattern.
   * 
   */
  public boolean hasMatch(final Sensor pSen2, final Signal pSignal_1) {
    return rawHasMatch(new Object[]{pSen2, pSignal_1});
  }
  
  /**
   * Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
   * @param pSen2 the fixed value of pattern parameter sen2, or null if not bound.
   * @param pSignal_1 the fixed value of pattern parameter signal_1, or null if not bound.
   * @return the number of pattern matches found.
   * 
   */
  public int countMatches(final Sensor pSen2, final Signal pSignal_1) {
    return rawCountMatches(new Object[]{pSen2, pSignal_1});
  }
  
  /**
   * Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
   * @param pSen2 the fixed value of pattern parameter sen2, or null if not bound.
   * @param pSignal_1 the fixed value of pattern parameter signal_1, or null if not bound.
   * @param processor the action that will process each pattern match.
   * 
   */
  public void forEachMatch(final Sensor pSen2, final Signal pSignal_1, final IMatchProcessor<? super SignalNeighbor_4Match> processor) {
    rawForEachMatch(new Object[]{pSen2, pSignal_1}, processor);
  }
  
  /**
   * Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
   * Neither determinism nor randomness of selection is guaranteed.
   * @param pSen2 the fixed value of pattern parameter sen2, or null if not bound.
   * @param pSignal_1 the fixed value of pattern parameter signal_1, or null if not bound.
   * @param processor the action that will process the selected match.
   * @return true if the pattern has at least one match with the given parameter values, false if the processor was not invoked
   * 
   */
  public boolean forOneArbitraryMatch(final Sensor pSen2, final Signal pSignal_1, final IMatchProcessor<? super SignalNeighbor_4Match> processor) {
    return rawForOneArbitraryMatch(new Object[]{pSen2, pSignal_1}, processor);
  }
  
  /**
   * Registers a new filtered delta monitor on this pattern matcher.
   * The DeltaMonitor can be used to track changes (delta) in the set of filtered pattern matches from now on, considering those matches only that conform to the given fixed values of some parameters.
   * It can also be reset to track changes from a later point in time,
   * and changes can even be acknowledged on an individual basis.
   * See {@link DeltaMonitor} for details.
   * @param fillAtStart if true, all current matches are reported as new match events; if false, the delta monitor starts empty.
   * @param pSen2 the fixed value of pattern parameter sen2, or null if not bound.
   * @param pSignal_1 the fixed value of pattern parameter signal_1, or null if not bound.
   * @return the delta monitor.
   * @deprecated use the IncQuery Databinding API (IncQueryObservables) instead.
   * 
   */
  @Deprecated
  public DeltaMonitor<SignalNeighbor_4Match> newFilteredDeltaMonitor(final boolean fillAtStart, final Sensor pSen2, final Signal pSignal_1) {
    return rawNewFilteredDeltaMonitor(fillAtStart, new Object[]{pSen2, pSignal_1});
  }
  
  /**
   * Returns a new (partial) Match object for the matcher.
   * This can be used e.g. to call the matcher with a partial match.
   * <p>The returned match will be immutable. Use {@link #newEmptyMatch()} to obtain a mutable match object.
   * @param pSen2 the fixed value of pattern parameter sen2, or null if not bound.
   * @param pSignal_1 the fixed value of pattern parameter signal_1, or null if not bound.
   * @return the (partial) match object.
   * 
   */
  public SignalNeighbor_4Match newMatch(final Sensor pSen2, final Signal pSignal_1) {
    return new SignalNeighbor_4Match.Immutable(pSen2, pSignal_1);
    
  }
  
  /**
   * Retrieve the set of values that occur in matches for sen2.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  protected Set<Sensor> rawAccumulateAllValuesOfsen2(final Object[] parameters) {
    Set<Sensor> results = new HashSet<Sensor>();
    rawAccumulateAllValues(POSITION_SEN2, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for sen2.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Sensor> getAllValuesOfsen2() {
    return rawAccumulateAllValuesOfsen2(emptyArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for sen2.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Sensor> getAllValuesOfsen2(final SignalNeighbor_4Match partialMatch) {
    return rawAccumulateAllValuesOfsen2(partialMatch.toArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for sen2.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Sensor> getAllValuesOfsen2(final Signal pSignal_1) {
    return rawAccumulateAllValuesOfsen2(new Object[]{null, pSignal_1});
  }
  
  /**
   * Retrieve the set of values that occur in matches for signal_1.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  protected Set<Signal> rawAccumulateAllValuesOfsignal_1(final Object[] parameters) {
    Set<Signal> results = new HashSet<Signal>();
    rawAccumulateAllValues(POSITION_SIGNAL_1, parameters, results);
    return results;
  }
  
  /**
   * Retrieve the set of values that occur in matches for signal_1.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Signal> getAllValuesOfsignal_1() {
    return rawAccumulateAllValuesOfsignal_1(emptyArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for signal_1.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Signal> getAllValuesOfsignal_1(final SignalNeighbor_4Match partialMatch) {
    return rawAccumulateAllValuesOfsignal_1(partialMatch.toArray());
  }
  
  /**
   * Retrieve the set of values that occur in matches for signal_1.
   * @return the Set of all values, null if no parameter with the given name exists, empty set if there are no matches
   * 
   */
  public Set<Signal> getAllValuesOfsignal_1(final Sensor pSen2) {
    return rawAccumulateAllValuesOfsignal_1(new Object[]{pSen2, null});
  }
  
  @Override
  protected SignalNeighbor_4Match tupleToMatch(final Tuple t) {
    try {
    	return new SignalNeighbor_4Match.Immutable((Concept.Sensor) t.get(POSITION_SEN2), (Concept.Signal) t.get(POSITION_SIGNAL_1));
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in tuple not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
  
  @Override
  protected SignalNeighbor_4Match arrayToMatch(final Object[] match) {
    try {
    	return new SignalNeighbor_4Match.Immutable((Concept.Sensor) match[POSITION_SEN2], (Concept.Signal) match[POSITION_SIGNAL_1]);
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in array not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
  
  @Override
  protected SignalNeighbor_4Match arrayToMatchMutable(final Object[] match) {
    try {
    	return new SignalNeighbor_4Match.Mutable((Concept.Sensor) match[POSITION_SEN2], (Concept.Signal) match[POSITION_SIGNAL_1]);
    } catch(ClassCastException e) {engine.getLogger().error("Element(s) in array not properly typed!",e);	//throw new IncQueryRuntimeException(e.getMessage());
    	return null;
    }
    
  }
}
