package hu.bme.mit.train.constraintcheck.incquery.ocl2iq;

import Concept.Sensor;
import Concept.Switch;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util.SwitchSensor_0QuerySpecification;
import java.util.Arrays;
import java.util.List;
import org.eclipse.incquery.runtime.api.IPatternMatch;
import org.eclipse.incquery.runtime.api.impl.BasePatternMatch;
import org.eclipse.incquery.runtime.exception.IncQueryException;

/**
 * Pattern-specific match representation of the hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SwitchSensor_0 pattern,
 * to be used in conjunction with {@link SwitchSensor_0Matcher}.
 * 
 * <p>Class fields correspond to parameters of the pattern. Fields with value null are considered unassigned.
 * Each instance is a (possibly partial) substitution of pattern parameters,
 * usable to represent a match of the pattern in the result of a query,
 * or to specify the bound (fixed) input parameters when issuing a query.
 * 
 * @see SwitchSensor_0Matcher
 * @see SwitchSensor_0Processor
 * 
 */
@SuppressWarnings("all")
public abstract class SwitchSensor_0Match extends BasePatternMatch {
  private Switch fSelf;
  
  private Sensor fSensor;
  
  private static List<String> parameterNames = makeImmutableList("self", "sensor");
  
  private SwitchSensor_0Match(final Switch pSelf, final Sensor pSensor) {
    this.fSelf = pSelf;
    this.fSensor = pSensor;
    
  }
  
  @Override
  public Object get(final String parameterName) {
    if ("self".equals(parameterName)) return this.fSelf;
    if ("sensor".equals(parameterName)) return this.fSensor;
    return null;
    
  }
  
  public Switch getSelf() {
    return this.fSelf;
    
  }
  
  public Sensor getSensor() {
    return this.fSensor;
    
  }
  
  @Override
  public boolean set(final String parameterName, final Object newValue) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    if ("self".equals(parameterName) ) {
    	this.fSelf = (Concept.Switch) newValue;
    	return true;
    }
    if ("sensor".equals(parameterName) ) {
    	this.fSensor = (Concept.Sensor) newValue;
    	return true;
    }
    return false;
    
  }
  
  public void setSelf(final Switch pSelf) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSelf = pSelf;
    
  }
  
  public void setSensor(final Sensor pSensor) {
    if (!isMutable()) throw new java.lang.UnsupportedOperationException();
    this.fSensor = pSensor;
    
  }
  
  @Override
  public String patternName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SwitchSensor_0";
    
  }
  
  @Override
  public List<String> parameterNames() {
    return SwitchSensor_0Match.parameterNames;
    
  }
  
  @Override
  public Object[] toArray() {
    return new Object[]{fSelf, fSensor};
    
  }
  
  @Override
  public String prettyPrint() {
    StringBuilder result = new StringBuilder();
    result.append("\"self\"=" + prettyPrintValue(fSelf) + ", ");
    result.append("\"sensor\"=" + prettyPrintValue(fSensor));
    return result.toString();
    
  }
  
  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((fSelf == null) ? 0 : fSelf.hashCode());
    result = prime * result + ((fSensor == null) ? 0 : fSensor.hashCode());
    return result;
    
  }
  
  @Override
  public boolean equals(final Object obj) {
    if (this == obj)
    	return true;
    if (!(obj instanceof SwitchSensor_0Match)) { // this should be infrequent
    	if (obj == null)
    		return false;
    	if (!(obj instanceof IPatternMatch))
    		return false;
    	IPatternMatch otherSig  = (IPatternMatch) obj;
    	if (!specification().equals(otherSig.specification()))
    		return false;
    	return Arrays.deepEquals(toArray(), otherSig.toArray());
    }
    SwitchSensor_0Match other = (SwitchSensor_0Match) obj;
    if (fSelf == null) {if (other.fSelf != null) return false;}
    else if (!fSelf.equals(other.fSelf)) return false;
    if (fSensor == null) {if (other.fSensor != null) return false;}
    else if (!fSensor.equals(other.fSensor)) return false;
    return true;
  }
  
  @Override
  public SwitchSensor_0QuerySpecification specification() {
    try {
    	return SwitchSensor_0QuerySpecification.instance();
    } catch (IncQueryException ex) {
     	// This cannot happen, as the match object can only be instantiated if the query specification exists
     	throw new IllegalStateException	(ex);
    }
    
  }
  
  @SuppressWarnings("all")
  static final class Mutable extends SwitchSensor_0Match {
    Mutable(final Switch pSelf, final Sensor pSensor) {
      super(pSelf, pSensor);
      
    }
    
    @Override
    public boolean isMutable() {
      return true;
    }
  }
  
  
  @SuppressWarnings("all")
  static final class Immutable extends SwitchSensor_0Match {
    Immutable(final Switch pSelf, final Sensor pSensor) {
      super(pSelf, pSensor);
      
    }
    
    @Override
    public boolean isMutable() {
      return false;
    }
  }
  
}
