package hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util;

import Concept.Segment;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.PosLengthMatch;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.ocl2iq.PosLength pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class PosLengthProcessor implements IMatchProcessor<PosLengthMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSelf the value of pattern parameter self in the currently processed match
   * 
   */
  public abstract void process(final Segment pSelf);
  
  @Override
  public void process(final PosLengthMatch match) {
    process(match.getSelf());
    
  }
}
