package hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util;

import com.google.common.collect.Sets;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.PosLengthMatcher;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedQuerySpecification;
import org.eclipse.incquery.runtime.context.EMFPatternMatcherContext;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.extensibility.IQuerySpecificationProvider;
import org.eclipse.incquery.runtime.matchers.psystem.IExpressionEvaluator;
import org.eclipse.incquery.runtime.matchers.psystem.IValueProvider;
import org.eclipse.incquery.runtime.matchers.psystem.PBody;
import org.eclipse.incquery.runtime.matchers.psystem.PParameter;
import org.eclipse.incquery.runtime.matchers.psystem.PQuery;
import org.eclipse.incquery.runtime.matchers.psystem.PVariable;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExportedParameter;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExpressionEvaluation;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.ConstantValue;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeBinary;

/**
 * A pattern-specific query specification that can instantiate PosLengthMatcher in a type-safe way.
 * 
 * @see PosLengthMatcher
 * @see PosLengthMatch
 * 
 */
@SuppressWarnings("all")
public final class PosLengthQuerySpecification extends BaseGeneratedQuerySpecification<PosLengthMatcher> {
  /**
   * @return the singleton instance of the query specification
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static PosLengthQuerySpecification instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected PosLengthMatcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return PosLengthMatcher.on(engine);
  }
  
  @Override
  public String getFullyQualifiedName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ocl2iq.PosLength";
    
  }
  
  @Override
  public List<String> getParameterNames() {
    return Arrays.asList("self");
  }
  
  @Override
  public List<PParameter> getParameters() {
    return Arrays.asList(new PParameter("self", "Concept.Segment"));
  }
  
  @Override
  public Set<PBody> doGetContainedBodies() throws IncQueryException {
    EMFPatternMatcherContext context = new EMFPatternMatcherContext();
    Set<PBody> bodies = Sets.newHashSet();
    {
      PBody body = new PBody(this);
      PVariable var_segment = body.getOrCreateVariableByName("segment");
      PVariable var_eInt = body.getOrCreateVariableByName("eInt");
      PVariable var_integer = body.getOrCreateVariableByName("integer");
      PVariable var_boolean_0 = body.getOrCreateVariableByName("boolean_0");
      body.setExportedParameters(Arrays.asList(
        new ExportedParameter(body, var_segment, "self")
      ));
      
      new TypeBinary(body, context, var_segment, var_eInt, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Segment", "Segment_length"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Segment.Segment_length");
      new ConstantValue(body, var_integer, 0);
      new ExpressionEvaluation(body, new IExpressionEvaluator() {
        @Override
        public String getShortDescription() {
        	return "Expression evaluation from pattern PosLength";
        }
        
        @Override
        public Iterable<String> getInputParameterNames() {
        	return Arrays.asList("eInt", "integer");
        }
        
        @Override
        public Object evaluateExpression(IValueProvider provider) throws Exception {
        	java.lang.Integer eInt = (java.lang.Integer) provider.getValue("eInt");
        	java.lang.Integer integer = (java.lang.Integer) provider.getValue("integer");
        	return evaluateExpression_1_1(eInt, integer);
        }
        
        },  var_boolean_0 ); 
      new ConstantValue(body, var_boolean_0, true);
      bodies.add(body);
    }setStatus(PQuery.PQueryStatus.OK);
    return bodies;
  }
  
  private PosLengthQuerySpecification() throws IncQueryException {
    super();
    setStatus(PQuery.PQueryStatus.UNINITIALIZED);
  }
  
  @SuppressWarnings("all")
  public static class Provider implements IQuerySpecificationProvider<PosLengthQuerySpecification> {
    @Override
    public PosLengthQuerySpecification get() throws IncQueryException {
      return instance();
    }
  }
  
  
  @SuppressWarnings("all")
  private static class LazyHolder {
    private final static PosLengthQuerySpecification INSTANCE = make();
    
    public static PosLengthQuerySpecification make() {
      try {
      	return new PosLengthQuerySpecification();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
  
  private boolean evaluateExpression_1_1(final Integer eInt, final Integer integer) {
    return (((int) (eInt).intValue()) <= (((Integer) integer)).intValue());
  }
}
