package hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util;

import Concept.Sensor;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.RouteSensorMatch;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.ocl2iq.RouteSensor pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class RouteSensorProcessor implements IMatchProcessor<RouteSensorMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSelf the value of pattern parameter self in the currently processed match
   * 
   */
  public abstract void process(final Sensor pSelf);
  
  @Override
  public void process(final RouteSensorMatch match) {
    process(match.getSelf());
    
  }
}
