package hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util;

import Concept.Route;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SignalNeighborMatch;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SignalNeighbor pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class SignalNeighborProcessor implements IMatchProcessor<SignalNeighborMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSelf the value of pattern parameter self in the currently processed match
   * 
   */
  public abstract void process(final Route pSelf);
  
  @Override
  public void process(final SignalNeighborMatch match) {
    process(match.getSelf());
    
  }
}
