package hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util;

import Concept.Sensor;
import Concept.Signal;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SignalNeighbor_4Match;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SignalNeighbor_4 pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class SignalNeighbor_4Processor implements IMatchProcessor<SignalNeighbor_4Match> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSen2 the value of pattern parameter sen2 in the currently processed match
   * @param pSignal_1 the value of pattern parameter signal_1 in the currently processed match
   * 
   */
  public abstract void process(final Sensor pSen2, final Signal pSignal_1);
  
  @Override
  public void process(final SignalNeighbor_4Match match) {
    process(match.getSen2(), match.getSignal_1());
    
  }
}
