package hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util;

import com.google.common.collect.Sets;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SignalNeighbor_4Matcher;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedQuerySpecification;
import org.eclipse.incquery.runtime.context.EMFPatternMatcherContext;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.extensibility.IQuerySpecificationProvider;
import org.eclipse.incquery.runtime.matchers.psystem.PBody;
import org.eclipse.incquery.runtime.matchers.psystem.PParameter;
import org.eclipse.incquery.runtime.matchers.psystem.PQuery;
import org.eclipse.incquery.runtime.matchers.psystem.PVariable;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExportedParameter;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeBinary;

/**
 * A pattern-specific query specification that can instantiate SignalNeighbor_4Matcher in a type-safe way.
 * 
 * @see SignalNeighbor_4Matcher
 * @see SignalNeighbor_4Match
 * 
 */
@SuppressWarnings("all")
public final class SignalNeighbor_4QuerySpecification extends BaseGeneratedQuerySpecification<SignalNeighbor_4Matcher> {
  /**
   * @return the singleton instance of the query specification
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static SignalNeighbor_4QuerySpecification instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected SignalNeighbor_4Matcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return SignalNeighbor_4Matcher.on(engine);
  }
  
  @Override
  public String getFullyQualifiedName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SignalNeighbor_4";
    
  }
  
  @Override
  public List<String> getParameterNames() {
    return Arrays.asList("sen2","signal_1");
  }
  
  @Override
  public List<PParameter> getParameters() {
    return Arrays.asList(new PParameter("sen2", "Concept.Sensor"),new PParameter("signal_1", "Concept.Signal"));
  }
  
  @Override
  public Set<PBody> doGetContainedBodies() throws IncQueryException {
    EMFPatternMatcherContext context = new EMFPatternMatcherContext();
    Set<PBody> bodies = Sets.newHashSet();
    {
      PBody body = new PBody(this);
      PVariable var_sen2 = body.getOrCreateVariableByName("sen2");
      PVariable var_signal_1 = body.getOrCreateVariableByName("signal_1");
      PVariable var_route_1 = body.getOrCreateVariableByName("route_1");
      body.setExportedParameters(Arrays.asList(
        new ExportedParameter(body, var_sen2, "sen2"), 
        new ExportedParameter(body, var_signal_1, "signal_1")
      ));
      
      
      new TypeBinary(body, context, var_route_1, var_sen2, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_routeDefinition"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_routeDefinition");
      new TypeBinary(body, context, var_route_1, var_signal_1, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_entry"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_entry");
      bodies.add(body);
    }setStatus(PQuery.PQueryStatus.OK);
    return bodies;
  }
  
  private SignalNeighbor_4QuerySpecification() throws IncQueryException {
    super();
    setStatus(PQuery.PQueryStatus.UNINITIALIZED);
  }
  
  @SuppressWarnings("all")
  public static class Provider implements IQuerySpecificationProvider<SignalNeighbor_4QuerySpecification> {
    @Override
    public SignalNeighbor_4QuerySpecification get() throws IncQueryException {
      return instance();
    }
  }
  
  
  @SuppressWarnings("all")
  private static class LazyHolder {
    private final static SignalNeighbor_4QuerySpecification INSTANCE = make();
    
    public static SignalNeighbor_4QuerySpecification make() {
      try {
      	return new SignalNeighbor_4QuerySpecification();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
}
