package hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util;

import Concept.Switch;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SwitchSensorMatch;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SwitchSensor pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class SwitchSensorProcessor implements IMatchProcessor<SwitchSensorMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSelf the value of pattern parameter self in the currently processed match
   * 
   */
  public abstract void process(final Switch pSelf);
  
  @Override
  public void process(final SwitchSensorMatch match) {
    process(match.getSelf());
    
  }
}
