package hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util;

import com.google.common.collect.Sets;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SwitchSensorMatcher;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util.SwitchSensor_0QuerySpecification;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedQuerySpecification;
import org.eclipse.incquery.runtime.context.EMFPatternMatcherContext;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.extensibility.IQuerySpecificationProvider;
import org.eclipse.incquery.runtime.matchers.psystem.PBody;
import org.eclipse.incquery.runtime.matchers.psystem.PParameter;
import org.eclipse.incquery.runtime.matchers.psystem.PQuery;
import org.eclipse.incquery.runtime.matchers.psystem.PVariable;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExportedParameter;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.NegativePatternCall;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeUnary;
import org.eclipse.incquery.runtime.matchers.tuple.FlatTuple;

/**
 * A pattern-specific query specification that can instantiate SwitchSensorMatcher in a type-safe way.
 * 
 * @see SwitchSensorMatcher
 * @see SwitchSensorMatch
 * 
 */
@SuppressWarnings("all")
public final class SwitchSensorQuerySpecification extends BaseGeneratedQuerySpecification<SwitchSensorMatcher> {
  /**
   * @return the singleton instance of the query specification
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static SwitchSensorQuerySpecification instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected SwitchSensorMatcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return SwitchSensorMatcher.on(engine);
  }
  
  @Override
  public String getFullyQualifiedName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SwitchSensor";
    
  }
  
  @Override
  public List<String> getParameterNames() {
    return Arrays.asList("self");
  }
  
  @Override
  public List<PParameter> getParameters() {
    return Arrays.asList(new PParameter("self", "Concept.Switch"));
  }
  
  @Override
  public Set<PBody> doGetContainedBodies() throws IncQueryException {
    EMFPatternMatcherContext context = new EMFPatternMatcherContext();
    Set<PBody> bodies = Sets.newHashSet();
    {
      PBody body = new PBody(this);
      PVariable var_switch_0 = body.getOrCreateVariableByName("switch_0");
      PVariable var__sensor = body.getOrCreateVariableByName("_sensor");
      body.setExportedParameters(Arrays.asList(
        new ExportedParameter(body, var_switch_0, "self")
      ));
      
      new TypeUnary(body, var_switch_0, getClassifierLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Switch"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Switch");
      new NegativePatternCall(body, new FlatTuple(var_switch_0, var__sensor), SwitchSensor_0QuerySpecification.instance().instance());
      bodies.add(body);
    }setStatus(PQuery.PQueryStatus.OK);
    return bodies;
  }
  
  private SwitchSensorQuerySpecification() throws IncQueryException {
    super();
    setStatus(PQuery.PQueryStatus.UNINITIALIZED);
  }
  
  @SuppressWarnings("all")
  public static class Provider implements IQuerySpecificationProvider<SwitchSensorQuerySpecification> {
    @Override
    public SwitchSensorQuerySpecification get() throws IncQueryException {
      return instance();
    }
  }
  
  
  @SuppressWarnings("all")
  private static class LazyHolder {
    private final static SwitchSensorQuerySpecification INSTANCE = make();
    
    public static SwitchSensorQuerySpecification make() {
      try {
      	return new SwitchSensorQuerySpecification();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
}
