package hu.bme.mit.train.constraintcheck.incquery.ocl2iq.util;

import com.google.common.collect.Sets;
import hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SwitchSensor_0Matcher;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedQuerySpecification;
import org.eclipse.incquery.runtime.context.EMFPatternMatcherContext;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.extensibility.IQuerySpecificationProvider;
import org.eclipse.incquery.runtime.matchers.psystem.PBody;
import org.eclipse.incquery.runtime.matchers.psystem.PParameter;
import org.eclipse.incquery.runtime.matchers.psystem.PQuery;
import org.eclipse.incquery.runtime.matchers.psystem.PVariable;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExportedParameter;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeBinary;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeUnary;

/**
 * A pattern-specific query specification that can instantiate SwitchSensor_0Matcher in a type-safe way.
 * 
 * @see SwitchSensor_0Matcher
 * @see SwitchSensor_0Match
 * 
 */
@SuppressWarnings("all")
public final class SwitchSensor_0QuerySpecification extends BaseGeneratedQuerySpecification<SwitchSensor_0Matcher> {
  /**
   * @return the singleton instance of the query specification
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static SwitchSensor_0QuerySpecification instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected SwitchSensor_0Matcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return SwitchSensor_0Matcher.on(engine);
  }
  
  @Override
  public String getFullyQualifiedName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ocl2iq.SwitchSensor_0";
    
  }
  
  @Override
  public List<String> getParameterNames() {
    return Arrays.asList("self","sensor");
  }
  
  @Override
  public List<PParameter> getParameters() {
    return Arrays.asList(new PParameter("self", "Concept.Switch"),new PParameter("sensor", "Concept.Sensor"));
  }
  
  @Override
  public Set<PBody> doGetContainedBodies() throws IncQueryException {
    EMFPatternMatcherContext context = new EMFPatternMatcherContext();
    Set<PBody> bodies = Sets.newHashSet();
    {
      PBody body = new PBody(this);
      PVariable var_self = body.getOrCreateVariableByName("self");
      PVariable var_sensor = body.getOrCreateVariableByName("sensor");
      body.setExportedParameters(Arrays.asList(
        new ExportedParameter(body, var_self, "self"), 
        new ExportedParameter(body, var_sensor, "sensor")
      ));
      
      new TypeUnary(body, var_self, getClassifierLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Switch"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Switch");
      
      new TypeBinary(body, context, var_self, var_sensor, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Trackelement", "TrackElement_sensor"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Trackelement.TrackElement_sensor");
      bodies.add(body);
    }setStatus(PQuery.PQueryStatus.OK);
    return bodies;
  }
  
  private SwitchSensor_0QuerySpecification() throws IncQueryException {
    super();
    setStatus(PQuery.PQueryStatus.UNINITIALIZED);
  }
  
  @SuppressWarnings("all")
  public static class Provider implements IQuerySpecificationProvider<SwitchSensor_0QuerySpecification> {
    @Override
    public SwitchSensor_0QuerySpecification get() throws IncQueryException {
      return instance();
    }
  }
  
  
  @SuppressWarnings("all")
  private static class LazyHolder {
    private final static SwitchSensor_0QuerySpecification INSTANCE = make();
    
    public static SwitchSensor_0QuerySpecification make() {
      try {
      	return new SwitchSensor_0QuerySpecification();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
}
