package hu.bme.mit.train.constraintcheck.incquery.util;

import Concept.Route;
import hu.bme.mit.train.constraintcheck.incquery.AseMatch;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.ase pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class AseProcessor implements IMatchProcessor<AseMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pR1 the value of pattern parameter R1 in the currently processed match
   * 
   */
  public abstract void process(final Route pR1);
  
  @Override
  public void process(final AseMatch match) {
    process(match.getR1());
    
  }
}
