package hu.bme.mit.train.constraintcheck.incquery.util;

import com.google.common.collect.Sets;
import hu.bme.mit.train.constraintcheck.incquery.AseMatcher;
import hu.bme.mit.train.constraintcheck.incquery.util.EntrySignal1QuerySpecification;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedQuerySpecification;
import org.eclipse.incquery.runtime.context.EMFPatternMatcherContext;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.extensibility.IQuerySpecificationProvider;
import org.eclipse.incquery.runtime.matchers.psystem.PBody;
import org.eclipse.incquery.runtime.matchers.psystem.PParameter;
import org.eclipse.incquery.runtime.matchers.psystem.PQuery;
import org.eclipse.incquery.runtime.matchers.psystem.PVariable;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExportedParameter;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.Inequality;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.NegativePatternCall;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeBinary;
import org.eclipse.incquery.runtime.matchers.tuple.FlatTuple;

/**
 * A pattern-specific query specification that can instantiate AseMatcher in a type-safe way.
 * 
 * @see AseMatcher
 * @see AseMatch
 * 
 */
@SuppressWarnings("all")
public final class AseQuerySpecification extends BaseGeneratedQuerySpecification<AseMatcher> {
  /**
   * @return the singleton instance of the query specification
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static AseQuerySpecification instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected AseMatcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return AseMatcher.on(engine);
  }
  
  @Override
  public String getFullyQualifiedName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ase";
    
  }
  
  @Override
  public List<String> getParameterNames() {
    return Arrays.asList("R1");
  }
  
  @Override
  public List<PParameter> getParameters() {
    return Arrays.asList(new PParameter("R1", "Concept.Route"));
  }
  
  @Override
  public Set<PBody> doGetContainedBodies() throws IncQueryException {
    EMFPatternMatcherContext context = new EMFPatternMatcherContext();
    Set<PBody> bodies = Sets.newHashSet();
    {
      PBody body = new PBody(this);
      PVariable var_R1 = body.getOrCreateVariableByName("R1");
      PVariable var_SigA = body.getOrCreateVariableByName("SigA");
      PVariable var_SigB = body.getOrCreateVariableByName("SigB");
      PVariable var_R2 = body.getOrCreateVariableByName("R2");
      PVariable var_R3 = body.getOrCreateVariableByName("R3");
      PVariable var_Sen1 = body.getOrCreateVariableByName("Sen1");
      PVariable var_Sen2 = body.getOrCreateVariableByName("Sen2");
      PVariable var_Sen3 = body.getOrCreateVariableByName("Sen3");
      PVariable var_Te1 = body.getOrCreateVariableByName("Te1");
      PVariable var_Te2a = body.getOrCreateVariableByName("Te2a");
      PVariable var_Te2b = body.getOrCreateVariableByName("Te2b");
      PVariable var_Te3 = body.getOrCreateVariableByName("Te3");
      body.setExportedParameters(Arrays.asList(
        new ExportedParameter(body, var_R1, "R1")
      ));
      
      new TypeBinary(body, context, var_R1, var_SigA, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_exit"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_exit");
      new TypeBinary(body, context, var_R2, var_SigB, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_exit"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_exit");
      new TypeBinary(body, context, var_R1, var_Sen1, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_routeDefinition"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_routeDefinition");
      new TypeBinary(body, context, var_R2, var_Sen2, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_routeDefinition"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_routeDefinition");
      new TypeBinary(body, context, var_R3, var_Sen3, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_routeDefinition"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_routeDefinition");
      new TypeBinary(body, context, var_Sen1, var_Te1, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Sensor", "Sensor_trackElement"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Sensor.Sensor_trackElement");
      new TypeBinary(body, context, var_Sen2, var_Te2a, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Sensor", "Sensor_trackElement"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Sensor.Sensor_trackElement");
      new TypeBinary(body, context, var_Sen2, var_Te2b, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Sensor", "Sensor_trackElement"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Sensor.Sensor_trackElement");
      new TypeBinary(body, context, var_Sen3, var_Te3, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Sensor", "Sensor_trackElement"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Sensor.Sensor_trackElement");
      new TypeBinary(body, context, var_Te1, var_Te2a, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Trackelement", "TrackElement_connectsTo"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Trackelement.TrackElement_connectsTo");
      new TypeBinary(body, context, var_Te2b, var_Te3, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Trackelement", "TrackElement_connectsTo"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Trackelement.TrackElement_connectsTo");
      new Inequality(body, var_R1, var_R2);
      new Inequality(body, var_R2, var_R3);
      new Inequality(body, var_R3, var_R1);
      new NegativePatternCall(body, new FlatTuple(var_R2, var_SigA), EntrySignal1QuerySpecification.instance().instance());
      new NegativePatternCall(body, new FlatTuple(var_R3, var_SigB), EntrySignal1QuerySpecification.instance().instance());
      bodies.add(body);
    }setStatus(PQuery.PQueryStatus.OK);
    return bodies;
  }
  
  private AseQuerySpecification() throws IncQueryException {
    super();
    setStatus(PQuery.PQueryStatus.UNINITIALIZED);
  }
  
  @SuppressWarnings("all")
  public static class Provider implements IQuerySpecificationProvider<AseQuerySpecification> {
    @Override
    public AseQuerySpecification get() throws IncQueryException {
      return instance();
    }
  }
  
  
  @SuppressWarnings("all")
  private static class LazyHolder {
    private final static AseQuerySpecification INSTANCE = make();
    
    public static AseQuerySpecification make() {
      try {
      	return new AseQuerySpecification();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
}
