package hu.bme.mit.train.constraintcheck.incquery.util;

import com.google.common.collect.Sets;
import hu.bme.mit.train.constraintcheck.incquery.Ase_bMatcher;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedQuerySpecification;
import org.eclipse.incquery.runtime.context.EMFPatternMatcherContext;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.extensibility.IQuerySpecificationProvider;
import org.eclipse.incquery.runtime.matchers.psystem.PBody;
import org.eclipse.incquery.runtime.matchers.psystem.PParameter;
import org.eclipse.incquery.runtime.matchers.psystem.PQuery;
import org.eclipse.incquery.runtime.matchers.psystem.PVariable;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExportedParameter;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeBinary;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeUnary;

/**
 * A pattern-specific query specification that can instantiate Ase_bMatcher in a type-safe way.
 * 
 * @see Ase_bMatcher
 * @see Ase_bMatch
 * 
 */
@SuppressWarnings("all")
public final class Ase_bQuerySpecification extends BaseGeneratedQuerySpecification<Ase_bMatcher> {
  /**
   * @return the singleton instance of the query specification
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static Ase_bQuerySpecification instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected Ase_bMatcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return Ase_bMatcher.on(engine);
  }
  
  @Override
  public String getFullyQualifiedName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ase_b";
    
  }
  
  @Override
  public List<String> getParameterNames() {
    return Arrays.asList("R1");
  }
  
  @Override
  public List<PParameter> getParameters() {
    return Arrays.asList(new PParameter("R1", "Concept.Route"));
  }
  
  @Override
  public Set<PBody> doGetContainedBodies() throws IncQueryException {
    EMFPatternMatcherContext context = new EMFPatternMatcherContext();
    Set<PBody> bodies = Sets.newHashSet();
    {
      PBody body = new PBody(this);
      PVariable var_R1 = body.getOrCreateVariableByName("R1");
      PVariable var_SigA = body.getOrCreateVariableByName("SigA");
      PVariable var_Sen1A = body.getOrCreateVariableByName("Sen1A");
      PVariable var_Te1 = body.getOrCreateVariableByName("Te1");
      body.setExportedParameters(Arrays.asList(
        new ExportedParameter(body, var_R1, "R1")
      ));
      
      new TypeBinary(body, context, var_R1, var_SigA, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_exit"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_exit");
      new TypeBinary(body, context, var_R1, var_Sen1A, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_routeDefinition"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_routeDefinition");
      new TypeUnary(body, var_Te1, getClassifierLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Segment"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Segment");
      new TypeBinary(body, context, var_Sen1A, var_Te1, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Sensor", "Sensor_trackElement"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Sensor.Sensor_trackElement");
      bodies.add(body);
    }setStatus(PQuery.PQueryStatus.OK);
    return bodies;
  }
  
  private Ase_bQuerySpecification() throws IncQueryException {
    super();
    setStatus(PQuery.PQueryStatus.UNINITIALIZED);
  }
  
  @SuppressWarnings("all")
  public static class Provider implements IQuerySpecificationProvider<Ase_bQuerySpecification> {
    @Override
    public Ase_bQuerySpecification get() throws IncQueryException {
      return instance();
    }
  }
  
  
  @SuppressWarnings("all")
  private static class LazyHolder {
    private final static Ase_bQuerySpecification INSTANCE = make();
    
    public static Ase_bQuerySpecification make() {
      try {
      	return new Ase_bQuerySpecification();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
}
