package hu.bme.mit.train.constraintcheck.incquery.util;

import com.google.common.collect.Sets;
import hu.bme.mit.train.constraintcheck.incquery.Ase_dMatcher;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedQuerySpecification;
import org.eclipse.incquery.runtime.context.EMFPatternMatcherContext;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.extensibility.IQuerySpecificationProvider;
import org.eclipse.incquery.runtime.matchers.psystem.PBody;
import org.eclipse.incquery.runtime.matchers.psystem.PParameter;
import org.eclipse.incquery.runtime.matchers.psystem.PQuery;
import org.eclipse.incquery.runtime.matchers.psystem.PVariable;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExportedParameter;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeBinary;

/**
 * A pattern-specific query specification that can instantiate Ase_dMatcher in a type-safe way.
 * 
 * @see Ase_dMatcher
 * @see Ase_dMatch
 * 
 */
@SuppressWarnings("all")
public final class Ase_dQuerySpecification extends BaseGeneratedQuerySpecification<Ase_dMatcher> {
  /**
   * @return the singleton instance of the query specification
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static Ase_dQuerySpecification instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected Ase_dMatcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return Ase_dMatcher.on(engine);
  }
  
  @Override
  public String getFullyQualifiedName() {
    return "hu.bme.mit.train.constraintcheck.incquery.ase_d";
    
  }
  
  @Override
  public List<String> getParameterNames() {
    return Arrays.asList("R");
  }
  
  @Override
  public List<PParameter> getParameters() {
    return Arrays.asList(new PParameter("R", "Concept.Route"));
  }
  
  @Override
  public Set<PBody> doGetContainedBodies() throws IncQueryException {
    EMFPatternMatcherContext context = new EMFPatternMatcherContext();
    Set<PBody> bodies = Sets.newHashSet();
    {
      PBody body = new PBody(this);
      PVariable var_R = body.getOrCreateVariableByName("R");
      PVariable var_SigA = body.getOrCreateVariableByName("SigA");
      PVariable var_SigB = body.getOrCreateVariableByName("SigB");
      PVariable var_Sen1 = body.getOrCreateVariableByName("Sen1");
      PVariable var_Sen2 = body.getOrCreateVariableByName("Sen2");
      PVariable var_Te1 = body.getOrCreateVariableByName("Te1");
      PVariable var_Te2 = body.getOrCreateVariableByName("Te2");
      PVariable var_SWPTe2 = body.getOrCreateVariableByName("SWPTe2");
      body.setExportedParameters(Arrays.asList(
        new ExportedParameter(body, var_R, "R")
      ));
      
      new TypeBinary(body, context, var_R, var_SigA, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_entry"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_entry");
      new TypeBinary(body, context, var_R, var_SigB, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_exit"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_exit");
      new TypeBinary(body, context, var_R, var_Sen1, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_routeDefinition"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_routeDefinition");
      new TypeBinary(body, context, var_R, var_Sen2, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_routeDefinition"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_routeDefinition");
      new TypeBinary(body, context, var_Sen1, var_Te1, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Sensor", "Sensor_trackElement"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Sensor.Sensor_trackElement");
      new TypeBinary(body, context, var_Sen2, var_Te2, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Sensor", "Sensor_trackElement"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Sensor.Sensor_trackElement");
      new TypeBinary(body, context, var_Te2, var_SWPTe2, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Switch", "Switch_switchPosition"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Switch.Switch_switchPosition");
      new TypeBinary(body, context, var_SWPTe2, var_R, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "SwitchPosition", "SwitchPosition_route"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/SwitchPosition.SwitchPosition_route");
      bodies.add(body);
    }setStatus(PQuery.PQueryStatus.OK);
    return bodies;
  }
  
  private Ase_dQuerySpecification() throws IncQueryException {
    super();
    setStatus(PQuery.PQueryStatus.UNINITIALIZED);
  }
  
  @SuppressWarnings("all")
  public static class Provider implements IQuerySpecificationProvider<Ase_dQuerySpecification> {
    @Override
    public Ase_dQuerySpecification get() throws IncQueryException {
      return instance();
    }
  }
  
  
  @SuppressWarnings("all")
  private static class LazyHolder {
    private final static Ase_dQuerySpecification INSTANCE = make();
    
    public static Ase_dQuerySpecification make() {
      try {
      	return new Ase_dQuerySpecification();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
}
