package hu.bme.mit.train.constraintcheck.incquery.util;

import Concept.Route;
import Concept.Signal;
import hu.bme.mit.train.constraintcheck.incquery.EntrySignal1Match;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.entrySignal1 pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class EntrySignal1Processor implements IMatchProcessor<EntrySignal1Match> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSig the value of pattern parameter Sig in the currently processed match
   * @param pR the value of pattern parameter R in the currently processed match
   * 
   */
  public abstract void process(final Signal pSig, final Route pR);
  
  @Override
  public void process(final EntrySignal1Match match) {
    process(match.getSig(), match.getR());
    
  }
}
