package hu.bme.mit.train.constraintcheck.incquery.util;

import com.google.common.collect.Sets;
import hu.bme.mit.train.constraintcheck.incquery.EntrySignalSensor1Matcher;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedQuerySpecification;
import org.eclipse.incquery.runtime.context.EMFPatternMatcherContext;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.extensibility.IQuerySpecificationProvider;
import org.eclipse.incquery.runtime.matchers.psystem.PBody;
import org.eclipse.incquery.runtime.matchers.psystem.PParameter;
import org.eclipse.incquery.runtime.matchers.psystem.PQuery;
import org.eclipse.incquery.runtime.matchers.psystem.PVariable;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExportedParameter;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeBinary;

/**
 * A pattern-specific query specification that can instantiate EntrySignalSensor1Matcher in a type-safe way.
 * 
 * @see EntrySignalSensor1Matcher
 * @see EntrySignalSensor1Match
 * 
 */
@SuppressWarnings("all")
public final class EntrySignalSensor1QuerySpecification extends BaseGeneratedQuerySpecification<EntrySignalSensor1Matcher> {
  /**
   * @return the singleton instance of the query specification
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static EntrySignalSensor1QuerySpecification instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected EntrySignalSensor1Matcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return EntrySignalSensor1Matcher.on(engine);
  }
  
  @Override
  public String getFullyQualifiedName() {
    return "hu.bme.mit.train.constraintcheck.incquery.entrySignalSensor1";
    
  }
  
  @Override
  public List<String> getParameterNames() {
    return Arrays.asList("Sig","R2","Sen2");
  }
  
  @Override
  public List<PParameter> getParameters() {
    return Arrays.asList(new PParameter("Sig", "Concept.Signal"),new PParameter("R2", "Concept.Route"),new PParameter("Sen2", "Concept.Sensor"));
  }
  
  @Override
  public Set<PBody> doGetContainedBodies() throws IncQueryException {
    EMFPatternMatcherContext context = new EMFPatternMatcherContext();
    Set<PBody> bodies = Sets.newHashSet();
    {
      PBody body = new PBody(this);
      PVariable var_Sig = body.getOrCreateVariableByName("Sig");
      PVariable var_R2 = body.getOrCreateVariableByName("R2");
      PVariable var_Sen2 = body.getOrCreateVariableByName("Sen2");
      body.setExportedParameters(Arrays.asList(
        new ExportedParameter(body, var_Sig, "Sig"), 
        new ExportedParameter(body, var_R2, "R2"), 
        new ExportedParameter(body, var_Sen2, "Sen2")
      ));
      
      
      
      new TypeBinary(body, context, var_R2, var_Sig, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_entry"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_entry");
      new TypeBinary(body, context, var_R2, var_Sen2, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_routeDefinition"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_routeDefinition");
      bodies.add(body);
    }setStatus(PQuery.PQueryStatus.OK);
    return bodies;
  }
  
  private EntrySignalSensor1QuerySpecification() throws IncQueryException {
    super();
    setStatus(PQuery.PQueryStatus.UNINITIALIZED);
  }
  
  @SuppressWarnings("all")
  public static class Provider implements IQuerySpecificationProvider<EntrySignalSensor1QuerySpecification> {
    @Override
    public EntrySignalSensor1QuerySpecification get() throws IncQueryException {
      return instance();
    }
  }
  
  
  @SuppressWarnings("all")
  private static class LazyHolder {
    private final static EntrySignalSensor1QuerySpecification INSTANCE = make();
    
    public static EntrySignalSensor1QuerySpecification make() {
      try {
      	return new EntrySignalSensor1QuerySpecification();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
}
