package hu.bme.mit.train.constraintcheck.incquery.util;

import Concept.Sensor;
import hu.bme.mit.train.constraintcheck.incquery.HasNegLengthSegmentMatch;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.HasNegLengthSegment pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class HasNegLengthSegmentProcessor implements IMatchProcessor<HasNegLengthSegmentMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSen the value of pattern parameter Sen in the currently processed match
   * 
   */
  public abstract void process(final Sensor pSen);
  
  @Override
  public void process(final HasNegLengthSegmentMatch match) {
    process(match.getSen());
    
  }
}
