package hu.bme.mit.train.constraintcheck.incquery.util;

import com.google.common.collect.Sets;
import hu.bme.mit.train.constraintcheck.incquery.HasSensorMatcher;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedQuerySpecification;
import org.eclipse.incquery.runtime.context.EMFPatternMatcherContext;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.extensibility.IQuerySpecificationProvider;
import org.eclipse.incquery.runtime.matchers.psystem.PBody;
import org.eclipse.incquery.runtime.matchers.psystem.PParameter;
import org.eclipse.incquery.runtime.matchers.psystem.PQuery;
import org.eclipse.incquery.runtime.matchers.psystem.PVariable;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExportedParameter;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeBinary;

/**
 * A pattern-specific query specification that can instantiate HasSensorMatcher in a type-safe way.
 * 
 * @see HasSensorMatcher
 * @see HasSensorMatch
 * 
 */
@SuppressWarnings("all")
public final class HasSensorQuerySpecification extends BaseGeneratedQuerySpecification<HasSensorMatcher> {
  /**
   * @return the singleton instance of the query specification
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static HasSensorQuerySpecification instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected HasSensorMatcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return HasSensorMatcher.on(engine);
  }
  
  @Override
  public String getFullyQualifiedName() {
    return "hu.bme.mit.train.constraintcheck.incquery.hasSensor";
    
  }
  
  @Override
  public List<String> getParameterNames() {
    return Arrays.asList("Trackelement");
  }
  
  @Override
  public List<PParameter> getParameters() {
    return Arrays.asList(new PParameter("Trackelement", "Concept.Trackelement"));
  }
  
  @Override
  public Set<PBody> doGetContainedBodies() throws IncQueryException {
    EMFPatternMatcherContext context = new EMFPatternMatcherContext();
    Set<PBody> bodies = Sets.newHashSet();
    {
      PBody body = new PBody(this);
      PVariable var_Trackelement = body.getOrCreateVariableByName("Trackelement");
      PVariable var_Target = body.getOrCreateVariableByName("Target");
      body.setExportedParameters(Arrays.asList(
        new ExportedParameter(body, var_Trackelement, "Trackelement")
      ));
      
      new TypeBinary(body, context, var_Trackelement, var_Target, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Trackelement", "TrackElement_sensor"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Trackelement.TrackElement_sensor");
      bodies.add(body);
    }setStatus(PQuery.PQueryStatus.OK);
    return bodies;
  }
  
  private HasSensorQuerySpecification() throws IncQueryException {
    super();
    setStatus(PQuery.PQueryStatus.UNINITIALIZED);
  }
  
  @SuppressWarnings("all")
  public static class Provider implements IQuerySpecificationProvider<HasSensorQuerySpecification> {
    @Override
    public HasSensorQuerySpecification get() throws IncQueryException {
      return instance();
    }
  }
  
  
  @SuppressWarnings("all")
  private static class LazyHolder {
    private final static HasSensorQuerySpecification INSTANCE = make();
    
    public static HasSensorQuerySpecification make() {
      try {
      	return new HasSensorQuerySpecification();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
}
