package hu.bme.mit.train.constraintcheck.incquery.util;

import Concept.Segment;
import hu.bme.mit.train.constraintcheck.incquery.NegLengthSegmentMatch;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.NegLengthSegment pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class NegLengthSegmentProcessor implements IMatchProcessor<NegLengthSegmentMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSeg the value of pattern parameter Seg in the currently processed match
   * 
   */
  public abstract void process(final Segment pSeg);
  
  @Override
  public void process(final NegLengthSegmentMatch match) {
    process(match.getSeg());
    
  }
}
