package hu.bme.mit.train.constraintcheck.incquery.util;

import com.google.common.collect.Sets;
import hu.bme.mit.train.constraintcheck.incquery.NegLengthSegmentMatcher;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedQuerySpecification;
import org.eclipse.incquery.runtime.context.EMFPatternMatcherContext;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.extensibility.IQuerySpecificationProvider;
import org.eclipse.incquery.runtime.matchers.psystem.IExpressionEvaluator;
import org.eclipse.incquery.runtime.matchers.psystem.IValueProvider;
import org.eclipse.incquery.runtime.matchers.psystem.PBody;
import org.eclipse.incquery.runtime.matchers.psystem.PParameter;
import org.eclipse.incquery.runtime.matchers.psystem.PQuery;
import org.eclipse.incquery.runtime.matchers.psystem.PVariable;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExportedParameter;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExpressionEvaluation;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeBinary;

/**
 * A pattern-specific query specification that can instantiate NegLengthSegmentMatcher in a type-safe way.
 * 
 * @see NegLengthSegmentMatcher
 * @see NegLengthSegmentMatch
 * 
 */
@SuppressWarnings("all")
public final class NegLengthSegmentQuerySpecification extends BaseGeneratedQuerySpecification<NegLengthSegmentMatcher> {
  /**
   * @return the singleton instance of the query specification
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static NegLengthSegmentQuerySpecification instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected NegLengthSegmentMatcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return NegLengthSegmentMatcher.on(engine);
  }
  
  @Override
  public String getFullyQualifiedName() {
    return "hu.bme.mit.train.constraintcheck.incquery.NegLengthSegment";
    
  }
  
  @Override
  public List<String> getParameterNames() {
    return Arrays.asList("Seg");
  }
  
  @Override
  public List<PParameter> getParameters() {
    return Arrays.asList(new PParameter("Seg", "Concept.Segment"));
  }
  
  @Override
  public Set<PBody> doGetContainedBodies() throws IncQueryException {
    EMFPatternMatcherContext context = new EMFPatternMatcherContext();
    Set<PBody> bodies = Sets.newHashSet();
    {
      PBody body = new PBody(this);
      PVariable var_Seg = body.getOrCreateVariableByName("Seg");
      PVariable var_Targetb = body.getOrCreateVariableByName("Targetb");
      body.setExportedParameters(Arrays.asList(
        new ExportedParameter(body, var_Seg, "Seg")
      ));
      
      new TypeBinary(body, context, var_Seg, var_Targetb, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Segment", "Segment_length"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Segment.Segment_length");
      new ExpressionEvaluation(body, new IExpressionEvaluator() {
        @Override
        public String getShortDescription() {
        	return "Expression evaluation from pattern NegLengthSegment";
        }
        
        @Override
        public Iterable<String> getInputParameterNames() {
        	return Arrays.asList("Targetb");
        }
        
        @Override
        public Object evaluateExpression(IValueProvider provider) throws Exception {
        	java.lang.Integer Targetb = (java.lang.Integer) provider.getValue("Targetb");
        	return evaluateExpression_1_1(Targetb);
        }
        
        },  null); 
      bodies.add(body);
    }setStatus(PQuery.PQueryStatus.OK);
    return bodies;
  }
  
  private NegLengthSegmentQuerySpecification() throws IncQueryException {
    super();
    setStatus(PQuery.PQueryStatus.UNINITIALIZED);
  }
  
  @SuppressWarnings("all")
  public static class Provider implements IQuerySpecificationProvider<NegLengthSegmentQuerySpecification> {
    @Override
    public NegLengthSegmentQuerySpecification get() throws IncQueryException {
      return instance();
    }
  }
  
  
  @SuppressWarnings("all")
  private static class LazyHolder {
    private final static NegLengthSegmentQuerySpecification INSTANCE = make();
    
    public static NegLengthSegmentQuerySpecification make() {
      try {
      	return new NegLengthSegmentQuerySpecification();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
  
  private boolean evaluateExpression_1_1(final Integer Targetb) {
    return ((((Integer) Targetb)).intValue() < 10);
  }
}
