package hu.bme.mit.train.constraintcheck.incquery.util;

import Concept.Route;
import Concept.Sensor;
import Concept.Switch;
import Concept.SwitchPosition;
import hu.bme.mit.train.constraintcheck.incquery.RouteSensorMatch;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.routeSensor pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class RouteSensorProcessor implements IMatchProcessor<RouteSensorMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSen the value of pattern parameter Sen in the currently processed match
   * @param pSw the value of pattern parameter Sw in the currently processed match
   * @param pSp the value of pattern parameter Sp in the currently processed match
   * @param pR the value of pattern parameter R in the currently processed match
   * 
   */
  public abstract void process(final Sensor pSen, final Switch pSw, final SwitchPosition pSp, final Route pR);
  
  @Override
  public void process(final RouteSensorMatch match) {
    process(match.getSen(), match.getSw(), match.getSp(), match.getR());
    
  }
}
