package hu.bme.mit.train.constraintcheck.incquery.util;

import com.google.common.collect.Sets;
import hu.bme.mit.train.constraintcheck.incquery.SignalNeighborMatcher;
import hu.bme.mit.train.constraintcheck.incquery.util.ConnectingSensorsQuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.EntrySignalSensorQuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.ExitSignalSensorQuerySpecification;
import hu.bme.mit.train.constraintcheck.incquery.util.RDefinitionQuerySpecification;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedQuerySpecification;
import org.eclipse.incquery.runtime.context.EMFPatternMatcherContext;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.extensibility.IQuerySpecificationProvider;
import org.eclipse.incquery.runtime.matchers.psystem.PBody;
import org.eclipse.incquery.runtime.matchers.psystem.PParameter;
import org.eclipse.incquery.runtime.matchers.psystem.PQuery;
import org.eclipse.incquery.runtime.matchers.psystem.PVariable;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExportedParameter;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.Inequality;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.NegativePatternCall;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.PositivePatternCall;
import org.eclipse.incquery.runtime.matchers.tuple.FlatTuple;

/**
 * A pattern-specific query specification that can instantiate SignalNeighborMatcher in a type-safe way.
 * 
 * @see SignalNeighborMatcher
 * @see SignalNeighborMatch
 * 
 */
@SuppressWarnings("all")
public final class SignalNeighborQuerySpecification extends BaseGeneratedQuerySpecification<SignalNeighborMatcher> {
  /**
   * @return the singleton instance of the query specification
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static SignalNeighborQuerySpecification instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected SignalNeighborMatcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return SignalNeighborMatcher.on(engine);
  }
  
  @Override
  public String getFullyQualifiedName() {
    return "hu.bme.mit.train.constraintcheck.incquery.signalNeighbor";
    
  }
  
  @Override
  public List<String> getParameterNames() {
    return Arrays.asList("R1");
  }
  
  @Override
  public List<PParameter> getParameters() {
    return Arrays.asList(new PParameter("R1", "Concept.Route"));
  }
  
  @Override
  public Set<PBody> doGetContainedBodies() throws IncQueryException {
    EMFPatternMatcherContext context = new EMFPatternMatcherContext();
    Set<PBody> bodies = Sets.newHashSet();
    {
      PBody body = new PBody(this);
      PVariable var_R1 = body.getOrCreateVariableByName("R1");
      PVariable var_SigA = body.getOrCreateVariableByName("SigA");
      PVariable var_Sen1A = body.getOrCreateVariableByName("Sen1A");
      PVariable var_Sen2A = body.getOrCreateVariableByName("Sen2A");
      PVariable var_R3A = body.getOrCreateVariableByName("R3A");
      PVariable var__R2A = body.getOrCreateVariableByName("_R2A");
      body.setExportedParameters(Arrays.asList(
        new ExportedParameter(body, var_R1, "R1")
      ));
      
      new PositivePatternCall(body, new FlatTuple(var_SigA, var_R1, var_Sen1A), ExitSignalSensorQuerySpecification.instance());
      new PositivePatternCall(body, new FlatTuple(var_Sen1A, var_Sen2A), ConnectingSensorsQuerySpecification.instance());
      new PositivePatternCall(body, new FlatTuple(var_R3A, var_Sen2A), RDefinitionQuerySpecification.instance());
      new Inequality(body, var_R3A, var_R1);
      new NegativePatternCall(body, new FlatTuple(var_SigA, var__R2A, var_Sen2A), EntrySignalSensorQuerySpecification.instance().instance());
      bodies.add(body);
    }setStatus(PQuery.PQueryStatus.OK);
    return bodies;
  }
  
  private SignalNeighborQuerySpecification() throws IncQueryException {
    super();
    setStatus(PQuery.PQueryStatus.UNINITIALIZED);
  }
  
  @SuppressWarnings("all")
  public static class Provider implements IQuerySpecificationProvider<SignalNeighborQuerySpecification> {
    @Override
    public SignalNeighborQuerySpecification get() throws IncQueryException {
      return instance();
    }
  }
  
  
  @SuppressWarnings("all")
  private static class LazyHolder {
    private final static SignalNeighborQuerySpecification INSTANCE = make();
    
    public static SignalNeighborQuerySpecification make() {
      try {
      	return new SignalNeighborQuerySpecification();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
}
