package hu.bme.mit.train.constraintcheck.incquery.util;

import Concept.Route;
import Concept.Signal;
import Concept.Switch;
import Concept.SwitchPosition;
import hu.bme.mit.train.constraintcheck.incquery.SwitchSetMatch;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.switchSet pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class SwitchSetProcessor implements IMatchProcessor<SwitchSetMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pSpstate the value of pattern parameter Spstate in the currently processed match
   * @param pSw the value of pattern parameter Sw in the currently processed match
   * @param pSig the value of pattern parameter Sig in the currently processed match
   * @param pSp the value of pattern parameter Sp in the currently processed match
   * @param pSwstate the value of pattern parameter Swstate in the currently processed match
   * @param pR the value of pattern parameter R in the currently processed match
   * 
   */
  public abstract void process(final Object pSpstate, final Switch pSw, final Signal pSig, final SwitchPosition pSp, final Object pSwstate, final Route pR);
  
  @Override
  public void process(final SwitchSetMatch match) {
    process(match.getSpstate(), match.getSw(), match.getSig(), match.getSp(), match.getSwstate(), match.getR());
    
  }
}
