package hu.bme.mit.train.constraintcheck.incquery.util;

import com.google.common.collect.Sets;
import hu.bme.mit.train.constraintcheck.incquery.SwitchSetMatcher;
import java.util.Arrays;
import java.util.List;
import java.util.Set;
import org.eclipse.incquery.runtime.api.IncQueryEngine;
import org.eclipse.incquery.runtime.api.impl.BaseGeneratedQuerySpecification;
import org.eclipse.incquery.runtime.context.EMFPatternMatcherContext;
import org.eclipse.incquery.runtime.exception.IncQueryException;
import org.eclipse.incquery.runtime.extensibility.IQuerySpecificationProvider;
import org.eclipse.incquery.runtime.matchers.psystem.PBody;
import org.eclipse.incquery.runtime.matchers.psystem.PParameter;
import org.eclipse.incquery.runtime.matchers.psystem.PQuery;
import org.eclipse.incquery.runtime.matchers.psystem.PVariable;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.ExportedParameter;
import org.eclipse.incquery.runtime.matchers.psystem.basicdeferred.Inequality;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.ConstantValue;
import org.eclipse.incquery.runtime.matchers.psystem.basicenumerables.TypeBinary;

/**
 * A pattern-specific query specification that can instantiate SwitchSetMatcher in a type-safe way.
 * 
 * @see SwitchSetMatcher
 * @see SwitchSetMatch
 * 
 */
@SuppressWarnings("all")
public final class SwitchSetQuerySpecification extends BaseGeneratedQuerySpecification<SwitchSetMatcher> {
  /**
   * @return the singleton instance of the query specification
   * @throws IncQueryException if the pattern definition could not be loaded
   * 
   */
  public static SwitchSetQuerySpecification instance() throws IncQueryException {
    try {
    	return LazyHolder.INSTANCE;
    } catch (ExceptionInInitializerError err) {
    	processInitializerError(err);
    	throw err;
    }
    
  }
  
  @Override
  protected SwitchSetMatcher instantiate(final IncQueryEngine engine) throws IncQueryException {
    return SwitchSetMatcher.on(engine);
  }
  
  @Override
  public String getFullyQualifiedName() {
    return "hu.bme.mit.train.constraintcheck.incquery.switchSet";
    
  }
  
  @Override
  public List<String> getParameterNames() {
    return Arrays.asList("Spstate","Sw","Sig","Sp","Swstate","R");
  }
  
  @Override
  public List<PParameter> getParameters() {
    return Arrays.asList(new PParameter("Spstate", "java.lang.Object"),new PParameter("Sw", "Concept.Switch"),new PParameter("Sig", "Concept.Signal"),new PParameter("Sp", "Concept.SwitchPosition"),new PParameter("Swstate", "java.lang.Object"),new PParameter("R", "Concept.Route"));
  }
  
  @Override
  public Set<PBody> doGetContainedBodies() throws IncQueryException {
    EMFPatternMatcherContext context = new EMFPatternMatcherContext();
    Set<PBody> bodies = Sets.newHashSet();
    {
      PBody body = new PBody(this);
      PVariable var_Spstate = body.getOrCreateVariableByName("Spstate");
      PVariable var_Sw = body.getOrCreateVariableByName("Sw");
      PVariable var_Sig = body.getOrCreateVariableByName("Sig");
      PVariable var_Sp = body.getOrCreateVariableByName("Sp");
      PVariable var_Swstate = body.getOrCreateVariableByName("Swstate");
      PVariable var_R = body.getOrCreateVariableByName("R");
      PVariable var_Individual3 = body.getOrCreateVariableByName("Individual3");
      body.setExportedParameters(Arrays.asList(
        new ExportedParameter(body, var_Spstate, "Spstate"), 
        new ExportedParameter(body, var_Sw, "Sw"), 
        new ExportedParameter(body, var_Sig, "Sig"), 
        new ExportedParameter(body, var_Sp, "Sp"), 
        new ExportedParameter(body, var_Swstate, "Swstate"), 
        new ExportedParameter(body, var_R, "R")
      ));
      
      
      
      
      
      
      new TypeBinary(body, context, var_R, var_Sig, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_entry"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_entry");
      new TypeBinary(body, context, var_Sig, var_Individual3, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Signal", "Signal_actualState"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Signal.Signal_actualState");
      new ConstantValue(body, var_Individual3, getEnumLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "SignalStateKind", "SignalStateKind_GO").getInstance());
      new TypeBinary(body, context, var_R, var_Sp, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Route", "Route_switchPosition"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Route.Route_switchPosition");
      new TypeBinary(body, context, var_Sp, var_Spstate, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "SwitchPosition", "SwitchPosition_switchState"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/SwitchPosition.SwitchPosition_switchState");
      new TypeBinary(body, context, var_Sp, var_Sw, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "SwitchPosition", "SwitchPosition_switch"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/SwitchPosition.SwitchPosition_switch");
      new TypeBinary(body, context, var_Sw, var_Swstate, getFeatureLiteral("http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl", "Switch", "Switch_actualState"), "http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl/Switch.Switch_actualState");
      new Inequality(body, var_Spstate, var_Swstate);
      bodies.add(body);
    }setStatus(PQuery.PQueryStatus.OK);
    return bodies;
  }
  
  private SwitchSetQuerySpecification() throws IncQueryException {
    super();
    setStatus(PQuery.PQueryStatus.UNINITIALIZED);
  }
  
  @SuppressWarnings("all")
  public static class Provider implements IQuerySpecificationProvider<SwitchSetQuerySpecification> {
    @Override
    public SwitchSetQuerySpecification get() throws IncQueryException {
      return instance();
    }
  }
  
  
  @SuppressWarnings("all")
  private static class LazyHolder {
    private final static SwitchSetQuerySpecification INSTANCE = make();
    
    public static SwitchSetQuerySpecification make() {
      try {
      	return new SwitchSetQuerySpecification();
      } catch (IncQueryException ex) {
      	throw new RuntimeException	(ex);
      }
      
    }
  }
  
}
