package hu.bme.mit.train.constraintcheck.incquery.util;

import Concept.Trackelement;
import hu.bme.mit.train.constraintcheck.incquery.TrackelementConnectedMatch;
import org.eclipse.incquery.runtime.api.IMatchProcessor;

/**
 * A match processor tailored for the hu.bme.mit.train.constraintcheck.incquery.trackelementConnected pattern.
 * 
 * Clients should derive an (anonymous) class that implements the abstract process().
 * 
 */
@SuppressWarnings("all")
public abstract class TrackelementConnectedProcessor implements IMatchProcessor<TrackelementConnectedMatch> {
  /**
   * Defines the action that is to be executed on each match.
   * @param pTe1 the value of pattern parameter Te1 in the currently processed match
   * @param pTe2 the value of pattern parameter Te2 in the currently processed match
   * 
   */
  public abstract void process(final Trackelement pTe1, final Trackelement pTe2);
  
  @Override
  public void process(final TrackelementConnectedMatch match) {
    process(match.getTe1(), match.getTe2());
    
  }
}
