package hu.bme.mit.train.cc.nativ;

import java.util.ArrayList;
import java.util.Collection;

import javax.naming.OperationNotSupportedException;

import hu.bme.mit.train.cc.incQuery.TestCasePosLength_IncQuery;
import hu.bme.mit.train.cc.incQuery.TestCaseRouteSensor_IncQuery;
import hu.bme.mit.train.cc.incQuery.TestCaseSignalNeighbor_IncQuery;
import hu.bme.mit.train.cc.incQuery.TestCaseSwitchSensor_IncQuery;
import hu.bme.mit.train.cc.incQuery.TestCaseSwitchSet_IncQuery;
import hu.bme.mit.train.scenarios.TestFactory;
import hu.bme.mit.train.util.CcBenchmark;

public class EiqTestFactory implements TestFactory {

	@Override
	public CcBenchmark getPosLength() {
		return new TestCasePosLength_IncQuery();
	}

	@Override
	public CcBenchmark getRouteSensor() {
		return new TestCaseRouteSensor_IncQuery();
	}

	@Override
	public CcBenchmark getSwitchSensor() {
		return new TestCaseSwitchSensor_IncQuery();
	}

	@Override
	public CcBenchmark getSwitchSet() {
		return new TestCaseSwitchSet_IncQuery();
	}

	@Override
	public CcBenchmark getSignalNeighbor() {
		return new TestCaseSignalNeighbor_IncQuery();
	}

	@Override
	public CcBenchmark getRouteSensorAI() {
		throw new RuntimeException(new OperationNotSupportedException());
	}

	@Override
	public CcBenchmark getSwitchSetAI() {
		throw new RuntimeException(new OperationNotSupportedException());
	}

	
	
	@Override
	public Collection<Object[]> getPosLengthModelsizes() {
		return TestCasePosLength_IncQuery.data();
	}

	@Override
	public Collection<Object[]> getRouteSensorModelsizes() {
		return TestCaseRouteSensor_IncQuery.data();
	}

	@Override
	public Collection<Object[]> getSwitchSensorModelsizes() {
		return TestCaseSwitchSensor_IncQuery.data();
	}

	@Override
	public Collection<Object[]> getSwitchSetModelsizes() {
		return TestCaseSwitchSet_IncQuery.data();
	}

	@Override
	public Collection<Object[]> getSignalNeighborModelsizes() {
		return TestCaseSignalNeighbor_IncQuery.data();
	}

	@Override
	public Collection<Object[]> getRouteSensorAIModelsizes() {
		return new ArrayList<Object[]>();
	}

	@Override
	public Collection<Object[]> getSwitchSetAIModelsizes() {
		return new ArrayList<Object[]>();
	}

}
