package hu.bme.mit.train.cc.nativ;

import hu.bme.mit.train.cc.incQuery.TestCasePosLength_OCL2IQ;
import hu.bme.mit.train.cc.incQuery.TestCaseRouteSensor_OCL2IQ;
import hu.bme.mit.train.cc.incQuery.TestCaseSignalNeighbor_OCL2IQ;
import hu.bme.mit.train.cc.incQuery.TestCaseSwitchSensor_OCL2IQ;
import hu.bme.mit.train.cc.incQuery.TestCaseSwitchSet_OCL2IQ;
import hu.bme.mit.train.scenarios.TestFactory;
import hu.bme.mit.train.util.CcBenchmark;

import java.util.ArrayList;
import java.util.Collection;

import javax.naming.OperationNotSupportedException;

public class OCL2IQTestFactory implements TestFactory {

	@Override
	public CcBenchmark getPosLength() {
		return new TestCasePosLength_OCL2IQ();
	}

	@Override
	public CcBenchmark getRouteSensor() {
		return new TestCaseRouteSensor_OCL2IQ();
	}

	@Override
	public CcBenchmark getSwitchSensor() {
		return new TestCaseSwitchSensor_OCL2IQ();
	}

	@Override
	public CcBenchmark getSwitchSet() {
		return new TestCaseSwitchSet_OCL2IQ();
	}

	@Override
	public CcBenchmark getSignalNeighbor() {
		return new TestCaseSignalNeighbor_OCL2IQ();
	}

	@Override
	public CcBenchmark getRouteSensorAI() {
		throw new RuntimeException(new OperationNotSupportedException());
	}

	@Override
	public CcBenchmark getSwitchSetAI() {
		throw new RuntimeException(new OperationNotSupportedException());
	}

	
	
	@Override
	public Collection<Object[]> getPosLengthModelsizes() {
		return TestCasePosLength_OCL2IQ.data();
	}

	@Override
	public Collection<Object[]> getRouteSensorModelsizes() {
		return TestCaseRouteSensor_OCL2IQ.data();
	}

	@Override
	public Collection<Object[]> getSwitchSensorModelsizes() {
		return TestCaseSwitchSensor_OCL2IQ.data();
	}

	@Override
	public Collection<Object[]> getSwitchSetModelsizes() {
		return TestCaseSwitchSet_OCL2IQ.data();
	}

	@Override
	public Collection<Object[]> getSignalNeighborModelsizes() {
		return TestCaseSignalNeighbor_OCL2IQ.data();
	}

	@Override
	public Collection<Object[]> getRouteSensorAIModelsizes() {
		return new ArrayList<Object[]>();
	}

	@Override
	public Collection<Object[]> getSwitchSetAIModelsizes() {
		return new ArrayList<Object[]>();
	}

}
