package hu.bme.mit.train.cc.nativ;

import java.util.Collection;

import hu.bme.mit.train.cc.java.TestCasePosLength_Java;
import hu.bme.mit.train.cc.java.TestCaseRouteSensor_Java;
import hu.bme.mit.train.cc.java.TestCaseSignalNeighbor_Java;
import hu.bme.mit.train.cc.java.TestCaseSwitchSensor_Java;
import hu.bme.mit.train.cc.java.TestCaseSwitchSet_Java;
import hu.bme.mit.train.cc.javaai.TestCaseRouteSensor_JavaAI;
import hu.bme.mit.train.cc.javaai.TestCaseSwitchSet_JavaAI;
import hu.bme.mit.train.scenarios.TestFactory;
import hu.bme.mit.train.util.CcBenchmark;

public class JavaTestFactory implements TestFactory {

	@Override
	public CcBenchmark getPosLength() {
		return new TestCasePosLength_Java();
	}

	@Override
	public CcBenchmark getRouteSensor() {
		return new TestCaseRouteSensor_Java();
	}

	@Override
	public CcBenchmark getSwitchSensor() {
		return new TestCaseSwitchSensor_Java();
	}

	@Override
	public CcBenchmark getSwitchSet() {
		return new TestCaseSwitchSet_Java();
	}

	@Override
	public CcBenchmark getSignalNeighbor() {
		return new TestCaseSignalNeighbor_Java();
	}

	@Override
	public CcBenchmark getRouteSensorAI() {
		return new TestCaseRouteSensor_JavaAI();
	}

	@Override
	public CcBenchmark getSwitchSetAI() {
		return new TestCaseSwitchSet_JavaAI();
	}

	@Override
	public Collection<Object[]> getPosLengthModelsizes() {
		return TestCasePosLength_Java.data();
	}

	@Override
	public Collection<Object[]> getRouteSensorModelsizes() {
		return TestCaseRouteSensor_Java.data();
	}

	@Override
	public Collection<Object[]> getSwitchSensorModelsizes() {
		return TestCaseSwitchSensor_Java.data();
	}

	@Override
	public Collection<Object[]> getSwitchSetModelsizes() {
		return TestCaseSwitchSet_Java.data();
	}

	@Override
	public Collection<Object[]> getSignalNeighborModelsizes() {
		return TestCaseSignalNeighbor_Java.data();
	}

	@Override
	public Collection<Object[]> getRouteSensorAIModelsizes() {
		return TestCaseRouteSensor_JavaAI.data();
	}

	@Override
	public Collection<Object[]> getSwitchSetAIModelsizes() {
		return TestCaseSwitchSet_JavaAI.data();
	}

}
