package hu.bme.mit.train.cc.nativ;

import java.util.Collection;

import hu.bme.mit.train.cc.mdtocl.TestCasePosLength_OCL;
import hu.bme.mit.train.cc.mdtocl.TestCaseRouteSensor_OCL;
import hu.bme.mit.train.cc.mdtocl.TestCaseSignalNeighbor_OCL;
import hu.bme.mit.train.cc.mdtocl.TestCaseSwitchSensor_OCL;
import hu.bme.mit.train.cc.mdtocl.TestCaseSwitchSet_OCL;
import hu.bme.mit.train.cc.mdtoclai.TestCaseRouteSensor_OCLAI;
import hu.bme.mit.train.cc.mdtoclai.TestCaseSwitchSet_OCLAI;
import hu.bme.mit.train.scenarios.TestFactory;
import hu.bme.mit.train.util.CcBenchmark;

public class MdtoclTestFactory implements TestFactory {

	@Override
	public CcBenchmark getPosLength() {
		return new TestCasePosLength_OCL();
	}

	@Override
	public CcBenchmark getRouteSensor() {
		return new TestCaseRouteSensor_OCL();
	}

	@Override
	public CcBenchmark getSwitchSensor() {
		return new TestCaseSwitchSensor_OCL();
	}

	@Override
	public CcBenchmark getSwitchSet() {
		return new TestCaseSwitchSet_OCL();
	}

	@Override
	public CcBenchmark getSignalNeighbor() {
		return new TestCaseSignalNeighbor_OCL();
	}

	@Override
	public CcBenchmark getRouteSensorAI() {
		return new TestCaseRouteSensor_OCLAI();
	}

	@Override
	public CcBenchmark getSwitchSetAI() {
		return new TestCaseSwitchSet_OCLAI();
	}

	@Override
	public Collection<Object[]> getPosLengthModelsizes() {
		return TestCasePosLength_OCL.data();
	}

	@Override
	public Collection<Object[]> getRouteSensorModelsizes() {
		return TestCaseRouteSensor_OCL.data();
	}

	@Override
	public Collection<Object[]> getSwitchSensorModelsizes() {
		return TestCaseSwitchSensor_OCL.data();
	}

	@Override
	public Collection<Object[]> getSwitchSetModelsizes() {
		return TestCaseSwitchSet_OCL.data();
	}

	@Override
	public Collection<Object[]> getRouteSensorAIModelsizes() {
		return TestCaseRouteSensor_OCLAI.data();
	}

	@Override
	public Collection<Object[]> getSwitchSetAIModelsizes() {
		return TestCaseSwitchSet_OCLAI.data();
	}

	@Override
	public Collection<Object[]> getSignalNeighborModelsizes() {
		return TestCaseSignalNeighbor_OCL.data();
	}

}
