--
-- Adatbázis: `Train`
--

-- 512 Mb
SET max_heap_table_size=536870912;

DROP DATABASE IF EXISTS `Train`;
CREATE DATABASE `Train`;
USE `Train`;

SET AUTOCOMMIT=0;
-- --------------------------------------------------------

--
-- Tábla szerkezet: `Route`
--

CREATE TABLE IF NOT EXISTS `Route` (
  `id` int(11) NOT NULL auto_increment,
  `Route_entry` int(11) NOT NULL,
  `Route_exit` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ENGINE=MEMORY;

-- --------------------------------------------------------

--
-- Tábla szerkezet: `Route_routeDefinition`
--

CREATE TABLE IF NOT EXISTS `Route_routeDefinition` (
  `Route_id` int(11) NOT NULL,
  `Sensor_id` int(11) NOT NULL
) DEFAULT CHARSET=utf8 ENGINE=MEMORY;

-- --------------------------------------------------------

--
-- Tábla szerkezet: `Segment`
--

CREATE TABLE IF NOT EXISTS `Segment` (
  `Trackelement_id` int(11) NOT NULL,
  `Segment_length` int(11) NOT NULL,
  PRIMARY KEY  (`Trackelement_id`)
) DEFAULT CHARSET=utf8 ENGINE=MEMORY;

-- --------------------------------------------------------

--
-- Tábla szerkezet: `Sensor`
--

CREATE TABLE IF NOT EXISTS `Sensor` (
  `id` int(11) NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ENGINE=MEMORY;

-- --------------------------------------------------------

--
-- Tábla szerkezet: `Sensor_trackElement`
--

CREATE TABLE IF NOT EXISTS `Sensor_trackElement` (
  `Sensor_id` int(11) NOT NULL,
  `Trackelement_id` int(11) NOT NULL
) DEFAULT CHARSET=utf8 ENGINE=MEMORY;

-- --------------------------------------------------------

--
-- Tábla szerkezet: `Signal`
--

CREATE TABLE IF NOT EXISTS `Signals` (
  `id` int(11) NOT NULL auto_increment,
  `Signal_actualState` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ENGINE=MEMORY;

-- --------------------------------------------------------

--
-- Tábla szerkezet: `SignalStateKind`
--

CREATE TABLE IF NOT EXISTS `SignalStateKind` (
  `id` int(11) NOT NULL auto_increment,
  `text` varchar(32) NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=6 ENGINE=MEMORY;

--
-- A tábla adatainak kiíratása `SignalStateKind`
--

INSERT INTO `SignalStateKind` (`id`, `text`) VALUES
(1, 'SignalStateKind_STOP'),
(2, 'SignalStateKind_FAILURE'),
(3, 'SignalStateKind_GO');

-- --------------------------------------------------------

--
-- Tábla szerkezet: `Switch`
--

CREATE TABLE IF NOT EXISTS `Switch` (
  `Trackelement_id` int(11) NOT NULL,
  `Switch_actualState` int(11) NOT NULL,
  PRIMARY KEY  (`Trackelement_id`)
) DEFAULT CHARSET=utf8 ENGINE=MEMORY;

-- --------------------------------------------------------

--
-- Tábla szerkezet: `SwitchPosition`
--

CREATE TABLE IF NOT EXISTS `SwitchPosition` (
  `id` int(11) NOT NULL auto_increment,
  `SwitchPosition_route` int(11) NOT NULL,
  `SwitchPosition_switch` int(11) NOT NULL,
  `SwitchPosition_switchState` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ENGINE=MEMORY;

-- --------------------------------------------------------

--
-- Tábla szerkezet: `SwitchStateKind`
--

CREATE TABLE IF NOT EXISTS `SwitchStateKind` (
  `id` int(11) NOT NULL auto_increment,
  `text` varchar(32) NOT NULL,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=8 ENGINE=MEMORY;

--
-- A tábla adatainak kiíratása `SwitchStateKind`
--

INSERT INTO `SwitchStateKind` (`id`, `text`) VALUES
(1, 'PointStateKind_FAILURE'),
(2, 'PointStateKind_LEFT'),
(3, 'PointStateKind_RIGHT'),
(4, 'PointStateKind_STRAIGHT');

-- --------------------------------------------------------

--
-- Tábla szerkezet: `Trackelement`
--

CREATE TABLE IF NOT EXISTS `Trackelement` (
  `id` int(11) NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ENGINE=MEMORY;

-- --------------------------------------------------------

--
-- Tábla szerkezet: `Trackelement_connectsTo`
--

CREATE TABLE IF NOT EXISTS `Trackelement_connectsTo` (
  `Trackelement_id` int(11) NOT NULL,
  `Trackelement_id_connectsTo` int(11) NOT NULL
) DEFAULT CHARSET=utf8 ENGINE=MEMORY;

-- PosLength
-- select * from Segment where Segment_length<=0

-- SwitchSensor
-- select * from Switch left join Sensor_trackElement on Sensor_trackElement.Trackelement_id=Switch.Trackelement_id WHERE Sensor_trackElement.Trackelement_id IS NULL;

-- SwitchSet
-- select SwitchPosition.id from SwitchPosition, Route, Signals, Switch where Route.Route_entry=Signals.id and Route.id=SwitchPosition.SwitchPosition_route and SwitchPosition.SwitchPosition_switch = Switch.Trackelement_id and Switch.Switch_actualState != SwitchPosition.SwitchPosition_switchState and Signals.Signal_actualState=3;
