package hu.bme.mit.train.util;

import hu.bme.mit.train.common.RuntimeConstants;

import java.io.IOException;
import java.net.URL;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.xmi.XMIResource;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceImpl;
//import org.semanticweb.owlapi.model.IRI;

import Concept.ConceptPackage;

public class FileBroker {

	public static URI getURLFromLocation(String bundleName, String path) {
		URI result = null;
		URL url = null;

		if(! RuntimeConstants.standAlone) {
			try {
				url = FileLocator.toFileURL(FileLocator.find(Platform.getBundle(bundleName), new Path(path), null));
			} catch (IOException e) {
				e.printStackTrace();
			}	

			if (url != null) {
				result = URI.createURI(url.toString());
			}
		}
		else {
			// Try standalone running...
			Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put
			("*", new XMIResourceFactoryImpl() {
				public Resource createResource(URI uri)
				{
					XMIResource xmiResource = new XMIResourceImpl(uri);
					return xmiResource;
				}
			});
			EPackage.Registry.INSTANCE.put(ConceptPackage.eNS_URI, ConceptPackage.eINSTANCE);
			String uriToCreate = RuntimeConstants.workspacePath + "/" + bundleName + "/" + path;
			result = URI.createFileURI(uriToCreate);
		}
		return result;
	}

	public static URI getFileFromBoundle(String fileName) {
		String bundleName = RuntimeConstants.modelProjectPLUGIN_ID;
		String path = fileName;
		return getURLFromLocation(bundleName, path);
	}

	public static URI getBigTestModelFile(String fileName) {
		return getFileFromBoundle(fileName);
	}

	public static URI getBigTestModelFile() {
		return getFileFromBoundle("models/testBig.concept");
	}
/*
	public static IRI getBigTestModelFileOWL(String fileName) {
		IRI result = null;
		if(! RuntimeConstants.standAlone) {
			try {
				result = IRI.create(FileLocator.toFileURL(FileLocator.find(Platform.getBundle(RuntimeConstants.modelProjectPLUGIN_ID), 
						new Path(fileName), null)));
			} catch (URISyntaxException e1) {
				e1.printStackTrace();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		} else {
			result = IRI.create("file://" + RuntimeConstants.modelProjectPath + "/" + fileName);
		}
		return result;
		
	}

	public static IRI getBigTestModelFileOWL() {
		return getBigTestModelFileOWL("models/testBig.owl");
	}
*/
}
