/**
 */
package Concept.impl;

import java.lang.reflect.InvocationTargetException;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.ocl.examples.domain.elements.DomainType;
import org.eclipse.ocl.examples.domain.evaluation.DomainEvaluator;
import org.eclipse.ocl.examples.domain.messages.EvaluatorMessages;
import org.eclipse.ocl.examples.domain.types.IdResolver;
import org.eclipse.ocl.examples.domain.values.OrderedSetValue;
import org.eclipse.ocl.examples.domain.values.SequenceValue;
import org.eclipse.ocl.examples.domain.values.SetValue;
import org.eclipse.ocl.examples.domain.values.impl.InvalidValueException;
import org.eclipse.ocl.examples.domain.values.util.ValuesUtil;
import org.eclipse.ocl.examples.library.classifier.ClassifierAllInstancesOperation;
import org.eclipse.ocl.examples.library.collection.CollectionIncludesOperation;
import org.eclipse.ocl.examples.library.ecore.EcoreExecutorManager;
import org.eclipse.ocl.examples.library.logical.BooleanAndOperation;
import org.eclipse.ocl.examples.library.logical.BooleanNotOperation;
import org.eclipse.ocl.examples.library.oclany.OclAnyEqualOperation;
import org.eclipse.ocl.examples.library.oclany.OclAnyNotEqualOperation;
import org.eclipse.ocl.examples.library.oclany.OclAnyOclAsSetOperation;

import org.eclipse.ocl.examples.pivot.utilities.PivotUtil;
import Concept.ConceptPackage;
import Concept.ConceptTables;
import Concept.Route;
import Concept.Sensor;
import Concept.Signal;
import Concept.SwitchPosition;
import Concept.Trackelement;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Route</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link Concept.impl.RouteImpl#getRoute_entry <em>Route entry</em>}</li>
 *   <li>{@link Concept.impl.RouteImpl#getRoute_switchPosition <em>Route switch Position</em>}</li>
 *   <li>{@link Concept.impl.RouteImpl#getRoute_exit <em>Route exit</em>}</li>
 *   <li>{@link Concept.impl.RouteImpl#getRoute_routeDefinition <em>Route route Definition</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RouteImpl extends ThingImpl implements Route {
	/**
	 * The cached value of the '{@link #getRoute_entry() <em>Route entry</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRoute_entry()
	 * @generated
	 * @ordered
	 */
	protected Signal route_entry;

	/**
	 * The cached value of the '{@link #getRoute_switchPosition() <em>Route switch Position</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRoute_switchPosition()
	 * @generated
	 * @ordered
	 */
	protected EList<SwitchPosition> route_switchPosition;

	/**
	 * The cached value of the '{@link #getRoute_exit() <em>Route exit</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRoute_exit()
	 * @generated
	 * @ordered
	 */
	protected Signal route_exit;

	/**
	 * The cached value of the '{@link #getRoute_routeDefinition() <em>Route route Definition</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRoute_routeDefinition()
	 * @generated
	 * @ordered
	 */
	protected EList<Sensor> route_routeDefinition;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RouteImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ConceptPackage.Literals.ROUTE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Signal getRoute_entry() {
		if (route_entry != null && route_entry.eIsProxy()) {
			InternalEObject oldRoute_entry = (InternalEObject)route_entry;
			route_entry = (Signal)eResolveProxy(oldRoute_entry);
			if (route_entry != oldRoute_entry) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ConceptPackage.ROUTE__ROUTE_ENTRY, oldRoute_entry, route_entry));
			}
		}
		return route_entry;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Signal basicGetRoute_entry() {
		return route_entry;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRoute_entry(Signal newRoute_entry) {
		Signal oldRoute_entry = route_entry;
		route_entry = newRoute_entry;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ConceptPackage.ROUTE__ROUTE_ENTRY, oldRoute_entry, route_entry));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SwitchPosition> getRoute_switchPosition() {
		if (route_switchPosition == null) {
			route_switchPosition = new EObjectWithInverseResolvingEList<SwitchPosition>(SwitchPosition.class, this, ConceptPackage.ROUTE__ROUTE_SWITCH_POSITION, ConceptPackage.SWITCH_POSITION__SWITCH_POSITION_ROUTE);
		}
		return route_switchPosition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Signal getRoute_exit() {
		if (route_exit != null && route_exit.eIsProxy()) {
			InternalEObject oldRoute_exit = (InternalEObject)route_exit;
			route_exit = (Signal)eResolveProxy(oldRoute_exit);
			if (route_exit != oldRoute_exit) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ConceptPackage.ROUTE__ROUTE_EXIT, oldRoute_exit, route_exit));
			}
		}
		return route_exit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Signal basicGetRoute_exit() {
		return route_exit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRoute_exit(Signal newRoute_exit) {
		Signal oldRoute_exit = route_exit;
		route_exit = newRoute_exit;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ConceptPackage.ROUTE__ROUTE_EXIT, oldRoute_exit, route_exit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Sensor> getRoute_routeDefinition() {
		if (route_routeDefinition == null) {
			route_routeDefinition = new EObjectResolvingEList<Sensor>(Sensor.class, this, ConceptPackage.ROUTE__ROUTE_ROUTE_DEFINITION);
		}
		return route_routeDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean signalNeighbor() {
		/**
		 * 
		 * self.Route_exit->exists(signal |
		 *   self.Route_routeDefinition.Sensor_trackElement.TrackElement_connectsTo.TrackElement_sensor->exists(sen2 |
		 *     Route.allInstances()
		 *     ->exists(route2X | route2X <> self and
		 *       route2X.Route_routeDefinition->includes(sen2)) and
		 *     not Route.allInstances()
		 *     ->exists(route2 |
		 *       (
		 *         route2.Route_routeDefinition->includes(sen2) and route2.Route_entry = signal
		 *       ))))
		 */
		final /*@NonNull*/ /*@NonInvalid*/ DomainEvaluator evaluator = PivotUtil.getEvaluator(this);
		final /*@NonNull*/ /*@Thrown*/ Signal Route_exit = this.getRoute_exit();
		final /*@NonNull*/ /*@Thrown*/ SetValue oclAsSet = OclAnyOclAsSetOperation.INSTANCE.evaluate(evaluator, ConceptTables.SET_CLSSid_Signal, Route_exit);
		/*@Nullable*/ /*@Thrown*/ Object accumulator = ValuesUtil.FALSE_VALUE;
		/*@Nullable*/ Iterator<?> ITERATOR_signal = oclAsSet.iterator();
		/*@Nullable*/ /*@Thrown*/ Boolean exists;
		while (true) {
		    if (!ITERATOR_signal.hasNext()) {
		        if ((accumulator == null) || (accumulator == ValuesUtil.FALSE_VALUE)) {
		            exists = (Boolean)accumulator;
		        }
		        else {
		            throw (InvalidValueException)accumulator;
		        }
		        break;
		    }
		    /*@Nullable*/ /*@NonInvalid*/ Signal signal = (Signal)ITERATOR_signal.next();
		    /**
		     * 
		     * self.Route_routeDefinition.Sensor_trackElement.TrackElement_connectsTo.TrackElement_sensor->exists(sen2 |
		     *   Route.allInstances()
		     *   ->exists(route2X | route2X <> self and
		     *     route2X.Route_routeDefinition->includes(sen2)) and
		     *   not Route.allInstances()
		     *   ->exists(route2 |
		     *     (
		     *       route2.Route_routeDefinition->includes(sen2) and route2.Route_entry = signal
		     *     )))
		     */
		    final /*@NonNull*/ /*@NonInvalid*/ IdResolver idResolver = evaluator.getIdResolver();
		    /*@Nullable*/ /*@Caught*/ Object CAUGHT_exists_0;
		    try {
		        final /*@NonNull*/ /*@Thrown*/ List<Sensor> Route_routeDefinition = this.getRoute_routeDefinition();
		        final /*@NonNull*/ /*@Thrown*/ OrderedSetValue BOXED_Route_routeDefinition = idResolver.createOrderedSetOfAll(ConceptTables.ORD_CLSSid_Sensor, Route_routeDefinition);
		        /*@NonNull*/ /*@Thrown*/ SequenceValue.Accumulator accumulator_0 = ValuesUtil.createSequenceAccumulatorValue(ConceptTables.SEQ_CLSSid_Trackelement);
		        /*@Nullable*/ Iterator<?> ITERATOR__1 = BOXED_Route_routeDefinition.iterator();
		        /*@NonNull*/ /*@Thrown*/ SequenceValue collect_1;
		        while (true) {
		            if (!ITERATOR__1.hasNext()) {
		                collect_1 = accumulator_0;
		                break;
		            }
		            /*@Nullable*/ /*@NonInvalid*/ Sensor _1 = (Sensor)ITERATOR__1.next();
		            /**
		             * Sensor_trackElement
		             */
		            if (_1 == null) {
		                throw new InvalidValueException("Null source for \'Concept::Sensor.Sensor_trackElement\'");
		            }
		            final /*@NonNull*/ /*@Thrown*/ List<Trackelement> Sensor_trackElement = _1.getSensor_trackElement();
		            final /*@NonNull*/ /*@Thrown*/ OrderedSetValue BOXED_Sensor_trackElement = idResolver.createOrderedSetOfAll(ConceptTables.ORD_CLSSid_Trackelement, Sensor_trackElement);
		            //
		            for (Object value : BOXED_Sensor_trackElement.flatten().getElements()) {
		                accumulator_0.add(value);
		            }
		        }
		        /*@NonNull*/ /*@Thrown*/ SequenceValue.Accumulator accumulator_1 = ValuesUtil.createSequenceAccumulatorValue(ConceptTables.SEQ_CLSSid_Trackelement);
		        /*@Nullable*/ Iterator<?> ITERATOR__1_0 = collect_1.iterator();
		        /*@NonNull*/ /*@Thrown*/ SequenceValue collect_0;
		        while (true) {
		            if (!ITERATOR__1_0.hasNext()) {
		                collect_0 = accumulator_1;
		                break;
		            }
		            /*@Nullable*/ /*@NonInvalid*/ Trackelement _1_0 = (Trackelement)ITERATOR__1_0.next();
		            /**
		             * TrackElement_connectsTo
		             */
		            if (_1_0 == null) {
		                throw new InvalidValueException("Null source for \'Concept::Trackelement.TrackElement_connectsTo\'");
		            }
		            final /*@NonNull*/ /*@Thrown*/ List<Trackelement> TrackElement_connectsTo = _1_0.getTrackElement_connectsTo();
		            final /*@NonNull*/ /*@Thrown*/ OrderedSetValue BOXED_TrackElement_connectsTo = idResolver.createOrderedSetOfAll(ConceptTables.ORD_CLSSid_Trackelement, TrackElement_connectsTo);
		            //
		            for (Object value : BOXED_TrackElement_connectsTo.flatten().getElements()) {
		                accumulator_1.add(value);
		            }
		        }
		        /*@NonNull*/ /*@Thrown*/ SequenceValue.Accumulator accumulator_2 = ValuesUtil.createSequenceAccumulatorValue(ConceptTables.SEQ_CLSSid_Sensor);
		        /*@Nullable*/ Iterator<?> ITERATOR__1_1 = collect_0.iterator();
		        /*@NonNull*/ /*@Thrown*/ SequenceValue collect;
		        while (true) {
		            if (!ITERATOR__1_1.hasNext()) {
		                collect = accumulator_2;
		                break;
		            }
		            /*@Nullable*/ /*@NonInvalid*/ Trackelement _1_1 = (Trackelement)ITERATOR__1_1.next();
		            /**
		             * TrackElement_sensor
		             */
		            if (_1_1 == null) {
		                throw new InvalidValueException("Null source for \'Concept::Trackelement.TrackElement_sensor\'");
		            }
		            final /*@NonNull*/ /*@Thrown*/ List<Sensor> TrackElement_sensor = _1_1.getTrackElement_sensor();
		            final /*@NonNull*/ /*@Thrown*/ OrderedSetValue BOXED_TrackElement_sensor = idResolver.createOrderedSetOfAll(ConceptTables.ORD_CLSSid_Sensor, TrackElement_sensor);
		            //
		            for (Object value : BOXED_TrackElement_sensor.flatten().getElements()) {
		                accumulator_2.add(value);
		            }
		        }
		        /*@Nullable*/ /*@Thrown*/ Object accumulator_3 = ValuesUtil.FALSE_VALUE;
		        /*@Nullable*/ Iterator<?> ITERATOR_sen2 = collect.iterator();
		        /*@Nullable*/ /*@Thrown*/ Boolean exists_0;
		        while (true) {
		            if (!ITERATOR_sen2.hasNext()) {
		                if ((accumulator_3 == null) || (accumulator_3 == ValuesUtil.FALSE_VALUE)) {
		                    exists_0 = (Boolean)accumulator_3;
		                }
		                else {
		                    throw (InvalidValueException)accumulator_3;
		                }
		                break;
		            }
		            /*@Nullable*/ /*@NonInvalid*/ Sensor sen2 = (Sensor)ITERATOR_sen2.next();
		            /**
		             * 
		             * Route.allInstances()
		             * ->exists(route2X | route2X <> self and
		             *   route2X.Route_routeDefinition->includes(sen2)) and
		             * not Route.allInstances()
		             * ->exists(route2 |
		             *   (
		             *     route2.Route_routeDefinition->includes(sen2) and route2.Route_entry = signal
		             *   ))
		             */
		            /*@Nullable*/ /*@Caught*/ Object CAUGHT_symbol_26;
		            try {
		                /*@Nullable*/ /*@Caught*/ Object CAUGHT_self_1;
		                try {
		                    final /*@NonNull*/ /*@NonInvalid*/ DomainType TYP_Concept_c_c_Route_0 = idResolver.getType(ConceptTables.CLSSid_Route, null);
		                    final /*@NonNull*/ /*@Thrown*/ SetValue allInstances = ClassifierAllInstancesOperation.INSTANCE.evaluate(evaluator, ConceptTables.SET_CLSSid_Route, TYP_Concept_c_c_Route_0);
		                    /*@Nullable*/ /*@Thrown*/ Object accumulator_4 = ValuesUtil.FALSE_VALUE;
		                    /*@Nullable*/ Iterator<?> ITERATOR_route2X = allInstances.iterator();
		                    /*@Nullable*/ /*@Thrown*/ Boolean self_1;
		                    while (true) {
		                        if (!ITERATOR_route2X.hasNext()) {
		                            if (accumulator_4 == ValuesUtil.FALSE_VALUE) {
		                                self_1 = (Boolean)accumulator_4;
		                            }
		                            else {
		                                throw (InvalidValueException)accumulator_4;
		                            }
		                            break;
		                        }
		                        /*@Nullable*/ /*@NonInvalid*/ Route route2X = (Route)ITERATOR_route2X.next();
		                        /**
		                         * route2X <> self and route2X.Route_routeDefinition->includes(sen2)
		                         */
		                        /*@NonNull*/ /*@Caught*/ Object CAUGHT_symbol_3;
		                        try {
		                            final /*@NonInvalid*/ boolean self_2 = route2X != this;
		                            /*@NonNull*/ /*@Caught*/ Object CAUGHT_b;
		                            try {
		                                if (route2X == null) {
		                                    throw new InvalidValueException("Null source for \'Concept::Route.Route_routeDefinition\'");
		                                }
		                                final /*@NonNull*/ /*@Thrown*/ List<Sensor> Route_routeDefinition_0 = route2X.getRoute_routeDefinition();
		                                final /*@NonNull*/ /*@Thrown*/ OrderedSetValue BOXED_Route_routeDefinition_0 = idResolver.createOrderedSetOfAll(ConceptTables.ORD_CLSSid_Sensor, Route_routeDefinition_0);
		                                final /*@Thrown*/ boolean b = CollectionIncludesOperation.INSTANCE.evaluate(BOXED_Route_routeDefinition_0, sen2).booleanValue();
		                                CAUGHT_b = b;
		                            }
		                            catch (Exception e) {
		                                CAUGHT_b = ValuesUtil.createInvalidValue(e);
		                            }
		                            final /*@NonInvalid*/ boolean eq = !self_2;
		                            /*@Thrown*/ boolean symbol_3;
		                            if (eq) {
		                                symbol_3 = ValuesUtil.FALSE_VALUE;
		                            }
		                            else {
		                                if (CAUGHT_b instanceof InvalidValueException) {
		                                    throw (InvalidValueException)CAUGHT_b;
		                                }
		                                final /*@NonInvalid*/ boolean symbol_0 = CAUGHT_b instanceof InvalidValueException;
		                                /*@Thrown*/ boolean symbol_2;
		                                if (symbol_0) {
		                                    symbol_2 = (Boolean)CAUGHT_b;
		                                }
		                                else {
		                                    final /*@Thrown*/ boolean eq_0 = CAUGHT_b == Boolean.FALSE;
		                                    /*@NonInvalid*/ boolean symbol_1;
		                                    if (eq_0) {
		                                        symbol_1 = ValuesUtil.FALSE_VALUE;
		                                    }
		                                    else {
		                                        symbol_1 = ValuesUtil.TRUE_VALUE;
		                                    }
		                                    symbol_2 = symbol_1;
		                                }
		                                symbol_3 = symbol_2;
		                            }
		                            CAUGHT_symbol_3 = symbol_3;
		                        }
		                        catch (Exception e) {
		                            CAUGHT_symbol_3 = ValuesUtil.createInvalidValue(e);
		                        }
		                        //
		                        if (CAUGHT_symbol_3 == ValuesUtil.TRUE_VALUE) {					// Normal successful body evaluation result
		                            self_1 = ValuesUtil.TRUE_VALUE;
		                            break;														// Stop immediately 
		                        }
		                        else if (CAUGHT_symbol_3 == ValuesUtil.FALSE_VALUE) {				// Normal unsuccessful body evaluation result
		                            ;															// Carry on
		                        }
		                        else if (CAUGHT_symbol_3 instanceof InvalidValueException) {		// Abnormal exception evaluation result
		                            accumulator_4 = CAUGHT_symbol_3;									// Cache an exception failure
		                        }
		                        else {															// Impossible badly typed result
		                            accumulator_4 = new InvalidValueException(EvaluatorMessages.NonBooleanBody, "exists");
		                        }
		                    }
		                    CAUGHT_self_1 = self_1;
		                }
		                catch (Exception e) {
		                    CAUGHT_self_1 = ValuesUtil.createInvalidValue(e);
		                }
		                /*@Nullable*/ /*@Caught*/ Object CAUGHT_symbol_15;
		                try {
		                    /*@Nullable*/ /*@Caught*/ Object CAUGHT_self_3;
		                    try {
		                        final /*@NonNull*/ /*@NonInvalid*/ DomainType TYP_Concept_c_c_Route_1 = idResolver.getType(ConceptTables.CLSSid_Route, null);
		                        final /*@NonNull*/ /*@Thrown*/ SetValue allInstances_0 = ClassifierAllInstancesOperation.INSTANCE.evaluate(evaluator, ConceptTables.SET_CLSSid_Route, TYP_Concept_c_c_Route_1);
		                        /*@Nullable*/ /*@Thrown*/ Object accumulator_5 = ValuesUtil.FALSE_VALUE;
		                        /*@Nullable*/ Iterator<?> ITERATOR_route2 = allInstances_0.iterator();
		                        /*@Nullable*/ /*@Thrown*/ Boolean self_3;
		                        while (true) {
		                            if (!ITERATOR_route2.hasNext()) {
		                                if (accumulator_5 == ValuesUtil.FALSE_VALUE) {
		                                    self_3 = (Boolean)accumulator_5;
		                                }
		                                else {
		                                    throw (InvalidValueException)accumulator_5;
		                                }
		                                break;
		                            }
		                            /*@Nullable*/ /*@NonInvalid*/ Route route2 = (Route)ITERATOR_route2.next();
		                            /**
		                             * route2.Route_routeDefinition->includes(sen2) and route2.Route_entry = signal
		                             */
		                            /*@NonNull*/ /*@Caught*/ Object CAUGHT_symbol_12;
		                            try {
		                                /*@NonNull*/ /*@Caught*/ Object CAUGHT_self_4;
		                                try {
		                                    if (route2 == null) {
		                                        throw new InvalidValueException("Null source for \'Concept::Route.Route_routeDefinition\'");
		                                    }
		                                    final /*@NonNull*/ /*@Thrown*/ List<Sensor> Route_routeDefinition_1 = route2.getRoute_routeDefinition();
		                                    final /*@NonNull*/ /*@Thrown*/ OrderedSetValue BOXED_Route_routeDefinition_1 = idResolver.createOrderedSetOfAll(ConceptTables.ORD_CLSSid_Sensor, Route_routeDefinition_1);
		                                    final /*@Thrown*/ boolean self_4 = CollectionIncludesOperation.INSTANCE.evaluate(BOXED_Route_routeDefinition_1, sen2).booleanValue();
		                                    CAUGHT_self_4 = self_4;
		                                }
		                                catch (Exception e) {
		                                    CAUGHT_self_4 = ValuesUtil.createInvalidValue(e);
		                                }
		                                /*@NonNull*/ /*@Caught*/ Object CAUGHT_b_0;
		                                try {
		                                    if (route2 == null) {
		                                        throw new InvalidValueException("Null source for \'Concept::Route.Route_entry\'");
		                                    }
		                                    final /*@NonNull*/ /*@Thrown*/ Signal Route_entry = route2.getRoute_entry();
		                                    final /*@Thrown*/ boolean b_0 = Route_entry == signal;
		                                    CAUGHT_b_0 = b_0;
		                                }
		                                catch (Exception e) {
		                                    CAUGHT_b_0 = ValuesUtil.createInvalidValue(e);
		                                }
		                                final /*@NonInvalid*/ boolean symbol_4 = CAUGHT_self_4 instanceof InvalidValueException;
		                                /*@Thrown*/ boolean symbol_12;
		                                if (symbol_4) {
		                                    final /*@NonInvalid*/ boolean symbol_5 = CAUGHT_b_0 instanceof InvalidValueException;
		                                    /*@Thrown*/ boolean symbol_7;
		                                    if (symbol_5) {
		                                        if (CAUGHT_self_4 instanceof InvalidValueException) {
		                                            throw (InvalidValueException)CAUGHT_self_4;
		                                        }
		                                        symbol_7 = (Boolean)CAUGHT_self_4;
		                                    }
		                                    else {
		                                        if (CAUGHT_b_0 instanceof InvalidValueException) {
		                                            throw (InvalidValueException)CAUGHT_b_0;
		                                        }
		                                        final /*@Thrown*/ boolean eq_1 = CAUGHT_b_0 == Boolean.FALSE;
		                                        /*@Thrown*/ boolean symbol_6;
		                                        if (eq_1) {
		                                            symbol_6 = ValuesUtil.FALSE_VALUE;
		                                        }
		                                        else {
		                                            if (CAUGHT_self_4 instanceof InvalidValueException) {
		                                                throw (InvalidValueException)CAUGHT_self_4;
		                                            }
		                                            symbol_6 = (Boolean)CAUGHT_self_4;
		                                        }
		                                        symbol_7 = symbol_6;
		                                    }
		                                    symbol_12 = symbol_7;
		                                }
		                                else {
		                                    if (CAUGHT_self_4 instanceof InvalidValueException) {
		                                        throw (InvalidValueException)CAUGHT_self_4;
		                                    }
		                                    final /*@Thrown*/ boolean eq_2 = CAUGHT_self_4 == Boolean.FALSE;
		                                    /*@Thrown*/ boolean symbol_11;
		                                    if (eq_2) {
		                                        symbol_11 = ValuesUtil.FALSE_VALUE;
		                                    }
		                                    else {
		                                        if (CAUGHT_b_0 instanceof InvalidValueException) {
		                                            throw (InvalidValueException)CAUGHT_b_0;
		                                        }
		                                        final /*@NonInvalid*/ boolean symbol_8 = CAUGHT_b_0 instanceof InvalidValueException;
		                                        /*@Thrown*/ boolean symbol_10;
		                                        if (symbol_8) {
		                                            symbol_10 = (Boolean)CAUGHT_b_0;
		                                        }
		                                        else {
		                                            final /*@Thrown*/ boolean eq_3 = CAUGHT_b_0 == Boolean.FALSE;
		                                            /*@NonInvalid*/ boolean symbol_9;
		                                            if (eq_3) {
		                                                symbol_9 = ValuesUtil.FALSE_VALUE;
		                                            }
		                                            else {
		                                                symbol_9 = ValuesUtil.TRUE_VALUE;
		                                            }
		                                            symbol_10 = symbol_9;
		                                        }
		                                        symbol_11 = symbol_10;
		                                    }
		                                    symbol_12 = symbol_11;
		                                }
		                                CAUGHT_symbol_12 = symbol_12;
		                            }
		                            catch (Exception e) {
		                                CAUGHT_symbol_12 = ValuesUtil.createInvalidValue(e);
		                            }
		                            //
		                            if (CAUGHT_symbol_12 == ValuesUtil.TRUE_VALUE) {					// Normal successful body evaluation result
		                                self_3 = ValuesUtil.TRUE_VALUE;
		                                break;														// Stop immediately 
		                            }
		                            else if (CAUGHT_symbol_12 == ValuesUtil.FALSE_VALUE) {				// Normal unsuccessful body evaluation result
		                                ;															// Carry on
		                            }
		                            else if (CAUGHT_symbol_12 instanceof InvalidValueException) {		// Abnormal exception evaluation result
		                                accumulator_5 = CAUGHT_symbol_12;									// Cache an exception failure
		                            }
		                            else {															// Impossible badly typed result
		                                accumulator_5 = new InvalidValueException(EvaluatorMessages.NonBooleanBody, "exists");
		                            }
		                        }
		                        CAUGHT_self_3 = self_3;
		                    }
		                    catch (Exception e) {
		                        CAUGHT_self_3 = ValuesUtil.createInvalidValue(e);
		                    }
		                    if (CAUGHT_self_3 instanceof InvalidValueException) {
		                        throw (InvalidValueException)CAUGHT_self_3;
		                    }
		                    final /*@NonInvalid*/ boolean symbol_13 = CAUGHT_self_3 instanceof InvalidValueException;
		                    /*@Nullable*/ /*@Thrown*/ Boolean symbol_15;
		                    if (symbol_13) {
		                        symbol_15 = (Boolean)CAUGHT_self_3;
		                    }
		                    else {
		                        final /*@Thrown*/ boolean eq_4 = CAUGHT_self_3 == null;
		                        /*@Nullable*/ /*@Thrown*/ Boolean symbol_14;
		                        if (eq_4) {
		                            symbol_14 = null;
		                        }
		                        else {
		                            final /*@Thrown*/ boolean eq_5 = CAUGHT_self_3 == Boolean.FALSE;
		                            symbol_14 = (Boolean)eq_5;
		                        }
		                        symbol_15 = symbol_14;
		                    }
		                    CAUGHT_symbol_15 = symbol_15;
		                }
		                catch (Exception e) {
		                    CAUGHT_symbol_15 = ValuesUtil.createInvalidValue(e);
		                }
		                final /*@NonInvalid*/ boolean symbol_16 = CAUGHT_self_1 instanceof InvalidValueException;
		                /*@Nullable*/ /*@Thrown*/ Boolean symbol_26;
		                if (symbol_16) {
		                    final /*@NonInvalid*/ boolean symbol_17 = CAUGHT_symbol_15 instanceof InvalidValueException;
		                    /*@Nullable*/ /*@Thrown*/ Boolean symbol_19;
		                    if (symbol_17) {
		                        if (CAUGHT_self_1 instanceof InvalidValueException) {
		                            throw (InvalidValueException)CAUGHT_self_1;
		                        }
		                        symbol_19 = (Boolean)CAUGHT_self_1;
		                    }
		                    else {
		                        if (CAUGHT_symbol_15 instanceof InvalidValueException) {
		                            throw (InvalidValueException)CAUGHT_symbol_15;
		                        }
		                        final /*@Thrown*/ boolean eq_6 = CAUGHT_symbol_15 == Boolean.FALSE;
		                        /*@Nullable*/ /*@Thrown*/ Boolean symbol_18;
		                        if (eq_6) {
		                            symbol_18 = (Boolean)ValuesUtil.FALSE_VALUE;
		                        }
		                        else {
		                            if (CAUGHT_self_1 instanceof InvalidValueException) {
		                                throw (InvalidValueException)CAUGHT_self_1;
		                            }
		                            symbol_18 = (Boolean)CAUGHT_self_1;
		                        }
		                        symbol_19 = symbol_18;
		                    }
		                    symbol_26 = symbol_19;
		                }
		                else {
		                    if (CAUGHT_self_1 instanceof InvalidValueException) {
		                        throw (InvalidValueException)CAUGHT_self_1;
		                    }
		                    final /*@Thrown*/ boolean eq_7 = CAUGHT_self_1 == Boolean.FALSE;
		                    /*@Nullable*/ /*@Thrown*/ Boolean symbol_25;
		                    if (eq_7) {
		                        symbol_25 = (Boolean)ValuesUtil.FALSE_VALUE;
		                    }
		                    else {
		                        if (CAUGHT_symbol_15 instanceof InvalidValueException) {
		                            throw (InvalidValueException)CAUGHT_symbol_15;
		                        }
		                        final /*@NonInvalid*/ boolean symbol_20 = CAUGHT_symbol_15 instanceof InvalidValueException;
		                        /*@Nullable*/ /*@Thrown*/ Boolean symbol_24;
		                        if (symbol_20) {
		                            symbol_24 = (Boolean)CAUGHT_symbol_15;
		                        }
		                        else {
		                            final /*@Thrown*/ boolean eq_8 = CAUGHT_symbol_15 == Boolean.FALSE;
		                            /*@Nullable*/ /*@NonInvalid*/ Boolean symbol_23;
		                            if (eq_8) {
		                                symbol_23 = (Boolean)ValuesUtil.FALSE_VALUE;
		                            }
		                            else {
		                                final /*@Thrown*/ boolean eq_9 = CAUGHT_self_1 == null;
		                                /*@Nullable*/ /*@NonInvalid*/ Boolean symbol_22;
		                                if (eq_9) {
		                                    symbol_22 = null;
		                                }
		                                else {
		                                    final /*@Thrown*/ boolean eq_10 = CAUGHT_symbol_15 == null;
		                                    /*@Nullable*/ /*@NonInvalid*/ Boolean symbol_21;
		                                    if (eq_10) {
		                                        symbol_21 = null;
		                                    }
		                                    else {
		                                        symbol_21 = (Boolean)ValuesUtil.TRUE_VALUE;
		                                    }
		                                    symbol_22 = symbol_21;
		                                }
		                                symbol_23 = symbol_22;
		                            }
		                            symbol_24 = symbol_23;
		                        }
		                        symbol_25 = symbol_24;
		                    }
		                    symbol_26 = symbol_25;
		                }
		                CAUGHT_symbol_26 = symbol_26;
		            }
		            catch (Exception e) {
		                CAUGHT_symbol_26 = ValuesUtil.createInvalidValue(e);
		            }
		            //
		            if (CAUGHT_symbol_26 == ValuesUtil.TRUE_VALUE) {					// Normal successful body evaluation result
		                exists_0 = ValuesUtil.TRUE_VALUE;
		                break;														// Stop immediately 
		            }
		            else if (CAUGHT_symbol_26 == ValuesUtil.FALSE_VALUE) {				// Normal unsuccessful body evaluation result
		                ;															// Carry on
		            }
		            else if (CAUGHT_symbol_26 == null) {								// Abnormal null body evaluation result
		                if (accumulator_3 == ValuesUtil.FALSE_VALUE) {
		                    accumulator_3 = null;										// Cache a null failure
		                }
		            }
		            else if (CAUGHT_symbol_26 instanceof InvalidValueException) {		// Abnormal exception evaluation result
		                accumulator_3 = CAUGHT_symbol_26;									// Cache an exception failure
		            }
		            else {															// Impossible badly typed result
		                accumulator_3 = new InvalidValueException(EvaluatorMessages.NonBooleanBody, "exists");
		            }
		        }
		        CAUGHT_exists_0 = exists_0;
		    }
		    catch (Exception e) {
		        CAUGHT_exists_0 = ValuesUtil.createInvalidValue(e);
		    }
		    //
		    if (CAUGHT_exists_0 == ValuesUtil.TRUE_VALUE) {					// Normal successful body evaluation result
		        exists = ValuesUtil.TRUE_VALUE;
		        break;														// Stop immediately 
		    }
		    else if (CAUGHT_exists_0 == ValuesUtil.FALSE_VALUE) {				// Normal unsuccessful body evaluation result
		        ;															// Carry on
		    }
		    else if (CAUGHT_exists_0 == null) {								// Abnormal null body evaluation result
		        if (accumulator == ValuesUtil.FALSE_VALUE) {
		            accumulator = null;										// Cache a null failure
		        }
		    }
		    else if (CAUGHT_exists_0 instanceof InvalidValueException) {		// Abnormal exception evaluation result
		        accumulator = CAUGHT_exists_0;									// Cache an exception failure
		    }
		    else {															// Impossible badly typed result
		        accumulator = new InvalidValueException(EvaluatorMessages.NonBooleanBody, "exists");
		    }
		}
		if (exists == null) {
		    throw new InvalidValueException("Null body for \'Concept::Route.signalNeighbor() : Boolean\'");
		}
		return exists;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ConceptPackage.ROUTE__ROUTE_SWITCH_POSITION:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getRoute_switchPosition()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ConceptPackage.ROUTE__ROUTE_SWITCH_POSITION:
				return ((InternalEList<?>)getRoute_switchPosition()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ConceptPackage.ROUTE__ROUTE_ENTRY:
				if (resolve) return getRoute_entry();
				return basicGetRoute_entry();
			case ConceptPackage.ROUTE__ROUTE_SWITCH_POSITION:
				return getRoute_switchPosition();
			case ConceptPackage.ROUTE__ROUTE_EXIT:
				if (resolve) return getRoute_exit();
				return basicGetRoute_exit();
			case ConceptPackage.ROUTE__ROUTE_ROUTE_DEFINITION:
				return getRoute_routeDefinition();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ConceptPackage.ROUTE__ROUTE_ENTRY:
				setRoute_entry((Signal)newValue);
				return;
			case ConceptPackage.ROUTE__ROUTE_SWITCH_POSITION:
				getRoute_switchPosition().clear();
				getRoute_switchPosition().addAll((Collection<? extends SwitchPosition>)newValue);
				return;
			case ConceptPackage.ROUTE__ROUTE_EXIT:
				setRoute_exit((Signal)newValue);
				return;
			case ConceptPackage.ROUTE__ROUTE_ROUTE_DEFINITION:
				getRoute_routeDefinition().clear();
				getRoute_routeDefinition().addAll((Collection<? extends Sensor>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ConceptPackage.ROUTE__ROUTE_ENTRY:
				setRoute_entry((Signal)null);
				return;
			case ConceptPackage.ROUTE__ROUTE_SWITCH_POSITION:
				getRoute_switchPosition().clear();
				return;
			case ConceptPackage.ROUTE__ROUTE_EXIT:
				setRoute_exit((Signal)null);
				return;
			case ConceptPackage.ROUTE__ROUTE_ROUTE_DEFINITION:
				getRoute_routeDefinition().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ConceptPackage.ROUTE__ROUTE_ENTRY:
				return route_entry != null;
			case ConceptPackage.ROUTE__ROUTE_SWITCH_POSITION:
				return route_switchPosition != null && !route_switchPosition.isEmpty();
			case ConceptPackage.ROUTE__ROUTE_EXIT:
				return route_exit != null;
			case ConceptPackage.ROUTE__ROUTE_ROUTE_DEFINITION:
				return route_routeDefinition != null && !route_routeDefinition.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
			case ConceptPackage.ROUTE___SIGNAL_NEIGHBOR:
				return signalNeighbor();
		}
		return super.eInvoke(operationID, arguments);
	}

} //RouteImpl
