/**
 */
package Concept;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Route</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link Concept.Route#getRoute_entry <em>Route entry</em>}</li>
 *   <li>{@link Concept.Route#getRoute_switchPosition <em>Route switch Position</em>}</li>
 *   <li>{@link Concept.Route#getRoute_exit <em>Route exit</em>}</li>
 *   <li>{@link Concept.Route#getRoute_routeDefinition <em>Route route Definition</em>}</li>
 * </ul>
 * </p>
 *
 * @see Concept.ConceptPackage#getRoute()
 * @model
 * @generated
 */
public interface Route extends Thing {
	/**
	 * Returns the value of the '<em><b>Route entry</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Route entry</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Route entry</em>' reference.
	 * @see #setRoute_entry(Signal)
	 * @see Concept.ConceptPackage#getRoute_Route_entry()
	 * @model required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl!Route!Route_entry'"
	 * @generated
	 */
	Signal getRoute_entry();

	/**
	 * Sets the value of the '{@link Concept.Route#getRoute_entry <em>Route entry</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Route entry</em>' reference.
	 * @see #getRoute_entry()
	 * @generated
	 */
	void setRoute_entry(Signal value);

	/**
	 * Returns the value of the '<em><b>Route switch Position</b></em>' reference list.
	 * The list contents are of type {@link Concept.SwitchPosition}.
	 * It is bidirectional and its opposite is '{@link Concept.SwitchPosition#getSwitchPosition_route <em>Switch Position route</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Route switch Position</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Route switch Position</em>' reference list.
	 * @see Concept.ConceptPackage#getRoute_Route_switchPosition()
	 * @see Concept.SwitchPosition#getSwitchPosition_route
	 * @model opposite="SwitchPosition_route"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl!Route!Route_switchPosition'"
	 * @generated
	 */
	EList<SwitchPosition> getRoute_switchPosition();

	/**
	 * Returns the value of the '<em><b>Route exit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Route exit</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Route exit</em>' reference.
	 * @see #setRoute_exit(Signal)
	 * @see Concept.ConceptPackage#getRoute_Route_exit()
	 * @model required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl!Route!Route_exit'"
	 * @generated
	 */
	Signal getRoute_exit();

	/**
	 * Sets the value of the '{@link Concept.Route#getRoute_exit <em>Route exit</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Route exit</em>' reference.
	 * @see #getRoute_exit()
	 * @generated
	 */
	void setRoute_exit(Signal value);

	/**
	 * Returns the value of the '<em><b>Route route Definition</b></em>' reference list.
	 * The list contents are of type {@link Concept.Sensor}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Route route Definition</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Route route Definition</em>' reference list.
	 * @see Concept.ConceptPackage#getRoute_Route_routeDefinition()
	 * @model lower="2"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.semanticweb.org/ontologies/2011/1/TrainRequirementOntology.owl!Route!Route_routeDefinition'"
	 * @generated
	 */
	EList<Sensor> getRoute_routeDefinition();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='/**\n * \n * self.Route_exit->exists(signal |\n *   self.Route_routeDefinition.Sensor_trackElement.TrackElement_connectsTo.TrackElement_sensor->exists(sen2 |\n *     Route.allInstances()\n *     ->exists(route2X | route2X <> self and\n *       route2X.Route_routeDefinition->includes(sen2)) and\n *     not Route.allInstances()\n *     ->exists(route2 |\n *       (\n *         route2.Route_routeDefinition->includes(sen2) and route2.Route_entry = signal\n *       ))))\n \052/\nfinal /*@NonNull\052/ /*@NonInvalid\052/ <%org.eclipse.ocl.examples.domain.evaluation.DomainEvaluator%> evaluator = <%org.eclipse.ocl.examples.pivot.utilities.PivotUtil%>.getEvaluator(this);\nfinal /*@NonNull\052/ /*@Thrown\052/ <%Concept.Signal%> Route_exit = this.getRoute_exit();\nfinal /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.SetValue%> oclAsSet = <%org.eclipse.ocl.examples.library.oclany.OclAnyOclAsSetOperation%>.INSTANCE.evaluate(evaluator, <%Concept.ConceptTables%>.SET_CLSSid_Signal, Route_exit);\n/*@Nullable\052/ /*@Thrown\052/ <%java.lang.Object%> accumulator = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE;\n/*@Nullable\052/ <%java.util.Iterator%><?> ITERATOR_signal = oclAsSet.iterator();\n/*@Nullable\052/ /*@Thrown\052/ <%java.lang.Boolean%> exists;\nwhile (true) {\n    if (!ITERATOR_signal.hasNext()) {\n        if ((accumulator == null) || (accumulator == <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE)) {\n            exists = (<%java.lang.Boolean%>)accumulator;\n        }\n        else {\n            throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)accumulator;\n        }\n        break;\n    }\n    /*@Nullable\052/ /*@NonInvalid\052/ <%Concept.Signal%> signal = (<%Concept.Signal%>)ITERATOR_signal.next();\n    /**\n     * \n     * self.Route_routeDefinition.Sensor_trackElement.TrackElement_connectsTo.TrackElement_sensor->exists(sen2 |\n     *   Route.allInstances()\n     *   ->exists(route2X | route2X <> self and\n     *     route2X.Route_routeDefinition->includes(sen2)) and\n     *   not Route.allInstances()\n     *   ->exists(route2 |\n     *     (\n     *       route2.Route_routeDefinition->includes(sen2) and route2.Route_entry = signal\n     *     )))\n     \052/\n    final /*@NonNull\052/ /*@NonInvalid\052/ <%org.eclipse.ocl.examples.domain.types.IdResolver%> idResolver = evaluator.getIdResolver();\n    /*@Nullable\052/ /*@Caught\052/ <%java.lang.Object%> CAUGHT_exists_0;\n    try {\n        final /*@NonNull\052/ /*@Thrown\052/ <%java.util.List%><<%Concept.Sensor%>> Route_routeDefinition = this.getRoute_routeDefinition();\n        final /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.OrderedSetValue%> BOXED_Route_routeDefinition = idResolver.createOrderedSetOfAll(<%Concept.ConceptTables%>.ORD_CLSSid_Sensor, Route_routeDefinition);\n        /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.SequenceValue%>.Accumulator accumulator_0 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.createSequenceAccumulatorValue(<%Concept.ConceptTables%>.SEQ_CLSSid_Trackelement);\n        /*@Nullable\052/ <%java.util.Iterator%><?> ITERATOR__1 = BOXED_Route_routeDefinition.iterator();\n        /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.SequenceValue%> collect_1;\n        while (true) {\n            if (!ITERATOR__1.hasNext()) {\n                collect_1 = accumulator_0;\n                break;\n            }\n            /*@Nullable\052/ /*@NonInvalid\052/ <%Concept.Sensor%> _1 = (<%Concept.Sensor%>)ITERATOR__1.next();\n            /**\n             * Sensor_trackElement\n             \052/\n            if (_1 == null) {\n                throw new <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>(\"Null source for \\\'Concept::Sensor.Sensor_trackElement\\\'\");\n            }\n            final /*@NonNull\052/ /*@Thrown\052/ <%java.util.List%><<%Concept.Trackelement%>> Sensor_trackElement = _1.getSensor_trackElement();\n            final /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.OrderedSetValue%> BOXED_Sensor_trackElement = idResolver.createOrderedSetOfAll(<%Concept.ConceptTables%>.ORD_CLSSid_Trackelement, Sensor_trackElement);\n            //\n            for (Object value : BOXED_Sensor_trackElement.flatten().getElements()) {\n                accumulator_0.add(value);\n            }\n        }\n        /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.SequenceValue%>.Accumulator accumulator_1 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.createSequenceAccumulatorValue(<%Concept.ConceptTables%>.SEQ_CLSSid_Trackelement);\n        /*@Nullable\052/ <%java.util.Iterator%><?> ITERATOR__1_0 = collect_1.iterator();\n        /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.SequenceValue%> collect_0;\n        while (true) {\n            if (!ITERATOR__1_0.hasNext()) {\n                collect_0 = accumulator_1;\n                break;\n            }\n            /*@Nullable\052/ /*@NonInvalid\052/ <%Concept.Trackelement%> _1_0 = (<%Concept.Trackelement%>)ITERATOR__1_0.next();\n            /**\n             * TrackElement_connectsTo\n             \052/\n            if (_1_0 == null) {\n                throw new <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>(\"Null source for \\\'Concept::Trackelement.TrackElement_connectsTo\\\'\");\n            }\n            final /*@NonNull\052/ /*@Thrown\052/ <%java.util.List%><<%Concept.Trackelement%>> TrackElement_connectsTo = _1_0.getTrackElement_connectsTo();\n            final /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.OrderedSetValue%> BOXED_TrackElement_connectsTo = idResolver.createOrderedSetOfAll(<%Concept.ConceptTables%>.ORD_CLSSid_Trackelement, TrackElement_connectsTo);\n            //\n            for (Object value : BOXED_TrackElement_connectsTo.flatten().getElements()) {\n                accumulator_1.add(value);\n            }\n        }\n        /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.SequenceValue%>.Accumulator accumulator_2 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.createSequenceAccumulatorValue(<%Concept.ConceptTables%>.SEQ_CLSSid_Sensor);\n        /*@Nullable\052/ <%java.util.Iterator%><?> ITERATOR__1_1 = collect_0.iterator();\n        /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.SequenceValue%> collect;\n        while (true) {\n            if (!ITERATOR__1_1.hasNext()) {\n                collect = accumulator_2;\n                break;\n            }\n            /*@Nullable\052/ /*@NonInvalid\052/ <%Concept.Trackelement%> _1_1 = (<%Concept.Trackelement%>)ITERATOR__1_1.next();\n            /**\n             * TrackElement_sensor\n             \052/\n            if (_1_1 == null) {\n                throw new <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>(\"Null source for \\\'Concept::Trackelement.TrackElement_sensor\\\'\");\n            }\n            final /*@NonNull\052/ /*@Thrown\052/ <%java.util.List%><<%Concept.Sensor%>> TrackElement_sensor = _1_1.getTrackElement_sensor();\n            final /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.OrderedSetValue%> BOXED_TrackElement_sensor = idResolver.createOrderedSetOfAll(<%Concept.ConceptTables%>.ORD_CLSSid_Sensor, TrackElement_sensor);\n            //\n            for (Object value : BOXED_TrackElement_sensor.flatten().getElements()) {\n                accumulator_2.add(value);\n            }\n        }\n        /*@Nullable\052/ /*@Thrown\052/ <%java.lang.Object%> accumulator_3 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE;\n        /*@Nullable\052/ <%java.util.Iterator%><?> ITERATOR_sen2 = collect.iterator();\n        /*@Nullable\052/ /*@Thrown\052/ <%java.lang.Boolean%> exists_0;\n        while (true) {\n            if (!ITERATOR_sen2.hasNext()) {\n                if ((accumulator_3 == null) || (accumulator_3 == <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE)) {\n                    exists_0 = (<%java.lang.Boolean%>)accumulator_3;\n                }\n                else {\n                    throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)accumulator_3;\n                }\n                break;\n            }\n            /*@Nullable\052/ /*@NonInvalid\052/ <%Concept.Sensor%> sen2 = (<%Concept.Sensor%>)ITERATOR_sen2.next();\n            /**\n             * \n             * Route.allInstances()\n             * ->exists(route2X | route2X <> self and\n             *   route2X.Route_routeDefinition->includes(sen2)) and\n             * not Route.allInstances()\n             * ->exists(route2 |\n             *   (\n             *     route2.Route_routeDefinition->includes(sen2) and route2.Route_entry = signal\n             *   ))\n             \052/\n            /*@Nullable\052/ /*@Caught\052/ <%java.lang.Object%> CAUGHT_symbol_26;\n            try {\n                /*@Nullable\052/ /*@Caught\052/ <%java.lang.Object%> CAUGHT_self_1;\n                try {\n                    final /*@NonNull\052/ /*@NonInvalid\052/ <%org.eclipse.ocl.examples.domain.elements.DomainType%> TYP_Concept_c_c_Route_0 = idResolver.getType(<%Concept.ConceptTables%>.CLSSid_Route, null);\n                    final /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.SetValue%> allInstances = <%org.eclipse.ocl.examples.library.classifier.ClassifierAllInstancesOperation%>.INSTANCE.evaluate(evaluator, <%Concept.ConceptTables%>.SET_CLSSid_Route, TYP_Concept_c_c_Route_0);\n                    /*@Nullable\052/ /*@Thrown\052/ <%java.lang.Object%> accumulator_4 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE;\n                    /*@Nullable\052/ <%java.util.Iterator%><?> ITERATOR_route2X = allInstances.iterator();\n                    /*@Nullable\052/ /*@Thrown\052/ <%java.lang.Boolean%> self_1;\n                    while (true) {\n                        if (!ITERATOR_route2X.hasNext()) {\n                            if (accumulator_4 == <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE) {\n                                self_1 = (<%java.lang.Boolean%>)accumulator_4;\n                            }\n                            else {\n                                throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)accumulator_4;\n                            }\n                            break;\n                        }\n                        /*@Nullable\052/ /*@NonInvalid\052/ <%Concept.Route%> route2X = (<%Concept.Route%>)ITERATOR_route2X.next();\n                        /**\n                         * route2X <> self and route2X.Route_routeDefinition->includes(sen2)\n                         \052/\n                        /*@NonNull\052/ /*@Caught\052/ <%java.lang.Object%> CAUGHT_symbol_3;\n                        try {\n                            final /*@NonInvalid\052/ boolean self_2 = route2X != this;\n                            /*@NonNull\052/ /*@Caught\052/ <%java.lang.Object%> CAUGHT_b;\n                            try {\n                                if (route2X == null) {\n                                    throw new <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>(\"Null source for \\\'Concept::Route.Route_routeDefinition\\\'\");\n                                }\n                                final /*@NonNull\052/ /*@Thrown\052/ <%java.util.List%><<%Concept.Sensor%>> Route_routeDefinition_0 = route2X.getRoute_routeDefinition();\n                                final /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.OrderedSetValue%> BOXED_Route_routeDefinition_0 = idResolver.createOrderedSetOfAll(<%Concept.ConceptTables%>.ORD_CLSSid_Sensor, Route_routeDefinition_0);\n                                final /*@Thrown\052/ boolean b = <%org.eclipse.ocl.examples.library.collection.CollectionIncludesOperation%>.INSTANCE.evaluate(BOXED_Route_routeDefinition_0, sen2).booleanValue();\n                                CAUGHT_b = b;\n                            }\n                            catch (<%java.lang.Exception%> e) {\n                                CAUGHT_b = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.createInvalidValue(e);\n                            }\n                            final /*@NonInvalid\052/ boolean eq = !self_2;\n                            /*@Thrown\052/ boolean symbol_3;\n                            if (eq) {\n                                symbol_3 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE;\n                            }\n                            else {\n                                if (CAUGHT_b instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\n                                    throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)CAUGHT_b;\n                                }\n                                final /*@NonInvalid\052/ boolean symbol_0 = CAUGHT_b instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>;\n                                /*@Thrown\052/ boolean symbol_2;\n                                if (symbol_0) {\n                                    symbol_2 = (<%java.lang.Boolean%>)CAUGHT_b;\n                                }\n                                else {\n                                    final /*@Thrown\052/ boolean eq_0 = CAUGHT_b == Boolean.FALSE;\n                                    /*@NonInvalid\052/ boolean symbol_1;\n                                    if (eq_0) {\n                                        symbol_1 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE;\n                                    }\n                                    else {\n                                        symbol_1 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.TRUE_VALUE;\n                                    }\n                                    symbol_2 = symbol_1;\n                                }\n                                symbol_3 = symbol_2;\n                            }\n                            CAUGHT_symbol_3 = symbol_3;\n                        }\n                        catch (<%java.lang.Exception%> e) {\n                            CAUGHT_symbol_3 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.createInvalidValue(e);\n                        }\n                        //\n                        if (CAUGHT_symbol_3 == <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n                            self_1 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.TRUE_VALUE;\n                            break;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately \n                        }\n                        else if (CAUGHT_symbol_3 == <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n                            ;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n                        }\n                        else if (CAUGHT_symbol_3 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\t\t// Abnormal exception evaluation result\n                            accumulator_4 = CAUGHT_symbol_3;\t\t\t\t\t\t\t\t\t// Cache an exception failure\n                        }\n                        else {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n                            accumulator_4 = new <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>(<%org.eclipse.ocl.examples.domain.messages.EvaluatorMessages%>.NonBooleanBody, \"exists\");\n                        }\n                    }\n                    CAUGHT_self_1 = self_1;\n                }\n                catch (<%java.lang.Exception%> e) {\n                    CAUGHT_self_1 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.createInvalidValue(e);\n                }\n                /*@Nullable\052/ /*@Caught\052/ <%java.lang.Object%> CAUGHT_symbol_15;\n                try {\n                    /*@Nullable\052/ /*@Caught\052/ <%java.lang.Object%> CAUGHT_self_3;\n                    try {\n                        final /*@NonNull\052/ /*@NonInvalid\052/ <%org.eclipse.ocl.examples.domain.elements.DomainType%> TYP_Concept_c_c_Route_1 = idResolver.getType(<%Concept.ConceptTables%>.CLSSid_Route, null);\n                        final /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.SetValue%> allInstances_0 = <%org.eclipse.ocl.examples.library.classifier.ClassifierAllInstancesOperation%>.INSTANCE.evaluate(evaluator, <%Concept.ConceptTables%>.SET_CLSSid_Route, TYP_Concept_c_c_Route_1);\n                        /*@Nullable\052/ /*@Thrown\052/ <%java.lang.Object%> accumulator_5 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE;\n                        /*@Nullable\052/ <%java.util.Iterator%><?> ITERATOR_route2 = allInstances_0.iterator();\n                        /*@Nullable\052/ /*@Thrown\052/ <%java.lang.Boolean%> self_3;\n                        while (true) {\n                            if (!ITERATOR_route2.hasNext()) {\n                                if (accumulator_5 == <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE) {\n                                    self_3 = (<%java.lang.Boolean%>)accumulator_5;\n                                }\n                                else {\n                                    throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)accumulator_5;\n                                }\n                                break;\n                            }\n                            /*@Nullable\052/ /*@NonInvalid\052/ <%Concept.Route%> route2 = (<%Concept.Route%>)ITERATOR_route2.next();\n                            /**\n                             * route2.Route_routeDefinition->includes(sen2) and route2.Route_entry = signal\n                             \052/\n                            /*@NonNull\052/ /*@Caught\052/ <%java.lang.Object%> CAUGHT_symbol_12;\n                            try {\n                                /*@NonNull\052/ /*@Caught\052/ <%java.lang.Object%> CAUGHT_self_4;\n                                try {\n                                    if (route2 == null) {\n                                        throw new <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>(\"Null source for \\\'Concept::Route.Route_routeDefinition\\\'\");\n                                    }\n                                    final /*@NonNull\052/ /*@Thrown\052/ <%java.util.List%><<%Concept.Sensor%>> Route_routeDefinition_1 = route2.getRoute_routeDefinition();\n                                    final /*@NonNull\052/ /*@Thrown\052/ <%org.eclipse.ocl.examples.domain.values.OrderedSetValue%> BOXED_Route_routeDefinition_1 = idResolver.createOrderedSetOfAll(<%Concept.ConceptTables%>.ORD_CLSSid_Sensor, Route_routeDefinition_1);\n                                    final /*@Thrown\052/ boolean self_4 = <%org.eclipse.ocl.examples.library.collection.CollectionIncludesOperation%>.INSTANCE.evaluate(BOXED_Route_routeDefinition_1, sen2).booleanValue();\n                                    CAUGHT_self_4 = self_4;\n                                }\n                                catch (<%java.lang.Exception%> e) {\n                                    CAUGHT_self_4 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.createInvalidValue(e);\n                                }\n                                /*@NonNull\052/ /*@Caught\052/ <%java.lang.Object%> CAUGHT_b_0;\n                                try {\n                                    if (route2 == null) {\n                                        throw new <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>(\"Null source for \\\'Concept::Route.Route_entry\\\'\");\n                                    }\n                                    final /*@NonNull\052/ /*@Thrown\052/ <%Concept.Signal%> Route_entry = route2.getRoute_entry();\n                                    final /*@Thrown\052/ boolean b_0 = Route_entry == signal;\n                                    CAUGHT_b_0 = b_0;\n                                }\n                                catch (<%java.lang.Exception%> e) {\n                                    CAUGHT_b_0 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.createInvalidValue(e);\n                                }\n                                final /*@NonInvalid\052/ boolean symbol_4 = CAUGHT_self_4 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>;\n                                /*@Thrown\052/ boolean symbol_12;\n                                if (symbol_4) {\n                                    final /*@NonInvalid\052/ boolean symbol_5 = CAUGHT_b_0 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>;\n                                    /*@Thrown\052/ boolean symbol_7;\n                                    if (symbol_5) {\n                                        if (CAUGHT_self_4 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\n                                            throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)CAUGHT_self_4;\n                                        }\n                                        symbol_7 = (<%java.lang.Boolean%>)CAUGHT_self_4;\n                                    }\n                                    else {\n                                        if (CAUGHT_b_0 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\n                                            throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)CAUGHT_b_0;\n                                        }\n                                        final /*@Thrown\052/ boolean eq_1 = CAUGHT_b_0 == Boolean.FALSE;\n                                        /*@Thrown\052/ boolean symbol_6;\n                                        if (eq_1) {\n                                            symbol_6 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE;\n                                        }\n                                        else {\n                                            if (CAUGHT_self_4 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\n                                                throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)CAUGHT_self_4;\n                                            }\n                                            symbol_6 = (<%java.lang.Boolean%>)CAUGHT_self_4;\n                                        }\n                                        symbol_7 = symbol_6;\n                                    }\n                                    symbol_12 = symbol_7;\n                                }\n                                else {\n                                    if (CAUGHT_self_4 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\n                                        throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)CAUGHT_self_4;\n                                    }\n                                    final /*@Thrown\052/ boolean eq_2 = CAUGHT_self_4 == Boolean.FALSE;\n                                    /*@Thrown\052/ boolean symbol_11;\n                                    if (eq_2) {\n                                        symbol_11 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE;\n                                    }\n                                    else {\n                                        if (CAUGHT_b_0 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\n                                            throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)CAUGHT_b_0;\n                                        }\n                                        final /*@NonInvalid\052/ boolean symbol_8 = CAUGHT_b_0 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>;\n                                        /*@Thrown\052/ boolean symbol_10;\n                                        if (symbol_8) {\n                                            symbol_10 = (<%java.lang.Boolean%>)CAUGHT_b_0;\n                                        }\n                                        else {\n                                            final /*@Thrown\052/ boolean eq_3 = CAUGHT_b_0 == Boolean.FALSE;\n                                            /*@NonInvalid\052/ boolean symbol_9;\n                                            if (eq_3) {\n                                                symbol_9 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE;\n                                            }\n                                            else {\n                                                symbol_9 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.TRUE_VALUE;\n                                            }\n                                            symbol_10 = symbol_9;\n                                        }\n                                        symbol_11 = symbol_10;\n                                    }\n                                    symbol_12 = symbol_11;\n                                }\n                                CAUGHT_symbol_12 = symbol_12;\n                            }\n                            catch (<%java.lang.Exception%> e) {\n                                CAUGHT_symbol_12 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.createInvalidValue(e);\n                            }\n                            //\n                            if (CAUGHT_symbol_12 == <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n                                self_3 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.TRUE_VALUE;\n                                break;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately \n                            }\n                            else if (CAUGHT_symbol_12 == <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n                                ;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n                            }\n                            else if (CAUGHT_symbol_12 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\t\t// Abnormal exception evaluation result\n                                accumulator_5 = CAUGHT_symbol_12;\t\t\t\t\t\t\t\t\t// Cache an exception failure\n                            }\n                            else {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n                                accumulator_5 = new <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>(<%org.eclipse.ocl.examples.domain.messages.EvaluatorMessages%>.NonBooleanBody, \"exists\");\n                            }\n                        }\n                        CAUGHT_self_3 = self_3;\n                    }\n                    catch (<%java.lang.Exception%> e) {\n                        CAUGHT_self_3 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.createInvalidValue(e);\n                    }\n                    if (CAUGHT_self_3 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\n                        throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)CAUGHT_self_3;\n                    }\n                    final /*@NonInvalid\052/ boolean symbol_13 = CAUGHT_self_3 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>;\n                    /*@Nullable\052/ /*@Thrown\052/ <%java.lang.Boolean%> symbol_15;\n                    if (symbol_13) {\n                        symbol_15 = (<%java.lang.Boolean%>)CAUGHT_self_3;\n                    }\n                    else {\n                        final /*@Thrown\052/ boolean eq_4 = CAUGHT_self_3 == null;\n                        /*@Nullable\052/ /*@Thrown\052/ <%java.lang.Boolean%> symbol_14;\n                        if (eq_4) {\n                            symbol_14 = null;\n                        }\n                        else {\n                            final /*@Thrown\052/ boolean eq_5 = CAUGHT_self_3 == Boolean.FALSE;\n                            symbol_14 = (<%java.lang.Boolean%>)eq_5;\n                        }\n                        symbol_15 = symbol_14;\n                    }\n                    CAUGHT_symbol_15 = symbol_15;\n                }\n                catch (<%java.lang.Exception%> e) {\n                    CAUGHT_symbol_15 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.createInvalidValue(e);\n                }\n                final /*@NonInvalid\052/ boolean symbol_16 = CAUGHT_self_1 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>;\n                /*@Nullable\052/ /*@Thrown\052/ <%java.lang.Boolean%> symbol_26;\n                if (symbol_16) {\n                    final /*@NonInvalid\052/ boolean symbol_17 = CAUGHT_symbol_15 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>;\n                    /*@Nullable\052/ /*@Thrown\052/ <%java.lang.Boolean%> symbol_19;\n                    if (symbol_17) {\n                        if (CAUGHT_self_1 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\n                            throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)CAUGHT_self_1;\n                        }\n                        symbol_19 = (<%java.lang.Boolean%>)CAUGHT_self_1;\n                    }\n                    else {\n                        if (CAUGHT_symbol_15 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\n                            throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)CAUGHT_symbol_15;\n                        }\n                        final /*@Thrown\052/ boolean eq_6 = CAUGHT_symbol_15 == Boolean.FALSE;\n                        /*@Nullable\052/ /*@Thrown\052/ <%java.lang.Boolean%> symbol_18;\n                        if (eq_6) {\n                            symbol_18 = (<%java.lang.Boolean%>)<%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE;\n                        }\n                        else {\n                            if (CAUGHT_self_1 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\n                                throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)CAUGHT_self_1;\n                            }\n                            symbol_18 = (<%java.lang.Boolean%>)CAUGHT_self_1;\n                        }\n                        symbol_19 = symbol_18;\n                    }\n                    symbol_26 = symbol_19;\n                }\n                else {\n                    if (CAUGHT_self_1 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\n                        throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)CAUGHT_self_1;\n                    }\n                    final /*@Thrown\052/ boolean eq_7 = CAUGHT_self_1 == Boolean.FALSE;\n                    /*@Nullable\052/ /*@Thrown\052/ <%java.lang.Boolean%> symbol_25;\n                    if (eq_7) {\n                        symbol_25 = (<%java.lang.Boolean%>)<%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE;\n                    }\n                    else {\n                        if (CAUGHT_symbol_15 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\n                            throw (<%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>)CAUGHT_symbol_15;\n                        }\n                        final /*@NonInvalid\052/ boolean symbol_20 = CAUGHT_symbol_15 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>;\n                        /*@Nullable\052/ /*@Thrown\052/ <%java.lang.Boolean%> symbol_24;\n                        if (symbol_20) {\n                            symbol_24 = (<%java.lang.Boolean%>)CAUGHT_symbol_15;\n                        }\n                        else {\n                            final /*@Thrown\052/ boolean eq_8 = CAUGHT_symbol_15 == Boolean.FALSE;\n                            /*@Nullable\052/ /*@NonInvalid\052/ <%java.lang.Boolean%> symbol_23;\n                            if (eq_8) {\n                                symbol_23 = (<%java.lang.Boolean%>)<%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE;\n                            }\n                            else {\n                                final /*@Thrown\052/ boolean eq_9 = CAUGHT_self_1 == null;\n                                /*@Nullable\052/ /*@NonInvalid\052/ <%java.lang.Boolean%> symbol_22;\n                                if (eq_9) {\n                                    symbol_22 = null;\n                                }\n                                else {\n                                    final /*@Thrown\052/ boolean eq_10 = CAUGHT_symbol_15 == null;\n                                    /*@Nullable\052/ /*@NonInvalid\052/ <%java.lang.Boolean%> symbol_21;\n                                    if (eq_10) {\n                                        symbol_21 = null;\n                                    }\n                                    else {\n                                        symbol_21 = (<%java.lang.Boolean%>)<%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.TRUE_VALUE;\n                                    }\n                                    symbol_22 = symbol_21;\n                                }\n                                symbol_23 = symbol_22;\n                            }\n                            symbol_24 = symbol_23;\n                        }\n                        symbol_25 = symbol_24;\n                    }\n                    symbol_26 = symbol_25;\n                }\n                CAUGHT_symbol_26 = symbol_26;\n            }\n            catch (<%java.lang.Exception%> e) {\n                CAUGHT_symbol_26 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.createInvalidValue(e);\n            }\n            //\n            if (CAUGHT_symbol_26 == <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n                exists_0 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.TRUE_VALUE;\n                break;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately \n            }\n            else if (CAUGHT_symbol_26 == <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n                ;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n            }\n            else if (CAUGHT_symbol_26 == null) {\t\t\t\t\t\t\t\t// Abnormal null body evaluation result\n                if (accumulator_3 == <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE) {\n                    accumulator_3 = null;\t\t\t\t\t\t\t\t\t\t// Cache a null failure\n                }\n            }\n            else if (CAUGHT_symbol_26 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\t\t// Abnormal exception evaluation result\n                accumulator_3 = CAUGHT_symbol_26;\t\t\t\t\t\t\t\t\t// Cache an exception failure\n            }\n            else {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n                accumulator_3 = new <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>(<%org.eclipse.ocl.examples.domain.messages.EvaluatorMessages%>.NonBooleanBody, \"exists\");\n            }\n        }\n        CAUGHT_exists_0 = exists_0;\n    }\n    catch (<%java.lang.Exception%> e) {\n        CAUGHT_exists_0 = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.createInvalidValue(e);\n    }\n    //\n    if (CAUGHT_exists_0 == <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.TRUE_VALUE) {\t\t\t\t\t// Normal successful body evaluation result\n        exists = <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.TRUE_VALUE;\n        break;\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Stop immediately \n    }\n    else if (CAUGHT_exists_0 == <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE) {\t\t\t\t// Normal unsuccessful body evaluation result\n        ;\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Carry on\n    }\n    else if (CAUGHT_exists_0 == null) {\t\t\t\t\t\t\t\t// Abnormal null body evaluation result\n        if (accumulator == <%org.eclipse.ocl.examples.domain.values.util.ValuesUtil%>.FALSE_VALUE) {\n            accumulator = null;\t\t\t\t\t\t\t\t\t\t// Cache a null failure\n        }\n    }\n    else if (CAUGHT_exists_0 instanceof <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>) {\t\t// Abnormal exception evaluation result\n        accumulator = CAUGHT_exists_0;\t\t\t\t\t\t\t\t\t// Cache an exception failure\n    }\n    else {\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t// Impossible badly typed result\n        accumulator = new <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>(<%org.eclipse.ocl.examples.domain.messages.EvaluatorMessages%>.NonBooleanBody, \"exists\");\n    }\n}\nif (exists == null) {\n    throw new <%org.eclipse.ocl.examples.domain.values.impl.InvalidValueException%>(\"Null body for \\\'Concept::Route.signalNeighbor() : Boolean\\\'\");\n}\nreturn exists;'"
	 * @generated
	 */
	boolean signalNeighbor();

} // Route
